unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, GR32_Image, ExtCtrls, {G32_ProgressBar,} 

  { T e s t C o m p o n e n t ! ! ! }
  G32_PlotWindow, GR32_RangeBars, Buttons, Menus, ActnList, G32_Button;

type
  TForm1 = class(TForm)
    PaintBox321: TPaintBox32;
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    Button5: TButton;
    Button6: TButton;
    Label1: TLabel;
    Button7: TButton;
    ButtonLevels: TButton;
    Button3: TButton;
    Button4: TButton;
    LabeledEdit1: TLabeledEdit;
    PopupMenu1: TPopupMenu;
    fdsgh1: TMenuItem;
    sdfgsd1: TMenuItem;
    dsfg1: TMenuItem;
    PlotWindow321: TPlotWindow32;
    procedure Button1Click(Sender: TObject);

    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);

    procedure ButtonLevelsClick(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    { T e s t C o m p o n e n t ! ! ! }
    PlotWindow : TPlotWindow32;

     PlotWindow2 : TPlotWindow32;

    FFTPanel  : TPlotPanel;
    MSV_FFTPlot32 : TFFTPlot32;

     actionList : TPlotActionList;
  end;

var
  Form1: TForm1;

implementation

uses GR32, Math;

var
  DataArray : array of single;
  DataArraySize : integer;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
{ T e s t C o m p o n e n t ! ! ! }

  PlotWindow := TPlotWindow32.Create(Self);
  PlotWindow.Parent := Self;
  PlotWindow.Left := 1;
  PlotWindow.Top  := 200;
  // PlotWindow.Height  := 200;

  PlotWindow2 := TPlotWindow32.Create(Self);
  PlotWindow2.Parent := Self;
  PlotWindow2.Left := 1;
  PlotWindow2.Top  := 200;
  // PlotWindow.Height  := 200;


  FFTPanel := TPlotPanel.Create(Self);
  FFTPanel.Parent := Self;
  FFTPanel.Left := 405;
  FFTPanel.Top  := 200;
  FFTPanel.Height := 250;
  FFTPanel.Width := 450;

  MSV_FFTPlot32 := TFFTPlot32.Create(Self);
  MSV_FFTPlot32.Parent := Self;
  MSV_FFTPlot32.Left := 1;
  MSV_FFTPlot32.Top  := 1;
  MSV_FFTPlot32.LogScale := true;

  actionList := TPlotActionList.Create(Self);
  PlotWindow.ActionList := actionList;
  PlotWindow2.ActionList := actionList;  

 // MSV_FFTPlot32.Height  := 200;

 ButtonLevels.Click;
//Button1.s

 // Application.OnActionExecute = ExecActn;

end;

procedure TForm1.Button1Click(Sender: TObject);
const ClorAxis   = clGreen;
      LeftAxis   = 10;
      BottomAxis = 10;
      ClorData  = clRed;
      
   var i, x, y : integer;
begin
DataArraySize := 1024;
SetLength(DataArray, DataArraySize);
Randomize;
for i := 0 to DataArraySize-1 do
  begin
  DataArray[i] := (random(1024 * 64)) / (1024 * 32) * 2.5; // - 1024 * 32
  end;

for i := 2 to (DataArraySize div 4) - 1 do
  begin
  DataArray[i*4] := DataArray[i*4] + ((random(1024 * 64)) / (1024 * 32) * 12.5) / ln(i); // - 1024 * 32
  end;

PlotWindow.Data.SetAllParams(DataArraySize, 0, 1.0,dtFFT); // dtWave

for i := 0 to DataArraySize-1 do
  begin
   PlotWindow.Data.Point[i] := DataArray[i]
  end;

PlotWindow.Plot.ZoomOnePointToPixel;
PlotWindow.Plot.Invalidate;

  with PaintBox321 do begin
   with Buffer do begin
    with Canvas do begin
     //******** Clear Canvas **********************************//
     Brush.Color := clGray;//clBlack;
     Brush.Style := bsSolid;
     Pen.Color := clWhite;
     Rectangle(ClipRect);
     //******** Left Axis *************************************//
     Pen.Color := ClorAxis;
     MoveTo(LeftAxis, PaintBox321.Height - BottomAxis);
     LineTo(PaintBox321.Width, PaintBox321.Height - BottomAxis);
     //******** Bottom Axis ************************************//
     MoveTo(LeftAxis, PaintBox321.Height - BottomAxis);
     LineTo(LeftAxis, BottomAxis);
     //******** Grafics ****************************************//
     Pen.Color := ClorData;
     MoveTo(LeftAxis, PaintBox321.Height - BottomAxis);
     for i := 0 to DataArraySize-1 do
        begin
        x := LeftAxis + 1 + i;
        y := PaintBox321.Height - BottomAxis - Round(DataArray[i] * 10);
        LineTo(x,y);
       // MoveTo(x,y);
    end;
   end;
  Repaint;
  end;
  end;

end;


procedure TForm1.Button5Click(Sender: TObject);
begin
PlotWindow.Framed := not PlotWindow.Framed;
end;

procedure TForm1.Button6Click(Sender: TObject);
var temp : TPlotTypeLine;
begin
with PlotWindow do
 begin
  temp := PlotWindow.Plot.TypeLine;
  if temp = ptlAA then
    temp := ptlNone
   else Inc(temp);
  Plot.TypeLine := temp;

  if Plot.TypeLine = ptlNone   then Label1.Caption := ' '
  else if Plot.TypeLine = ptlAA then Label1.Caption := '';
  //else if Plot.TypeLine = ptlX then Label1.Caption := ' 2';
 end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.ButtonLevelsClick(Sender: TObject);
var i : integer;
begin
 MSV_FFTPlot32.LevelCount := 7;
 ButtonLevels.Caption:= 'Levels=' + IntToStr( MSV_FFTPlot32.LevelCount);
 MSV_FFTPlot32.MaxAmp := 100;

 MSV_FFTPlot32.Levels[0].max := random(100);
 MSV_FFTPlot32.Levels[0].position := random(100);
 MSV_FFTPlot32.Levels[0].fmin :=50;
 MSV_FFTPlot32.Levels[0].fmax :=150;
 for i := 1 to MSV_FFTPlot32.LevelCount-1 do
  begin
   //ShowMessage('fdlkg');
   MSV_FFTPlot32.Levels[i].max := random(100);
   MSV_FFTPlot32.Levels[i].position := random(100);
   MSV_FFTPlot32.Levels[i].fmin :=MSV_FFTPlot32.Levels[i-1].fmax;
   MSV_FFTPlot32.Levels[i].fmax :=MSV_FFTPlot32.Levels[i-1].fmax*2;
  end;
//MSV_FFTPlot32.Refresh
// MSV_FFTPlot32.
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
FFTPanel.PlotWindow := PlotWindow;
FFTPanel.Hold := True;
FFTPanel.BottomLine := blDblDot;
FFTPanel.Resize;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
FFTPanel.PlotWindow := PlotWindow;
FFTPanel.Hold := True;
end;

procedure TForm1.Button7Click(Sender: TObject);
var a : TDataType;
begin
if PlotWindow.Data.DataType = dtWave then a := dtFFT
 else a :=  dtWave;
PlotWindow.Data.SetAllParams(DataArraySize, 0, 1.0, a);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
MSV_FFTPlot32.LogScale := not MSV_FFTPlot32.LogScale;
end;

end.
