unit AffIm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,GR32, GR32_Image,GR32_Layers, StdCtrls,jpeg, ExtDlgs;

type
  TAffichIm = class(TForm)
    Image: TImgView32;
    Panel1: TPanel;
    Label1: TLabel;
    OK: TButton;
    Annule: TButton;
    Label2: TLabel;
    ScrolZoom: TScrollBar;
    Button1: TButton;
    SelTout: TButton;
    EnrImage: TButton;
    SaveDialog: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure AgrandirImage(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure ScrolZoomChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure EnrImageClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Delimiter:boolean;
    Cadre:TRubberbandLayer;
    ImageRetour:TBitmap32;
    HCadre,BCadre,GCadre,DCadre:integer;
    procedure ChangeCadre(Sender:Tobject);
  end;

var
  AffichIm: TAffichIm;

implementation

{$R *.DFM}
uses Donnees,math,PhylMain;

procedure TAffichIm.AgrandirImage(Sender: TObject);
begin
  //BoundsRect:=TImage(Sender).BoundsRect;
  //BigImage.Picture:=TImage(Sender).Picture;
  //Show;
end;

procedure TAffichIm.FormCreate(Sender: TObject);
//Var
 // RectLoc:TFloatRect;
begin
  Cadre:=TRubberbandLayer.Create(Image.Layers);
  Cadre.Scaled:=True;
  Cadre.OnUserChange:=ChangeCadre;
{  RectLoc.Top:=0;
  RectLoc.Bottom:=Image.Bitmap.Height-2;
  RectLoc.Left:=0;
  RectLoc.Right:=Image.Bitmap.Width-2;
  Cadre.Location:=RectLoc;}
  Cadre.Visible:=True;
  ImageRetour:=TBitmap32.Create;
end;
procedure MontreImage(longueur,largeur:integer;var NomFichier;Img:TBitmap);
Var
  RectLoc:TFloatRect;
begin
  RectLoc.Top:=0;
  RectLoc.Bottom:=Image.Bitmap.Height;
  RectLoc.Left:=0;
  RectLoc.Right:=Image.Bitmap.Width;
  Cadre.Location:=RectLoc;

procedure TAffichIm.ChangeCadre(Sender:Tobject);
Var
 G,D,H,B:single;
 Rectangl:TFloatRect;
begin
  G:=Cadre.Location.Left;
  D:=Cadre.Location.Right;
  H:=Cadre.Location.Top;
  B:=Cadre.Location.Bottom;
  If G<0 then G:=0;
  if G>(Image.Bitmap.Width-10)then G:=Image.Bitmap.Width-10;
  If D<(G+10) then D:=(G+10);
  if D>(Image.Bitmap.Width)then D:=Image.Bitmap.Width;
  If H<0 then H:=0;
  if H>(Image.Bitmap.Height-10)then H:=Image.Bitmap.Height-10;
  If B<(H+10) then B:=(H+10);
  if B>(Image.Bitmap.Height)then B:=Image.Bitmap.Height;
  Rectangl:=FloatRect(G,H,D,B);
  Cadre.Location:=Rectangl;
end;

procedure TAffichIm.OKClick(Sender: TObject);
Var
  Rectang:TRect;
  RectCop:TRect;
begin
  Rectang:=MakeRect(Cadre.Location);
  RectCop:=MakeRect(0,0,Rectang.Right-Rectang.Left,Rectang.Bottom-Rectang.Top);
  ImageRetour.SetSize(RectCop.Right,RectCop.Bottom);
  Image.Bitmap.DrawTo(ImageRetour,RectCop,Rectang);
  ModalResult:=mrOK;
end;

procedure TAffichIm.ScrolZoomChange(Sender: TObject);
begin
  Image.Scale:=ScrolZoom.Position/10;
end;

procedure TAffichIm.Button1Click(Sender: TObject);
begin
  Image.scale:=1;
end;

procedure TAffichIm.FormActivate(Sender: TObject);
Var
  RectLoc:TFloatRect;
  RectImgBig:TRect;
begin
  Image.OffsetHorz:=0;
  Image.OffsetVert:=0;
  RectImgBig:=Image.GetViewportRect;
  RectLoc.Top:=0;
  RectLoc.Bottom:=Min(Image.Bitmap.Height,RectImgBig.Bottom);
  RectLoc.Left:=0;
  RectLoc.Right:=Min(Image.Bitmap.Width,RectImgBig.Right);
  Cadre.Location:=RectLoc;
end;

procedure TAffichIm.EnrImageClick(Sender: TObject);
Var
  Rectang:TRect;
  RectCop:TRect;
  NomFichier,extension:string;
  image_temp_J:TBitmap;
  JPEGImage:TJPEGImage;
begin
  SaveDialog.FileName:='';
  SaveDialog.InitialDir:=GetMesDocuments;
  if SaveDialog.Execute then
    begin
      Rectang:=MakeRect(Cadre.Location);
      RectCop:=MakeRect(0,0,Rectang.Right-Rectang.Left,Rectang.Bottom-Rectang.Top);
      ImageRetour.SetSize(RectCop.Right,RectCop.Bottom);
      Image.Bitmap.DrawTo(ImageRetour,RectCop,Rectang);
      NomFichier:=SaveDialog.FileName;
      Extension:=UpperCase(ExtractFileExt(NomFichier));
      If Extension='.BMP' then ImageRetour.SaveToFile(NomFichier)
      else if Extension='.JPG' then
        begin
          image_temp_J:=TBitmap.Create;
          JPEGImage:=TJPEGImage.Create;
          With JPEGImage do
            begin
              try
                image_temp_J.Assign(ImageRetour);
                Assign(image_temp_J);
                SaveToFile(NomFichier);
              finally
                free;
                image_temp_J.Free;
              end;
            end;
        end;
    end
end;
end.
