unit ArbreDate;

interface

uses
  Windows, Messages, SysUtils, Classes,Controls,Gr32,Gr32_Layers,GR32_Image,Gr32_Polygons,graphics,
  StructureDonnees;
const
 crRoot = 1;
 crSwap = 2;                                  
 crPolytom = 3;
Var
  StrGroupeNonNomme:string;

type
  TArbreDate = class;
  TCurseursLayer = class;
  TAncetreLayer = class;
  TBranche= class(Tobject)
  public
    { Dclarations publiques }
    Proprietaire:TArbreDate;
    Nom:string;  //Nom du Taxon ou Anctre eventuellement des ... (Mammifres..)
    EtiqTaxon:String;//Nom  afficher Rien si anctre sinon nom du Taxon
    NomGroupe:string;
    NumeroGroupe:integer; //si l'espace manque pour le numro complet
    PositionNumero:TRect;
    PositionEtiqGroupe:TRect;
    AncetreDirect:TBranche;
    Descendants:Array of TBranche;
    PremierDescendant:TBranche; //descendant final (Taxon) le plus  gauche dans l'arbre Clade
    DernierDescendant:TBranche; //descendant final (Taxon) le plus  droite dans l'arbre Clade
    Ancetre:TAncetreLayer; //Nil si c'est un taxon terminal
    Curseurs:TCurseursLayer; //Nil si c'est un noeud (anctre)
    AgeApp:integer; // ge d'apparition de l'espce en milliers d'annes;
    AgeDisp:integer; // ge de disparition de l'espce en milliers d'annes;
    PosAgeApp:integer; // Position actuelle de l'ge d'apparition sur le graphique en milliers d'annes;
    PosAgeDisp:integer; // Position actuelle de l'ge de disparition sur le graphique en milliers d'annes;
    AgeMin:integer; //ge le plus faible possible en fonction des taxons descendants connus
    //AgeMax:integer; //ge min de l'anctre direct
    NbTotTaxons:integer;
    Largeur:integer;
    Hauteur:integer;
    Niveau:integer;
    CouleurTrait:TColor32;
    Grise:Boolean;
    CouleurTaxon:TColor32;
    CouleurBoite:TColor32;
    CouleurSurBoite:TColor32;
    LargeurTexte:integer;
    HauteurLigne:integer;
    X,Y:integer;
    XCible,YCible:integer;
    YBranche:integer;
    XTaxon,YTaxon:integer;
    PlaceParDefaut:Boolean;
    CaracteresDExcl:TStringList;
    EtatsDExcl:TStringList;
    Portrait:TListeAttributs;
    EstUnGroupeMonoPhyl:Boolean;
    RacineFictive:Boolean;
    TracerBoite:Boolean;  //est-ce ncessaire ? (voir EstUnGroupeMonophyletique)
    EspBG,EspBD:integer;
    EspBGCalcule,EspBDCalcule:boolean;
    EspaceMaxEtiqTax:integer;
    Constructor CreateBranche(LeProprietaire:TArbreDate);
    Constructor CreateTaxon(LeProprietaire:TArbreDate);
    function Structure:String;
    function StructAvecGroupe:String;
    function EstIssueDe(LAncetre:TBranche):Boolean;
    procedure SupprimeDescendants;
    procedure Supprime;
    Destructor Destroy; override;
    Function NombreTaxonsDescendants:integer;
    Function NombreNiveaux:integer;
    Function EstUnTaxon:boolean;
    Function EstDescendantDe(UneRacine:TBranche):Boolean;
    Procedure RepertorieBranches;
    Function CherchePremierDescendant:TBranche;
    Function ChercheDernierDescendant:TBranche;
    Procedure FixeCouleurAncetresDescendants(Couleur:TColor32);
    Procedure RazCouleurAncetresDescendants;
    Procedure FixeCouleurBranchesDescendants(Couleur:TColor32;AGriser:Boolean);
    Procedure RazCouleurBranchesDescendants;
    //Procedure TaxonsDescendants(var ListeTaxons:TStringList);
    Function TaxonsDescendants:string;
    procedure SetCouleurAncetre(Couleur:TColor32);
    function GetCouleurAncetre:TColor32;
    Property CouleurAncetre:TColor32 read GetCouleurAncetre write SetCouleurAncetre;
    Function CalcEspG:integer;  // pour le dessin des botes
    Function CalcEspD:integer;
    Function CalculeLongueurCar(NomCar:string):integer;
    Function CalculeEspaceMaxEtiqTax(UnBitMap:TBitmap32):integer;
    Function BoiteQuiInclutUneAutre:Boolean;
    procedure InverseDescendants;
    procedure ChangePortrait(NomCar,Etat:string;NumEtat,Statut:integer);
  end;
  TCurseursLayer = class(TPositionedLayer)
  public
    { Dclarations publiques }
    Couleur:TColor32;
    Largeur:integer;
    Hauteur:integer;
    //Support:TRubberbandLayer;
    DeuxCurseurs:Boolean;
    CurseurD:integer;//0: les deux, 1: Gauche, 2 : droite;
    Proprietaire:TArbreDate;
    Branche:TBranche;
    LargeurTexte:integer;
    HauteurTexte:integer;
    EstFossile:Boolean;
    EstExterne:Boolean;
    Constructor CreateLayer(LeProprietaire:TArbreDate;LaBranche:TBranche);
    Procedure Positionne(X,Y:integer);
  end;
  TAncetreLayer = class(TPositionedLayer)
  public
    Couleur:TColor32;
    Rayon:integer;
    //Support:TRubberbandLayer;
    Proprietaire:TArbreDate;
    Branche:TBranche;
    DateMaxi:integer;
    NomGroupe:string;
    Constructor CreateLayer(LeProprietaire:TArbreDate;LaBranche:TBranche);
    Procedure Positionne(X,Y:integer);
  end;
  TGroupeDeBranches=Array of TBranche;
  TTypeItemStrati=(Eon,Ere,Periode,Epoque,Etage);
  TItemCrise=record
    Nom:string[40];
    Age:integer; //en milliers d'annes
    PCF:integer;   //% de familles
    PCG:integer;   //% de genres
    PCE:integer;    //% d'espces
  end;
  TItemStrati=record
    TypeItem:TTypeItemStrati;
    Nom:string[20];
    AgeFin:integer; //en milliers d'annes
    AgeDebut:integer;
    Couleur:TColor32;
  end;
  TArbreDate = class(TImage32)
  private
    FRacines:TGroupeDeBranches;
  public
    Nom:string;//Nom de l'arbre
    Branches:Array of TBranche;
    EchelleStrati:Array of TItemStrati;
    Crises:Array of TItemCrise;
    DessinProv:TBitmapLayer;

    NumeroAncetre:integer;
    TypeDArbre:integer;  //0:Arbre Date   1:Arbre Clade
    SimpleDiagramme:Boolean;//pour la partie Organiser
    CouleurFossile:TColor32;
    CouleurExterne:TColor32;
    CouleurCrises:TColor32;
    MiniAge:integer; //ge du dbut de l'chelle en milliers d'annes;
    MaxiAge:integer; //ge de fin de l'chelle en milliers d'annes;
    PosXMiniAge:integer; //ge du dbut de l'chelle en milliers d'annes;
    PosXMaxiAge:integer; //ge de fin de l'chelle en milliers d'annes;
    CoeffPosXToAge,CoeffAgeToPosX:real;
    MargeH:integer;
    EcartTaxons:integer;
    MargeHMini:integer;
    MargeHMax:integer;
    MargeV:integer;
    MargeVMini:integer;
    MargeVMax:integer;
    MargeG:integer;
    SupXBoiteD,SupYBoite,SupXBoiteG:integer; //Espace supplmentaires  G  D et en haut pour l'affichage des botes
    SupYNiv:Array of integer;
    SupIntBoites:integer;// total des espaces supplmentaire entre les taxons pour l'affichage des botes
    EspBoites:integer; // espace entre 2 boites
    LargeurEtiqTaxons:integer;
    LargeurGraphe:integer;
    HauteurGraphe:integer;
    LongueurRacine:integer;
    EpaisseurBranche:integer;
    YAxetemps,HauteurAxeTemps:integer;
    YEchelleStrati,HauteurEchelleStrati:integer;
    HauteurItemsEchelleStrati:integer;
    YItemsEchelleStrati:Array [TTypeItemStrati] of integer;
    YCurseur:integer;  //niveau max du curseur de dplacement de taxon
    YTaxons:integer;
    YLegende:integer;
    HauteurTaxon:integer;
    HauteurTexte:integer;
    NombreTaxons:integer;
    NombreTaxonsLibres:integer;
    NombreNiveaux:integer;
    DeltaPosX:integer;
    EcartAge:integer;
    LargeurBranche:integer;
    Marge:integer;
    CurseurAgeMax:TPositionedLayer;
    CurseurAgeMin:TPositionedLayer;
    AncetreDeplace:TAncetreLayer;
    BrancheCliquee:TBranche;
    NoeudClique:Boolean;
    CurseursDeplaces:TCurseursLayer;
    X0Souris:integer;
    Y0Souris:integer;
    EchelleMa:boolean;  //true si chelle en millions d'annes, false si chelle en annes
    PrecisionDate:integer; //nombre de chiffres aprs la virgule
    EffacerCurseursDeplaces:Boolean;
    Attente:Boolean;
    TexteInfo:string; //Texte qu'il faut aller chercher si AjusterInfo est dclench
    AjusterInfo:TNotifyEvent;
    UneBrancheEstCliquee:TNotifyEvent;
    ArbreModifie:TNotifyEvent;
    UnGroupeEstANommer:TNotifyEvent;
    EstModifiable:Boolean;
    ModeInversion:Boolean;
    DessinerBoites:Boolean;
    AfficherNomsGroupes:Boolean;
    BoitesSansTaxons:boolean;
    BranchesCreuses:Boolean;
    AfficherStrati:Boolean;
    AfficherCatStrati:Array [TTypeItemStrati]of Boolean;
    AfficherCrises:Boolean;
    CouleurAncetre:TColor32;
    CouleurErreur:TColor32;
    CouleurBranche:TColor32;
    CouleurCurseur:TColor32;
    CouleurTraitRacine:TColor32;
    CouleurBoiteDefaut:TColor32;
    LargeurDisponible:integer;
    HauteurDisponible:integer;
    coeffY:single;//coeff multiplicateur pour rduire la hauteur;
    ListeCaracteres:TStringList;
    ListeCompleteTaxons:TStringList;

    ListeCaracteresARechercher:TStringList;
    LaSousCollection:TSousCollection;
    LeNouvCaractere:TCaractD;
    //CrAjout:TCursor;
    MonRemplissage:TBitmapPolygonFiller;
    MonPointille:TBitmap32;
    NumeroGroupe:integer;
    StructurePrecedente:TStringList;
    SansAncetre:Boolean;
    MethodeParci:integer;
                  // MethodeParci 0: m. de Wagner (rversions et convergences acceptes)
              //         1: m. de Camin Sokal (convergences seules acceptes)  faire
              //         2: m. de Dollo (rversions seules acceptes)   faire

    //Procedure ChercheNombreTaxons;
    procedure ConstruitListeTaxons;
    Procedure ChercheNombreNiveaux;
    Procedure Construit(BrancheParente:TBranche;ChaineStruct:string;TypeStruct:integer;limG,limD:string);
    // TypeStruct=0 : structure d'arbre la plus simple avec seulement les noms.
    // TypeStruct=1 : chaine de structure des nouvelles botes.
    // TypeStruct=2 : chaine de structure simple mais avec les noms de groupe.
    Procedure NvBrancheDApresStructAPG(BrancheParente:TBranche;ChaineStruct:string;limG,limD:string);
    Procedure NvBrancheDApresStructArbre(BrancheParente:TBranche;ChaineStruct:string;limG,limD:string);
    Procedure NvBrancheDApresStructBoite(BrancheParente:TBranche;ChaineStruct:string;limG,limD:string);
    Function ConstruitBase(NomsTaxons:TStringList):TBranche; // construit une racine sur laquelle sont directement branchs les Taxons
                                                             // renvoie la rfrence de la racine
    Function AjouteTaxon(NomTaxon:string;BrancheSupport:TBranche):TBranche;
                                         // renvoie la rfrence de la branche cre
    Procedure FixeBrancheSurLeNoeud(NoeudSupport,BrancheAFixer:TBranche);
    Procedure FixeBrancheSurLaBranche(BrancheSupport,BrancheAFixer:TBranche);
    Procedure FixeNoeudSurLaBranche(BrancheSupport,NoeudAFixer:TBranche);
    Procedure FixeNoeudSurLeNoeud(NoeudSupport,NoeudAFixer:TBranche);
    Procedure RetireBrancheDuNoeud(BrancheARetirer,AncienNoeud:TBranche);
    Procedure SupprimeBranche(LaBrancheS:TBranche);
    //Procedure AjusteParentes(BrancheParente:TBranche;ChaineStruct:string;TypeStruct:integer;limG,limD:string);
    Constructor Create(AOwner: TComponent);override;
    Destructor Destroy; override;
    Function AgeToPosX(LAge:integer):integer;
    Function PosXToAge(LaPosX:integer):integer;
    Procedure ReclasseBranches;
    Procedure ConstruitPortraits(Methode:integer);
                  // Methode 0: m. de Wagner (rversions et convergences acceptes)
              //         1: m. de Camin Sokal (convergences seules acceptes)  faire
              //         2: m. de Dollo (rversions seules acceptes)   faire

    Procedure ConstruitPortraitsWagner; //verif ncessaire ?
    Procedure ConstruitPortraitsCaminSokal; //pas de rversion : tat anctre= tat le moins volu
    Procedure ConstruitPortraitsDollo; //pas de convergence : tat ancetre= tat volu si un des descendants possde cet tat de manire non exclusive
    Procedure ConstruitPortraitTaxon(UneBranche:TBranche);
    Procedure ConstruitPortraitWagner(UneBranche:TBranche);
    Procedure ConstruitAttributWagner(UneBranche:TBranche;NomCar:string);
    Procedure ConstruitPortraitCaminSokal(UneBranche:TBranche);
    Procedure ConstruitAttributCaminSokal(UneBranche:TBranche;NomCar:string);
    Procedure CalculeTailleArbreDate(LeBitMap:TBitMap32);
    Procedure CalculeEspVertArbreDate(LeBitMap:TBitMap32);
    Procedure DessineArbreDateSur(LeBitMap:TBitmap32);
    Procedure DessineEchelleStrati(LeBitmap:TBitmap32);
    Procedure DessineLegendeArbreDate(LeBitmap:TBitmap32);
    Procedure CalculeTailleArbreClade(LeBitMap:TBitMap32);
    Procedure DessineArbreCladeSur(LeBitMap:TBitmap32);
    Procedure TraceBrancheCladeSur(LeBitMap:TBitmap32;CouleurHaut,CouleurBas:TColor32;HautGrise,BasGrise:Boolean;LePointHG,LePointHD,LePointMG,LePointMD,LePointBG,LePointBD:TFixedPoint);
    Procedure DessineBoiteClade(BaseHautBoite,n:integer;LaBranche:TBranche;LeBitMap:TBitmap32);
    Procedure DessineBoiteDate(n:integer;LaBranche:TBranche;LeBitMap:TBitmap32);
    procedure SupprimeLayer(LeLayer:TPositionedLayer);
    procedure Redessine;
    Function LabrancheDuTaxon(NomTaxon:string):TBranche;
    Function LAncetreDesTaxons(NomsTaxons:string):TBranche;

    Procedure PaintCurseursTaxon(Sender: TObject; Buffer: TBitmap32);
    Procedure PaintAncetre(Sender: TObject; Buffer: TBitmap32);

    procedure MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer); override;
    procedure ArbreDateMouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure ArbreCladeMouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure MouseMove (Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer); override;
    procedure MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer); override;
    procedure ArbreDateMouseMove (Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure ArbreDateMouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure ArbreCladeMouseMove (Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure ArbreCladeMouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    Function StructArbre:String;
    Function StructAvecGroupe:String;
    function TranscritAge(age:integer;moins,AjouterUnite:boolean;le:string):String;
    Procedure ToutEffacer;
    Function Verifier(Var NbBP:integer):string;
    Procedure ToutDisposer;
    Procedure MarqueCommeFossile(Nomtaxon:string);
    Procedure MarqueCommeExterne(Nomtaxon:string);
    Procedure RazFossiles;
    Procedure RazExternes;
    Procedure RazCouleurBoites;
    Procedure RAZCouleurs;
    Procedure RazCouleurSurBoites;
    Procedure RazCouleurAncetres;
    procedure RazCouleurBranches;
    Procedure RazCouleursCurseurs;
    procedure RazNomGroupe;
    procedure RazEspB;
    procedure RAZPremDerDesc;
    Function BrancheAPosition(X,Y:integer;Var SurLeNoeud:Boolean):TBranche;
    Function GetRacines:TGroupeDeBranches;
    Function ChargeFichierStrati(NomFichier:string):Boolean;
    Function TrouveCrise(X,Y:integer;AfficherInfo:Boolean;Var LaCrise:TItemCrise):Boolean;
    Function TrouveNomStrati(X,Y:integer;AfficherInfo:Boolean;Var UnItemStrati:TItemStrati):Boolean;
    Function AncPlusVieuxPrem(UneBranche:TBranche):TBranche; //Recherche le plus viel ancetre dont elle est la premire branche descendante
    Function AncPlusVieuxDern(UneBranche:TBranche):TBranche; //Recherche le plus viel ancetre dont elle est la dernire branche descendante
    Function CalculeLongueurTot(NomCar:string;Var LongCar:integer):integer;
    Function CalculeLongueurCar(NomCar:string):integer;
    Property Racines:TGroupeDeBranches read GetRacines;
    procedure ColoreSuivantEtats(Nomcar:string;ListeCouleurs: Array of TColor);
    procedure ColoreBoitesParDefaut;
    Function NomDeNumeroGroupe(X,Y:integer):String;
    Function AncetreDuGroupeANommer(X,Y:integer):TBranche;
    Function RegroupeTout:TBranche;
    Procedure AjouteAncetreArbreDateBrancheTermGroupe;
    procedure VerifieMonoPhyletisme(Tout:Boolean);
    procedure VerifieAncetreRacine;
    function RazParentes(ListeTax:TStringList):Boolean;
    procedure VerifiePosAges;
    //Function ExisteAncetreNomCar:string):integer;
    //Function NumBranche(LaBranche:TBranche):integer;
    //procedure MouseMove (Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer); override;
    //Function ExisteTaxon(NomTaxon:string):integer;

    //Procedure RetireBranche(NomTaxon:string);
    //Procedure RetireBrancheContenant(Nomcar:string);
//    Procedure PositionneBranches;

  published
    { Dclarations publies }
  end;
function ExtraitChaineJusquaLimDSim(ChaineStruct:string;limG,limD:string;var posuiv:integer):string;
procedure TraceCercleSur(Bitmap:TBitMap32;Xcentre,YCentre,rayon:integer;Couleur,CouleurContour:TColor32);

procedure Register;

implementation
uses Math,Dialogs,Forms;

//***** TBranche *****
Constructor TBranche.CreateBranche(LeProprietaire:TArbreDate);
begin
  Create;
  Proprietaire:=LeProprietaire;
  Ancetre:=TAncetreLayer.CreateLayer(LeProprietaire,Self);
  Curseurs:=Nil; //Nil si c'est un noeud (anctre)
  CouleurTrait:=LeProprietaire.CouleurBranche;
  Grise:=False;
  CouleurTaxon:=ClBlack32;// couleur d'criture de l'tiquette du taxon
  Hauteur:=0;
  Largeur:=0;
  PosAgeApp:=-1; // valeur ngative signalant que le rglage n'est pas fait
  PosAgeDisp:=-1; // valeur ngative signalant que le rglage n'est pas fait
  AgeMin:=0; //ge le plus faible possible en fonction des taxons descendants connus
  PlaceParDefaut:=True;
  Ancetre.Cursor:=CrSizeWE;
  Ancetre.Branche:=Self;
  TracerBoite:=True;
  RacineFictive:=False;
  Ancetre.OnPaint:=Proprietaire.PaintAncetre;
  Nom:='Anctre';
  EtiqTaxon:='';//Nom  afficher Rien si anctre
  NomGroupe:='';
  NumeroGroupe:=-1;
  AncetreDirect:=Nil;
  CaracteresDExcl:=TStringList.Create;
  EtatsDExcl:=TStringList.Create;
  //PortraitRobotCar:=TStringList.Create;
  //PortraitRobotEtats:=TStringList.Create;
  Portrait:=TListeAttributs.Create;
  EstUnGroupeMonoPhyl:=False;
  CouleurBoite:=clRed32;
  CouleurSurBoite:=0;
  EspBD:=0;
  EspBG:=0;
  EspBGCalcule:=False;
  EspBDCalcule:=False;

  //SetLength(Descendants,0);
end;
Constructor TBranche.CreateTaxon(LeProprietaire:TArbreDate);
begin
  Create;
  Proprietaire:=LeProprietaire;
  Ancetre:=Nil; //Nil si c'est un taxon terminal
  Curseurs:=TCurseursLayer.CreateLayer(LeProprietaire,Self);
  AgeApp:=0;
  AgeDisp:=0;  //provisoirement
  PosAgeDisp:=0;
  PosAgeApp:=0;
  CouleurTrait:=clBlack32;
  Grise:=False;
  CouleurBoite:=Proprietaire.CouleurBoiteDefaut;
  CouleurSurBoite:=0;
  Hauteur:=0;
  Largeur:=0;
  Curseurs.Branche:=Self;
  Curseurs.OnPaint:=Proprietaire.PaintCurseursTaxon;
  Curseurs.HauteurTexte:=LeProprietaire.HauteurTexte;  // Bitmap.TextHeight('T');
  CaracteresDExcl:=TStringList.Create;
  EtatsDExcl:=TStringList.Create;
  Portrait:=TListeAttributs.Create;
  TracerBoite:=False;
  Nom:='Taxon';
  EtiqTaxon:='Taxon';//Nom  afficher Rien si anctre
  NomGroupe:='';
  NumeroGroupe:=-1;
  AncetreDirect:=Nil;
  SetLength(Descendants,0);
end;
procedure TBranche.SupprimeDescendants;
Var
  i:integer;
begin
  For i:=0 to Length(Descendants)-1 do
    Descendants[i].SupprimeDescendants;
  Destroy;
end;
procedure TBranche.Supprime;
begin
  Destroy;
end;

Destructor TBranche.Destroy;
begin
  //supprimer les Layers associs
  if Ancetre<>Nil then
    Proprietaire.SupprimeLayer(Ancetre);
  if Curseurs<>Nil then
    Proprietaire.SupprimeLayer(Curseurs);
  inherited Destroy;
end;
function TBranche.EstIssueDe(LAncetre:TBranche):Boolean;
begin
  If AncetreDirect=Nil then Result:=False
  else If AncetreDirect=LAncetre then Result:=True
  else Result:=AncetreDirect.EstIssueDe(LAncetre);
end;
Function TBranche.BoiteQuiInclutUneAutre:Boolean;
Var
  i:integer;
begin
  Result:=False;
  for i:=0 to Length(Descendants)-1 do
    begin
      if (Descendants[i]<>Nil) and Descendants[i].EstUnGroupeMonoPhyl then
        begin
          Result:=True;
          Break;
        end;
    end;
end;
Function TBranche.CalculeLongueurCar(NomCar:string):integer;
Var
  i:integer;
begin
  Result:=0;
  if AncetreDirect=Nil then
    begin
      if (Portrait.NumeroEtat(NomCar)>0) and (Portrait.Statut(NomCar)>1) then
        inc(Result);
    end
  else
    begin
      if ((Portrait.NumeroEtat(NomCar)=0) or (Portrait.Statut(NomCar)>1)) and
        (Portrait.NumeroEtat(NomCar)<>AncetreDirect.Portrait.NumeroEtat(NomCar)) then
          Result:=1;
    end;
  for i:=0 to Length(Descendants)-1 do
    Result:=Result+Descendants[i].CalculeLongueurCar(NomCar);
end;
Function TBranche.NombreTaxonsDescendants:integer;
Var
  i:integer;
begin
  if Length(Descendants)=0 then
    NbTotTaxons:=1// Length(Descendants)
  else
    NbTotTaxons:=0;
  For i:=0 to Length(Descendants)-1 do
    begin
      NbTotTaxons:=NbTotTaxons+Descendants[i].NombreTaxonsDescendants;
    end;
  Result:=NbTotTaxons;
end;
Function TBranche.NombreNiveaux:integer;
Var
  i,n,p:integer;
Begin
  Niveau:=0;
  p:=Length(Descendants);  //Self.
  For i:=0 to p-1 do
    begin
      if (Descendants[i]<>Nil) and (Descendants[i].Ancetre<>Nil) then
        begin
          n:=Descendants[i].NombreNiveaux;
          if n>Niveau then
            Niveau:=n;
        end;
    end;
  if Length(Descendants)>0 then inc(Niveau);
  Result:=Niveau;
end;
Function TBranche.EstDescendantDe(UneRacine:TBranche):Boolean;
begin
  Result:=False;
  if AncetreDirect=Nil then
    exit
  else if AncetreDirect=UneRacine then
    Result:=True
  else
    Result:=AncetreDirect.EstDescendantDe(UneRacine);
end;
Function TBranche.EstUnTaxon:boolean;
begin
  Result:=(Curseurs<>Nil);
end;
Procedure TBranche.RepertorieBranches;
Var
  i,n:integer;
Begin
  if Length(Descendants)>0 then
    begin
      if Proprietaire.NumeroAncetre=0 then
        Nom:='Anctre Racine'
      else Nom:='Anctre '+ IntToStr(Proprietaire.NumeroAncetre);
      inc(Proprietaire.NumeroAncetre);
    end;
  For i:=0 to Length(Descendants)-1 do
    if Descendants[i]<>Nil then
      begin
        n:=Length(Proprietaire.Branches);
        SetLength(Proprietaire.Branches,n+1);
        Proprietaire.Branches[n]:=Descendants[i];
        Descendants[i].RepertorieBranches;
      end;
end;
Function TBranche.CherchePremierDescendant:TBranche;
begin
  if PremierDescendant=Nil then
    begin
      If Length(Descendants)=0 then
        PremierDescendant:=Self
      else
        PremierDescendant:=Descendants[0].CherchePremierDescendant;
    end;
  Result:=PremierDescendant;
end;
Function TBranche.ChercheDernierDescendant:TBranche;
begin
  if DernierDescendant=Nil then
    begin
      If Length(Descendants)=0 then
        DernierDescendant:=Self
      else
        DernierDescendant:=Descendants[Length(Descendants)-1].ChercheDernierDescendant;
    end;
  Result:=DernierDescendant;
end;

Procedure TBranche.FixeCouleurAncetresDescendants(Couleur:TColor32);
Var
  i:integer;
begin
  if Ancetre<>nil then
    begin
     if EstUnGroupeMonoPhyl then
       Ancetre.Couleur:=Couleur
     else
       Ancetre.Couleur:=Proprietaire.CouleurErreur;
     For i:=0 to Length(Descendants)-1 do
        Descendants[i].FixeCouleurAncetresDescendants(Couleur);
    end;
end;
Procedure TBranche.RazCouleurAncetresDescendants;
begin
  if Ancetre<>nil then
     FixeCouleurAncetresDescendants(Proprietaire.CouleurAncetre);
end;
Procedure TBranche.FixeCouleurBranchesDescendants(Couleur:TColor32;AGriser:Boolean);
Var
  i:integer;
begin
  CouleurTrait:=Couleur;
  Grise:=AGriser;
  For i:=0 to Length(Descendants)-1 do
      Descendants[i].FixeCouleurBranchesDescendants(Couleur,AGriser);
end;
Procedure TBranche.RazCouleurBranchesDescendants;
begin
  FixeCouleurBranchesDescendants(Proprietaire.CouleurBranche,False);
end;

procedure TBranche.SetCouleurAncetre(Couleur:TColor32);
begin
  if Ancetre<>nil then Ancetre.Couleur:=Couleur;
end;
function TBranche.GetCouleurAncetre:TColor32;
begin
  if Ancetre<>nil then Result:=Ancetre.Couleur
  else Result:=0;
end;
Function TBranche.TaxonsDescendants:string;
Var
  i:integer;
  NomTaxon:string;
begin
  Result:='';
  if Length(Descendants)=0 then
    begin
      NomTaxon:=Nom;
        if pos(' ',NomTaxon)>0 then
          NomTaxon:='"'+NomTaxon+'"';
      Result:=NomTaxon;
    end;
  For i:=0 to Length(Descendants)-1 do
    begin
      if Descendants[i].EstUnTaxon then
        begin
          NomTaxon:=Descendants[i].Nom;
          if pos(' ',NomTaxon)>0 then
            NomTaxon:='"'+NomTaxon+'"';
          if Result='' then
            Result:=NomTaxon
          else
            Result:=Result+','+NomTaxon;
        end
      else
        begin
          if Result='' then
            Result:=Descendants[i].TaxonsDescendants
          else
            Result:=Result+','+Descendants[i].TaxonsDescendants;
        end;
    end;
end;
Function TBranche.CalculeEspaceMaxEtiqTax(UnBitMap:TBitmap32):integer;
Var
  i,p:integer;
  texte:string;
begin
  Result:=0;
  Texte:='';
  if Length(Descendants)=0 then
    begin
      if Proprietaire.BoitesSansTaxons then
        begin
          If CaracteresDExcl.Count>0 then
            Texte:=NomGroupe
          else if (AncetreDirect<>nil)and AncetreDirect.TracerBoite then
            Texte:=AncetreDirect.NomGroupe
          else
            begin
              result:=0;
              EspaceMaxEtiqTax:=Result;
              exit;
            end;
          if Texte='' then
            Texte:=StrGroupeNonNomme;
        end
      else
        Texte:=EtiqTaxon;
      p:=Pos('=',Texte);
      if p>0 then
        begin
          if p<(length(Texte) div 2) then
            Delete(Texte,p,Length(Texte)-p+1)
          else
            Delete(Texte,1,p);
        end;
      Result:=UnBitmap.TextWidth(Texte);
    end
  else
    begin
      For i:=0 to Length(Descendants)-1 do
        begin
          Result:=Max(Result,Descendants[i].CalculeEspaceMaxEtiqTax(UnBitMap));
        end;
    end;
  EspaceMaxEtiqTax:=Result;
end;

Function TBranche.CalcEspG:integer;
begin
  if EspBGCalcule then
    begin
      Result:=EspBG;
      exit;
    end;
  if (Length(Descendants)=0) then
    begin
      if (CaracteresDExcl.Count>0)or TracerBoite then
        begin
          if (Proprietaire.TypeDArbre=0) then
            Result:=0
          else
            Result:=(Proprietaire.HauteurTexte div 2)+Proprietaire.EspBoites;
        end
      else
        Result:=0;
    end
  else
    begin
      if Descendants[0].EstUnTaxon then
        begin
          if RacineFictive then Result:=0
          else if Descendants[0].TracerBoite then
            begin
              if (Proprietaire.TypeDArbre>0) then
                Result:=(Proprietaire.HauteurTexte div 2)+Proprietaire.EspBoites*2 //Proprietaire.EspBoites*3
              else
                begin
                  Result:=Proprietaire.EspBoites;
                  if Proprietaire.DessinerBoites and Proprietaire.AfficherNomsGroupes then
                    Result:=Result+Proprietaire.HauteurTexte+4;
                end;
            end
          else
            begin
              Result:=Proprietaire.EspBoites;
              if (Proprietaire.TypeDArbre=0) and Proprietaire.AfficherNomsGroupes then
                Result:=Result+Proprietaire.HauteurTexte+4;
            end;
        end
      else
        begin
          if RacineFictive then Result:=Descendants[0].CalcEspG
          else
            begin
              Result:=Proprietaire.EspBoites+Descendants[0].CalcEspG;
              if (Proprietaire.TypeDArbre=0)and Proprietaire.AfficherNomsGroupes then
                Result:=Result+Proprietaire.HauteurTexte+4;
            end;
        end
    end;
  EspBG:=Result;
  EspBGCalcule:=True;
end;
Function TBranche.CalcEspD:integer;
Var
  n:integer;
begin
  if EspBDCalcule then
    begin
      Result:=EspBD;
      exit;
    end;
  n:=Length(Descendants)-1;
  if (n<0) then
    begin
      if CaracteresDExcl.Count>0 then
        Result:=(Proprietaire.HauteurTexte div 2)+Proprietaire.EspBoites //Proprietaire.EspBoites*2
      else
        Result:=0;
    end
  else
    begin
      if Descendants[n].EstUnTaxon then
        begin
          if RacineFictive then Result:=0
          else if Descendants[n].TracerBoite then
            Result:=(Proprietaire.HauteurTexte div 2)+Proprietaire.EspBoites*2 //Proprietaire.EspBoites*3
          else
            Result:=Proprietaire.EspBoites;
        end
      else
        begin
          if RacineFictive then Result:=Descendants[n].CalcEspD
          else Result:=Proprietaire.EspBoites+Descendants[n].CalcEspD;
        end
    end;
  EspBD:=Result;
  EspBDCalcule:=True;
end;
function TBranche.StructAvecGroupe:String;
Var
  i:integer;
begin
  Result:='';
  if Length(Descendants)=0 then
    Result:='<'+'$'+NomGroupe+'$'+Nom+'>'
  else
    begin
      Result:='<'+'$'+NomGroupe+'$';    //+Nom
      For i:=0 to Length(Descendants)-1 do
        Result:=Result+Descendants[i].StructAvecGroupe;
      Result:=Result+'>';
    end;
end;

function TBranche.Structure:String;
Var
  i:integer;
begin
  Result:='';
  if Length(Descendants)=0 then
    Result:='<'+Nom+'>'
  else
    begin
      Result:='<';    //+Nom
      For i:=0 to Length(Descendants)-1 do
        Result:=Result+Descendants[i].Structure;
      Result:=Result+'>';
    end;
end;
procedure TBranche.InverseDescendants;
Var
  i,n:integer;
  UneBranche:TBranche;
begin
  n:=Length(Descendants);
  For i:=0 to (n div 2)-1 do
    begin
      UneBranche:=Descendants[i];
      Descendants[i]:=Descendants[n-i-1];
      Descendants[n-i-1]:=UneBranche;
    end;
  Proprietaire.ReclasseBranches;
end;
procedure TBranche.ChangePortrait(NomCar,Etat:string;NumEtat,Statut:integer);
begin
  Portrait.ModifieOuAjoute(NomCar,Etat,NumEtat,Statut);
end;

//***** TCurseursLayer ******

Constructor TCurseursLayer.CreateLayer(LeProprietaire:TArbreDate;LaBranche:TBranche);
begin
  inherited Create(LeProprietaire.Layers);
  Proprietaire:=LeProprietaire;
  Branche:=LaBranche;
  Scaled:=True;
  Largeur:=0;
  Hauteur:=5;
  EstExterne:=False;
  EstFossile:=False;
  Couleur:=LeProprietaire.CouleurCurseur;
  Cursor:=CrSizeWE;
end;
Procedure TCurseursLayer.Positionne(X,Y:integer);//Y : position du trait horizontal, X position de la droite
Var
  Position:TFloatRect;
begin
  if Branche.Proprietaire.TypeDArbre=0 then
    begin
      Position.Top:=Y-HauteurTexte div 2;
      Position.Bottom:=Position.Top+HauteurTexte;
      Position.Left:=X-Largeur;
      Position.Right:=X+LargeurTexte;
    end
  else
    begin
      Position.Left:=X-HauteurTexte div 2;//Y
      Position.Right:=Position.Left+HauteurTexte; //
      Position.Bottom:=Y;//X-Largeur;
      Position.Top:=Y-Branche.LargeurTexte//X+LargeurTexte;
    end;
  Location:=Position;
end;

//***** TAncetreLayer ******

Constructor TAncetreLayer.CreateLayer(LeProprietaire:TArbreDate;LaBranche:TBranche);
begin
  inherited Create(LeProprietaire.Layers);
  Proprietaire:=LeProprietaire;
  Branche:=LaBranche;
  Scaled:=True;
  Rayon:=4;
  Couleur:=LeProprietaire.CouleurAncetre;
end;
Procedure TAncetreLayer.Positionne(X,Y:integer); //X et Y : coordonnes du centre
Var
  Position:TFloatRect;
begin
  Position.Left:=X-Rayon;
  Position.Top:=Y-Rayon;
  Position.Bottom:=Y+Rayon;
  Position.Right:=X+Rayon;
  Location:=Position;
end;


//******** TArbreDate *****************
Constructor TArbreDate.Create(AOwner: TComponent);
Var
  i,j:integer;
  CatItemStrati:TTypeItemStrati;
  cl:TColor32;
begin
  inherited Create(AOwner);
  SimpleDiagramme:=False;
  DessinProv:=TBitmapLayer.Create(Layers);
  DessinProv.Scaled:=True;
  DessinProv.Bitmap.Width:=1;
  DessinProv.Bitmap.Height:=1;
  DessinProv.Bitmap.DrawMode := dmBlend;
  DessinProv.Location:=FloatRect(0,0,1,1);
  DessinProv.Bitmap.MasterAlpha := 255;

  StrGroupeNonNomme:='Groupe non nomm';
  Parent:=TWinControl(AOwner);
  DessinerBoites:=False;
  AfficherNomsGroupes:=False;
  BoitesSansTaxons:=False;
  BranchesCreuses:=False;
  AfficherStrati:=True;
  For CatItemStrati:=Ere to Periode do
    AfficherCatStrati[CatItemStrati]:=True;
  AfficherCrises:=False;
  CouleurFossile:=clRed32;
  CouleurExterne:=clBlue32;
  CouleurCrises:=clRed32;
  TypeDArbre:=0; //par dfaut: arbre dat
  EffacerCurseursDeplaces:=False;
  SetLength(Branches,0);
  StructurePrecedente:=TStringList.Create;
  Attente:=False;
  MargeH:=8;
  MargeV:=4;
  EspBoites:=6;
  MargeHMini:=2;
  MargeHMax:=30;
  MargeVMini:=1;
  MargeVMax:=10;
  HauteurTexte:=Bitmap.TextHeight('T');
  DeltaPosX:=4;
  TexteInfo:='';
  LongueurRacine:=30;//20;
  epaisseurBranche:=3;
  coeffY:=1;  //de 1  0,7
  MiniAge:=0; //ge du dbut de l'chelle en milliers d'annes;
  MaxiAge:=600000; //ge de fin de l'chelle en milliers d'annes;
  PosXMiniAge:=MargeH; //ge du dbut de l'chelle en milliers d'annes;
  PosXMaxiAge:=MargeH; //ge de fin de l'chelle en milliers d'annes;
  NumeroAncetre:=0;
  CouleurAncetre:=ClYellow32;
  CouleurBranche:=ClBlack32;
  CouleurCurseur:=ClRed32;
  CouleurErreur:=ClWhite32;
  CouleurTraitRacine:=clBlack32;
  CouleurBoiteDefaut:=ClRed32;
  EstModifiable:=False;
  //EstModifiable:=True;
  LargeurDisponible:=400;
  HauteurDisponible:=300;
  BitMap.Width:=ClientWidth;
  BitMap.Height:=ClientHeight;
  BitMap.Clear($FFFFFFFF);
  ListeCaracteres:=TStringList.Create;
  ListeCompleteTaxons:=TStringList.Create;
  NombreTaxons:=0;
  NombreTaxonsLibres:=0;
  MonRemplissage:=TBitmapPolygonFiller.create;
  MonPointille:=TBitmap32.create;
  MonPointille.Width:=4;
  MonPointille.Height:=4;
  cl:=clYellow32;
  for i:=0 to 1 do
    begin
      for j:=0 to 1 do
        begin
          MonPointille.PixelS[i*2,j*2]:=cl;
          MonPointille.PixelS[i*2+1,j*2]:=cl;
          MonPointille.PixelS[i*2,j*2+1]:=cl;
          MonPointille.PixelS[i*2+1,j*2+1]:=cl;
          if (cl=clYellow32) then cl:=clBlack32  //(j=0) and
          else cl:=clYellow32;    //if (j=0) then
        end;
    end;
  screen.Cursors[crRoot]:= LoadCursor(HInstance, 'CRROOT');
  screen.Cursors[crSwap]:=LoadCursor(HInstance, 'CRSWAP');
  screen.Cursors[crPolytom]:=LoadCursor(HInstance, 'CRPOLYTOM');
  MethodeParci:=1;
end;
Destructor TArbreDate.Destroy;
begin
  Layers.Clear;
  MonRemplissage.Free;
  MonPointille.Free;
  inherited Destroy;
end;
procedure TArbreDate.ConstruitListeTaxons;
Var
  i:integer;
  Liste:TStringList;
Begin
  ListeCompleteTaxons.Clear;
  Liste:=TStringList.Create;
  NombreTaxonsLibres:=0;
  For i:=0 to Length(Branches)-1 do
    if Branches[i].AncetreDirect=Nil then
      begin
        if Branches[i].EstUnTaxon then
          begin
            inc(NombreTaxonsLibres);
            ListeCompleteTaxons.Add(Branches[i].Nom);
          end
        else
          begin
            Liste.Clear;
            Liste.CommaText:=Branches[i].TaxonsDescendants;
            ListeCompleteTaxons.AddStrings(Liste);
          end;
      end;
  NombreTaxons:=ListeCompleteTaxons.Count;
  Liste.Free;
end;

{Procedure TArbreDate.ChercheNombreTaxons;
Var
  i:integer;
Begin
  NombreTaxons:=0;
  For i:=0 to Length(Branches)-1 do
    if Branches[i].AncetreDirect=Nil then
      NombreTaxons:=NombreTaxons+Branches[i].NombreTaxonsDescendants;
end;}
Procedure TArbreDate.ChercheNombreNiveaux;
Var
  i,n:integer;
Begin
  NombreNiveaux:=0;
  For i:=0 to Length(Branches)-1 do
    if Branches[i].AncetreDirect=Nil then
      begin
        n:=Branches[i].NombreNiveaux;
        if n>NombreNiveaux then
          NombreNiveaux:=n;
      end;
  inc(NombreNiveaux);
end;
function ExtraitChaineJusquaLimDSim(ChaineStruct:string;limG,limD:string;var posuiv:integer):string;
Var
  i,valp,n:integer;
  chaine:string;
  Lettre:string[1];
begin
  if ChaineStruct[1]<>limG then
    begin
      Result:='Erreur';
      exit;
    end;
  posuiv:=0;
  n:=length(ChaineStruct);
  i:=2;
  valp:=1;
  Chaine:='';
  while (valp>0) and (i<=n) do
    begin
      Lettre:=ChaineStruct[i];
      Chaine:=Chaine+Lettre;
      inc(i);
      if Lettre=limG then
        begin
          inc(valp);
        end
      else if Lettre=limD then
        begin
          dec(valp);
        end;
    end;
  if valp=0 then
    begin
      Delete(Chaine,Length(Chaine),1);
      posuiv:=i;
      Result:=Chaine;
    end
  else
    begin
      Result:='Erreur';
      posuiv:=0;
    end;
end;
Function TArbreDate.ConstruitBase(NomsTaxons:TStringList):TBranche; // construit une racine sur laquelle sont directement branchs les Taxons
                                                             // renvoie la rfrence de la racine
Var
  LaRacine:TBranche;
  UneBranche:TBranche;
  i,p:integer;
begin
  LaRacine:=TBranche.CreateBranche(Self);
  LaRacine.AncetreDirect:=Nil;
  LaRacine.Nom:='Anctre racine';
  LaRacine.NomGroupe:='';
  p:=Length(Branches);
  SetLength(Branches,p+1);
  Branches[p]:=LaRacine;
  For i:=0 to NomsTaxons.Count-1 do
    begin
      UneBranche:=TBranche.CreateTaxon(Self);
      UneBranche.AncetreDirect:=LaRacine;
      UneBranche.Nom:=NomsTaxons[i];
      UneBranche.EtiqTaxon:=NomsTaxons[i];
      UneBranche.Curseurs.HauteurTexte:=Bitmap.TextHeight(UneBranche.Nom);
      UneBranche.Curseurs.LargeurTexte:=Bitmap.TextWidth(UneBranche.Nom)+MargeH;
      UneBranche.NomGroupe:='';
      p:=Length(Branches);
      SetLength(Branches,p+1);
      Branches[p]:=UneBranche;
      if LaRacine<>Nil then
        begin
          p:=Length(LaRacine.Descendants);
          SetLength(LaRacine.Descendants,p+1);
          LaRacine.Descendants[p]:=UneBranche;
        end;
    end;
  VerifieAncetreRacine;
  if Assigned(ArbreModifie) then
    ArbreModifie(Self);
  if StructurePrecedente.Count>=10 then
    StructurePrecedente.Delete(0);
  StructurePrecedente.Add(StructAvecGroupe);
  Redessine;
  Result:=LaRacine;
end;
Function TArbreDate.AjouteTaxon(NomTaxon:string;BrancheSupport:TBranche):TBranche;  // renvoie la rfrence de la branche cre
Var
  UneBranche:TBranche;
  UnAncetre:TBranche;
  i,p:integer;
begin
  UneBranche:=TBranche.CreateTaxon(Self);
  UneBranche.Nom:=NomTaxon;
  UneBranche.EtiqTaxon:=NomTaxon;
  UneBranche.Curseurs.HauteurTexte:=Bitmap.TextHeight(UneBranche.Nom);
  UneBranche.Curseurs.LargeurTexte:=Bitmap.TextWidth(UneBranche.Nom)+MargeH;
  UneBranche.NomGroupe:='';
  p:=Length(Branches);
  SetLength(Branches,p+1);
  Branches[p]:=UneBranche;
  if (BrancheSupport<>Nil) and BrancheSupport.EstUnTaxon then
    begin
      //crer une branche intermdiaire
      UnAncetre:=TBranche.CreateBranche(Self);
      UnAncetre.AncetreDirect:=BrancheSupport.AncetreDirect;
      UnAncetre.Nom:='Anctre ';
      UnAncetre.NomGroupe:='';
      if BrancheSupport.AncetreDirect<>Nil then
        begin
          For i:=0 to Length(BrancheSupport.AncetreDirect.Descendants)-1 do
            begin
              if BrancheSupport.AncetreDirect.Descendants[i]=BrancheSupport then
                begin
                  BrancheSupport.AncetreDirect.Descendants[i]:=UnAncetre;
                  break;
                end;
            end;
        end;
      SetLength(UnAncetre.Descendants,2);
      UnAncetre.Descendants[0]:=BrancheSupport;
      UnAncetre.Descendants[1]:=UneBranche;
      p:=Length(Branches);
      SetLength(Branches,p+1);
      Branches[p]:=UnAncetre;
    end
  else
    begin
      UneBranche.AncetreDirect:=BrancheSupport;
      if BrancheSupport<>Nil then
        begin
          p:=Length(BrancheSupport.Descendants);
          SetLength(BrancheSupport.Descendants,p+1);
          BrancheSupport.Descendants[p]:=UneBranche;
        end;
    end;
  Result:=UneBranche;
  if BrancheSupport<>Nil then
    begin
      ReclasseBranches;
      RazNomGroupe;
      VerifieAncetreRacine;
      if Assigned(ArbreModifie) then ArbreModifie(Self);
      if StructurePrecedente.Count>=10 then
        StructurePrecedente.Delete(0);
      StructurePrecedente.Add(StructAvecGroupe);
    end;
end;
Procedure TArbreDate.SupprimeBranche(LaBrancheS:TBranche);
Var
  UneBranche:TBranche;
  i,j,p,q,numD,nbD,numDA,nbDA:integer;
begin
  numD:=-1;
  nbD:=0;
  If LaBrancheS.AncetreDirect<>Nil then
    begin
      nbD:=Length(LaBrancheS.AncetreDirect.Descendants);
      For i:=0 to nbD-1 do
        begin
          if LaBrancheS.AncetreDirect.Descendants[i]=LaBrancheS then
            begin
              numD:=i;  //numro de descendant
              Break;
            end;
        end;
    end;
  p:=Length(LaBrancheS.Descendants);
  if (p=0) and (LaBrancheS.AncetreDirect<>Nil) then
    begin
      if Length(LaBrancheS.AncetreDirect.Descendants)=2 then
        begin
          UneBranche:=LaBrancheS.AncetreDirect;
          UneBranche.Descendants[1-numD].AncetreDirect:=UneBranche.AncetreDirect;
          if UneBranche.AncetreDirect<>Nil then
            begin
              nbDA:=Length(UneBranche.AncetreDirect.Descendants);
              numDA:=-1;
              For i:=0 to nbDA-1 do
                begin
                  if UneBranche.AncetreDirect.Descendants[i]=UneBranche then
                    begin
                      numDA:=i;  //numro de descendant
                      Break;
                    end;
                end;
              if numDA>-1 then
                UneBranche.AncetreDirect.Descendants[numDA]:=UneBranche.Descendants[1-numD];
            end;
          //supprimer le noeud intermdiaire
          SetLength(UneBranche.Descendants,0);
          q:=Length(Branches)-1;
          For i:=0 to q do
            begin
              if Branches[i]=UneBranche then
                begin
                  For j:=i to q-1 do
                    Branches[j]:=Branches[j+1];
                  SetLength(Branches,q);
                  Break;
                end;
            end;
          if UneBranche<>Nil then UneBranche.Free;
        end
      else
        begin
          For i:=numD to nbD-2 do
            LaBrancheS.AncetreDirect.Descendants[i]:=LaBrancheS.AncetreDirect.Descendants[i+1];
          SetLength(LaBrancheS.AncetreDirect.Descendants,nbD-1);
        end;
    end
  else if (NumD>-1) and (p>1) then   // faire de la place pour les branches descendantes
    begin
      SetLength(LaBrancheS.AncetreDirect.Descendants,nbD+p-1);
      For i:=nbD-1 downto numD+1 do
        LaBrancheS.AncetreDirect.Descendants[i+p-1]:=LaBrancheS.AncetreDirect.Descendants[i];
    end;
  if (p>0) and (LaBrancheS.AncetreDirect<>Nil) then
    begin
      For i:=0 to p-1 do
        begin
          LaBrancheS.Descendants[i].AncetreDirect:=LaBrancheS.AncetreDirect;
          LaBrancheS.AncetreDirect.Descendants[NumD+i]:=LaBrancheS.Descendants[i];
        end;
    end
  else
    begin
      For i:=0 to p-1 do
        LaBrancheS.Descendants[i].AncetreDirect:=Nil;
    end;
  SetLength(LaBrancheS.Descendants,0);
  p:=Length(Branches)-1;
  For i:=0 to p do
    begin
      if Branches[i]=LaBrancheS then
        begin
          For j:=i to p-1 do
            Branches[j]:=Branches[j+1];
          SetLength(Branches,p);
          break;
        end;
    end;
  if LaBrancheS<>Nil then LaBrancheS.Free;
end;
Procedure TArbreDate.FixeBrancheSurLeNoeud(NoeudSupport,BrancheAFixer:TBranche);
Var
  p:integer;
begin
  if (BrancheAFixer=Nil) or ((NoeudSupport<>Nil)and NoeudSupport.EstUnTaxon)
    or (NoeudSupport=BrancheAFixer)or(BrancheAFixer.AncetreDirect=NoeudSupport) then
      exit;
  if NoeudSupport.EstDescendantDe(BrancheAFixer) then exit;
  //Retirer BrancheAFixer de son ancien ancetre et si cet Ancetre n'a plus qu'un descendant, le supprimer
  RetireBrancheDuNoeud(BrancheAFixer,BrancheAFixer.AncetreDirect);

  BrancheAFixer.AncetreDirect:=NoeudSupport;
  //Placer la branche en dernire position sur le nouvel ancetre
  if NoeudSupport<>Nil then
    begin
      p:=Length(NoeudSupport.Descendants);
      SetLength(NoeudSupport.Descendants,p+1);
      NoeudSupport.Descendants[p]:=BrancheAFixer;
    end;
  ReclasseBranches;
  RazNomGroupe;
  VerifieAncetreRacine;
  if Assigned(ArbreModifie) then ArbreModifie(Self);
  if StructurePrecedente.Count>=10 then
    StructurePrecedente.Delete(0);
  StructurePrecedente.Add(StructAvecGroupe);
  Redessine;
end;
Procedure TArbreDate.RetireBrancheDuNoeud(BrancheARetirer,AncienNoeud:TBranche);
Var
  i,j,p:integer;
begin
  if AncienNoeud<>Nil then
    begin
      p:=Length(AncienNoeud.Descendants)-1;
      For i:=0 to p do
        begin
          if AncienNoeud.Descendants[i]=BrancheARetirer then
            begin
              For j:=i to p-1 do
                AncienNoeud.Descendants[j]:=AncienNoeud.Descendants[j+1];
              SetLength(AncienNoeud.Descendants,p);
              break;
            end;
        end;
      if Length(AncienNoeud.Descendants)<2 then
        SupprimeBranche(AncienNoeud);
    end;
end;
Procedure TArbreDate.FixeBrancheSurLaBranche(BrancheSupport,BrancheAFixer:TBranche);
Var
  i,p:integer;
  UnNoeud:TBranche;
begin
  if (BrancheAFixer=Nil)or (BrancheSupport=BrancheAFixer) then  //or(BrancheSupport=BrancheAFixer.AncetreDirect)
    exit;
  if BrancheSupport.EstDescendantDe(BrancheAFixer) then exit;

  if (BrancheAFixer.AncetreDirect<>Nil) and(Length(BrancheAFixer.AncetreDirect.Descendants)=2) then
    begin
      if (BrancheAFixer.AncetreDirect=BrancheSupport) then exit;
      For i:=0 to 1 do
        if BrancheAFixer.AncetreDirect.Descendants[i]=BrancheSupport then exit;
    end;
  //Retirer BrancheAFixer de son ancien ancetre et si cet Ancetre n'a plus qu'un descendant, le supprimer

  RetireBrancheDuNoeud(BrancheAFixer,BrancheAFixer.AncetreDirect);
  if (BrancheSupport=Nil) then
    begin
      ReclasseBranches;
      exit;
    end;
  //Crer un nouveau noeud
  UnNoeud:=TBranche.CreateBranche(Self);
  UnNoeud.AncetreDirect:=BrancheSupport.AncetreDirect;
  UnNoeud.Nom:='Anctre ';
  UnNoeud.NomGroupe:='';
  if BrancheSupport.AncetreDirect<>Nil then
    begin
      For i:=0 to Length(BrancheSupport.AncetreDirect.Descendants)-1 do
        begin
          if BrancheSupport.AncetreDirect.Descendants[i]=BrancheSupport then
            begin
              BrancheSupport.AncetreDirect.Descendants[i]:=UnNoeud;
              break;
            end;
        end;
    end;
  SetLength(UnNoeud.Descendants,2);
  UnNoeud.Descendants[0]:=BrancheSupport;
  UnNoeud.Descendants[1]:=BrancheAFixer;
  p:=Length(Branches);
  SetLength(Branches,p+1);
  Branches[p]:=UnNoeud;
  BrancheAFixer.AncetreDirect:=UnNoeud;
  BrancheSupport.AncetreDirect:=UnNoeud;
  ReclasseBranches;
  RazNomGroupe;
  VerifieAncetreRacine;
  if Assigned(ArbreModifie) then ArbreModifie(Self);
  if StructurePrecedente.Count>=10 then
    StructurePrecedente.Delete(0);
  StructurePrecedente.Add(StructAvecGroupe);
  Redessine;
end;

Procedure TArbreDate.FixeNoeudSurLaBranche(BrancheSupport,NoeudAFixer:TBranche);
Var
  i,p:integer;
begin
  if (NoeudAFixer=Nil)or (BrancheSupport=NoeudAFixer)  then
    exit;
  if BrancheSupport.EstDescendantDe(NoeudAFixer) then exit;
  //Retirer NoeudAFixer de son ancien ancetre et si cet Ancetre n'a plus qu'un descendant, le supprimer
  RetireBrancheDuNoeud(NoeudAFixer,NoeudAFixer.AncetreDirect);
  if (BrancheSupport=Nil) then
    begin
      ReclasseBranches;
      exit;
    end;
  NoeudAFixer.AncetreDirect:=BrancheSupport.AncetreDirect;
  //dconnecter BrancheSupport de son Anctre et remplacer par Noeud;
  if NoeudAFixer.AncetreDirect<>Nil then
    begin
      For i:=0 to Length(NoeudAFixer.AncetreDirect.Descendants)-1 do
        begin
          if NoeudAFixer.AncetreDirect.Descendants[i]=BrancheSupport then
            begin
              NoeudAFixer.AncetreDirect.Descendants[i]:=NoeudAFixer;
              Break;
            end;
        end;
    end;
  p:=Length(NoeudAFixer.Descendants);
  SetLength(NoeudAFixer.Descendants,p+1);
  NoeudAFixer.Descendants[p]:=BrancheSupport;
  BrancheSupport.AncetreDirect:=NoeudAFixer;
  ReclasseBranches;
  RazNomGroupe;
  VerifieAncetreRacine;
  if Assigned(ArbreModifie) then ArbreModifie(Self);
  if StructurePrecedente.Count>=10 then
    StructurePrecedente.Delete(0);
  StructurePrecedente.Add(StructAvecGroupe);
  Redessine;
end;
Procedure TArbreDate.FixeNoeudSurLeNoeud(NoeudSupport,NoeudAFixer:TBranche);
Var
  i,j,p,n:integer;
begin
  if (NoeudAFixer=Nil) or ((NoeudSupport<>Nil)and NoeudSupport.EstUnTaxon)
    or (NoeudSupport=NoeudAFixer) then exit;
    //empcher de fixer un noeud sur un de ses descendants.
  if NoeudSupport.EstDescendantDe(NoeudAFixer) then exit;
  //Si le NoeudSupport n'est pas le noeud anctre
  //Retirer NoeudAFixer de son ancien ancetre
  //et si cet Ancetre n'a plus qu'un descendant, le supprimer
  if NoeudSupport<>NoeudAFixer.AncetreDirect then
    begin
      RetireBrancheDuNoeud(NoeudAFixer,NoeudAFixer.AncetreDirect);
      NoeudAFixer.AncetreDirect:=NoeudSupport;
      if NoeudSupport<>Nil then
        begin         //Ajouter les descendants du noeud en dernire position sur le nouvel ancetre
          For i:=0 to Length(NoeudAFixer.Descendants)-1 do
            begin
              p:=Length(NoeudSupport.Descendants);
              SetLength(NoeudSupport.Descendants,p+1);
              NoeudSupport.Descendants[p]:=NoeudAFixer.Descendants[i];
              NoeudAFixer.Descendants[i].AncetreDirect:=NoeudSupport;
            end;
        end;
    end
  else
    //dcaler les descendants de l'anctre et y insrer ceux du noeud dplac
    begin
      p:=Length(NoeudSupport.Descendants);
      For i:=0 to p-1 do
        begin
          if NoeudSupport.Descendants[i]=NoeudAFixer then
            begin
              n:=Length(NoeudAFixer.Descendants);
              SetLength(NoeudSupport.Descendants,p+n-1);
              for j:=p-1 downto i+1 do
                NoeudSupport.Descendants[j+n-1]:=NoeudSupport.Descendants[j];
              For j:=0 to n-1 do
                begin
                  NoeudSupport.Descendants[i+j]:=NoeudAFixer.Descendants[j];
                  NoeudAFixer.Descendants[j].AncetreDirect:=NoeudSupport;
                end;
            end;
        end;
    end;

  // Supprimer le noeud  fixer;
  NoeudAFixer.AncetreDirect:=Nil;
  SetLength(NoeudAFixer.Descendants,0);
  SupprimeBranche(NoeudAFixer);
  ReclasseBranches;
  RazNomGroupe;
  VerifieAncetreRacine;
  if Assigned(ArbreModifie) then ArbreModifie(Self);
  if StructurePrecedente.Count>=10 then
    StructurePrecedente.Delete(0);
  StructurePrecedente.Add(StructAvecGroupe);
  Redessine;
end;
{
Procedure TArbreDate.NvBrancheDApresStructArbre(BrancheParente:TBranche;ChaineStruct:string;limG,limD:string);
Var
  n,p:integer;
  DerniereBranche:TBranche;
  LaBranche:TBranche;
begin
  if pos(limG,ChaineStruct)=0 then
    begin
      LaBranche:=TBranche.CreateTaxon(Self);
      LaBranche.AncetreDirect:=BrancheParente;
      LaBranche.Nom:=ChaineStruct;
      LaBranche.EtiqTaxon:=LaBranche.Nom;
      LaBranche.Curseurs.HauteurTexte:=Bitmap.TextHeight(LaBranche.Nom);
      LaBranche.Curseurs.LargeurTexte:=Bitmap.TextWidth(LaBranche.Nom)+MargeH;
      LaBranche.NomGroupe:='';
      n:=Length(Branches);
      SetLength(Branches,n+1);
      Branches[n]:=LaBranche;
      if BrancheParente<>Nil then
        begin
          p:=Length(BrancheParente.Descendants);
          SetLength(BrancheParente.Descendants,p+1);
          BrancheParente.Descendants[p]:=LaBranche;
        end;
    end
  else
    begin
      DerniereBranche:=TBranche.CreateBranche(Self);
      DerniereBranche.AncetreDirect:=BrancheParente;
      DerniereBranche.Nom:='Anctre';
      if NumeroAncetre=0 then
        DerniereBranche.Nom:=DerniereBranche.Nom+' racine'
      else
        DerniereBranche.Nom:=DerniereBranche.Nom+' '+IntToStr(NumeroAncetre);
      Inc(NumeroAncetre);
      DerniereBranche.NomGroupe:='';
      p:=Length(Branches);
      SetLength(Branches,p+1);
      Branches[p]:=DerniereBranche;
      if BrancheParente<>Nil then
        begin
          p:=Length(BrancheParente.Descendants);
          SetLength(BrancheParente.Descendants,p+1);
          BrancheParente.Descendants[p]:=DerniereBranche;
        end;
      Construit(DerniereBranche,ChaineStruct,0,limG,limD);
    end;
end;
}
Procedure TArbreDate.NvBrancheDApresStructArbre(BrancheParente:TBranche;ChaineStruct:string;limG,limD:string);
Var
  n,p,i:integer;
  DerniereBranche:TBranche;
  LaBranche:TBranche;
  Creer:Boolean;
begin
  if pos(limG,ChaineStruct)=0 then
    begin
      Creer:=True;
      //rechercher si le taxon existe dj
      For i:=0 to Length(Branches)-1 do
        begin
          if Branches[i].Nom = ChaineStruct then
            begin
              LaBranche:=Branches[i];
              LaBranche.AncetreDirect:=BrancheParente;
              Creer:=False;
              Break;
            end;
        end;
      if Creer then  //Sinon le crer
        begin
          LaBranche:=TBranche.CreateTaxon(Self);
          LaBranche.AncetreDirect:=BrancheParente;
          LaBranche.Nom:=ChaineStruct;
          LaBranche.EtiqTaxon:=LaBranche.Nom;
          LaBranche.Curseurs.HauteurTexte:=Bitmap.TextHeight(LaBranche.Nom);
          LaBranche.Curseurs.LargeurTexte:=Bitmap.TextWidth(LaBranche.Nom)+MargeH;
          LaBranche.NomGroupe:='';
          n:=Length(Branches);
          SetLength(Branches,n+1);
          Branches[n]:=LaBranche;
        end;
      if BrancheParente<>Nil then
        begin
          p:=Length(BrancheParente.Descendants);
          SetLength(BrancheParente.Descendants,p+1);
          BrancheParente.Descendants[p]:=LaBranche;
        end;
    end
  else
    begin
      DerniereBranche:=TBranche.CreateBranche(Self);
      DerniereBranche.AncetreDirect:=BrancheParente;
      DerniereBranche.Nom:='Anctre';
      if NumeroAncetre=0 then
        DerniereBranche.Nom:=DerniereBranche.Nom+' racine'
      else
        DerniereBranche.Nom:=DerniereBranche.Nom+' '+IntToStr(NumeroAncetre);
      Inc(NumeroAncetre);
      DerniereBranche.NomGroupe:='';
      p:=Length(Branches);
      SetLength(Branches,p+1);
      Branches[p]:=DerniereBranche;
      if BrancheParente<>Nil then
        begin
          p:=Length(BrancheParente.Descendants);
          SetLength(BrancheParente.Descendants,p+1);
          BrancheParente.Descendants[p]:=DerniereBranche;
        end;
      Construit(DerniereBranche,ChaineStruct,0,limG,limD);
    end;
end;
Procedure TArbreDate.NvBrancheDApresStructBoite(BrancheParente:TBranche;ChaineStruct:string;limG,limD:string);
Var
  StringListB:TStringList;
  chaine:string;
  i,nlim,n,p:integer;
  Nom,NomGroupe:string;
  EtiqTaxons:TStringList;
  Caracteres:TStringList;
  Etats:TStringList;
  DerniereBranche,LaBranche:TBranche;
begin
  StringListB:=TStringList.Create;
  nlim:=Pos(limG,ChaineStruct);
  if nlim=0 then
    begin
      StringListB.CommaText:=ChaineStruct;
    end
  else
    begin
      StringListB.CommaText:=Copy(ChaineStruct,1,nlim-1);
    end;
  Nom:=StringListB[0];
  NomGroupe:=StringListB[1];
  EtiqTaxons:=TStringList.Create;
  EtiqTaxons.CommaText:=StringListB[3];
  Caracteres:=TStringList.Create;
  Etats:=TStringList.Create;
  Caracteres.CommaText:=StringListB[5];
  Etats.CommaText:=StringListB[6];
  if (nlim>0) or (EtiqTaxons.Count>1) then
    begin
      DerniereBranche:=TBranche.CreateBranche(Self);
      DerniereBranche.AncetreDirect:=BrancheParente;
      DerniereBranche.Nom:='Anctre';
      DerniereBranche.NomGroupe:=NomGroupe;
      if Nomgroupe='' then
        begin
          if NumeroAncetre=0 then
            DerniereBranche.Nom:=DerniereBranche.Nom+' racine'
          else
            DerniereBranche.Nom:=DerniereBranche.Nom+' '+IntToStr(NumeroAncetre);
        end
      else
        begin
          DerniereBranche.Nom:=DerniereBranche.Nom+' des '+Nomgroupe;
        end;
      Inc(NumeroAncetre);
      p:=Length(Branches);
      SetLength(Branches,p+1);
      Branches[p]:=DerniereBranche;
      DerniereBranche.CaracteresDExcl.Clear;
      DerniereBranche.CaracteresDExcl.AddStrings(Caracteres);
      DerniereBranche.EtatsDExcl.Clear;
      DerniereBranche.EtatsDExcl.AddStrings(Etats);
      if BrancheParente<>Nil then
        begin
          p:=Length(BrancheParente.Descendants);
          SetLength(BrancheParente.Descendants,p+1);
          BrancheParente.Descendants[p]:=DerniereBranche;
        end;
    end;
  For i:=0 to EtiqTaxons.Count-1 do
    begin
      //crer des branches de taxons
      LaBranche:=TBranche.CreateTaxon(Self);
      LaBranche.Nom:=EtiqTaxons[i];
      p:=Length(LaBranche.Nom);
      While (p>0)and(LaBranche.Nom[p]=' ') do
        begin
          Delete(LaBranche.Nom,p,1);
          p:=Length(LaBranche.Nom);
        end;
      p:=pos(' -',LaBranche.Nom);
      if p>0 then LaBranche.Nom:=Copy(LaBranche.Nom,1,p-1);
      LaBranche.EtiqTaxon:=LaBranche.Nom;
      LaBranche.Curseurs.HauteurTexte:=Bitmap.TextHeight(LaBranche.Nom);
      LaBranche.Curseurs.LargeurTexte:=Bitmap.TextWidth(LaBranche.Nom)+MargeH;
      if (nlim=0)and(EtiqTaxons.Count=1) then
        begin
          LaBranche.NomGroupe:=NomGroupe;
          LaBranche.TracerBoite:=True;
        end;
      if DerniereBranche=Nil then
        begin
          LaBranche.AncetreDirect:=BrancheParente;
          LaBranche.NomGroupe:=NomGroupe;
          LaBranche.CaracteresDExcl.Clear;
          LaBranche.CaracteresDExcl.AddStrings(Caracteres);
          LaBranche.EtatsDExcl.Clear;
          LaBranche.EtatsDExcl.AddStrings(Etats);
          if BrancheParente<>Nil then
            begin
              p:=Length(BrancheParente.Descendants);
              SetLength(BrancheParente.Descendants,p+1);
              BrancheParente.Descendants[p]:=LaBranche;
            end;
        end
      else
        begin
          LaBranche.AncetreDirect:=DerniereBranche;
          //LaBranche.NomGroupe:='';
          p:=Length(DerniereBranche.Descendants);
          SetLength(DerniereBranche.Descendants,p+1);
          DerniereBranche.Descendants[p]:=LaBranche;
        end;
      n:=Length(Branches);
      SetLength(Branches,n+1);
      Branches[n]:=LaBranche;
    end;
  if nlim>0 then //il y a des botes incluses
    begin  //crer une branche descendante;
      chaine:=Copy(ChaineStruct,nlim,Length(ChaineStruct)-nlim+1);
      Construit(DerniereBranche,Chaine,1,limG,limD);
    end;
  Etats.Free;
  Caracteres.Free;
  EtiqTaxons.Free;
  StringListB.Free;
end;
Procedure TArbreDate.NvBrancheDApresStructAPG(BrancheParente:TBranche;ChaineStruct:string;limG,limD:string);
Var
  n,p,i:integer;
  DerniereBranche:TBranche;
  LaBranche:TBranche;
  LeGroupe:string;
  function ExtraitNomGroupe:string;
  Var
    posD1:integer;
  begin
    Result:=ChaineStruct;
    LeGroupe:='';
    posD1:=pos('$',Result);
    if posD1>0 then
      begin
        Result:=Copy(Result,posD1+1,Length(Result)-posD1);
        posD1:=pos('$',Result);
        if posD1>0 then
        begin
          if posD1>1 then
            LeGroupe:=Copy(Result,1,posD1-1);
          Result:=Copy(Result,posD1+1,Length(Result)-posD1);
        end;
      end;
  end;
  var
  Chaine:string;
  Creer:Boolean;
begin
  Chaine:=ExtraitNomGroupe;
  if pos(limG,Chaine)=0 then
    begin
      Creer:=True;
      //rechercher si le taxon existe dj
      For i:=0 to Length(Branches)-1 do
        begin
          if Branches[i].Nom = Chaine then
            begin
              LaBranche:=Branches[i];
              LaBranche.AncetreDirect:=BrancheParente;
              Creer:=False;
              Break;
            end;
        end;
      if Creer then  //Sinon le crer
        begin
          LaBranche:=TBranche.CreateTaxon(Self);
          LaBranche.AncetreDirect:=BrancheParente;
          LaBranche.Nom:=Chaine;
          LaBranche.EtiqTaxon:=LaBranche.Nom;
          LaBranche.Curseurs.HauteurTexte:=Bitmap.TextHeight(LaBranche.Nom);
          LaBranche.Curseurs.LargeurTexte:=Bitmap.TextWidth(LaBranche.Nom)+MargeH;
          n:=Length(Branches);
          SetLength(Branches,n+1);
          Branches[n]:=LaBranche;
        end;
      LaBranche.NomGroupe:=LeGroupe;
      if LaBranche.NomGroupe<>'' then
        begin
          LaBranche.EstUnGroupeMonoPhyl:=True;
          LaBranche.TracerBoite:=True;
        end;
      if BrancheParente<>Nil then
        begin
          p:=Length(BrancheParente.Descendants);
          SetLength(BrancheParente.Descendants,p+1);
          BrancheParente.Descendants[p]:=LaBranche;
        end;
    end
  else
    begin
      DerniereBranche:=TBranche.CreateBranche(Self);
      DerniereBranche.AncetreDirect:=BrancheParente;
      DerniereBranche.Nom:='Anctre';
      if NumeroAncetre=0 then
        DerniereBranche.Nom:=DerniereBranche.Nom+' racine'
      else
        DerniereBranche.Nom:=DerniereBranche.Nom+' '+IntToStr(NumeroAncetre);
      Inc(NumeroAncetre);
      DerniereBranche.NomGroupe:=LeGroupe;
      if LeGroupe<>'' then
        DerniereBranche.Nom:='Anctre des '+LeGroupe;
      p:=Length(Branches);
      SetLength(Branches,p+1);
      Branches[p]:=DerniereBranche;
      if BrancheParente<>Nil then
        begin
          p:=Length(BrancheParente.Descendants);
          SetLength(BrancheParente.Descendants,p+1);
          BrancheParente.Descendants[p]:=DerniereBranche;
        end;
      Construit(DerniereBranche,Chaine,2,limG,limD);
    end;
end;
Procedure TArbreDate.Construit(BrancheParente:TBranche;ChaineStruct:string;TypeStruct:integer;limG,limD:string);
Var
  posuiv:integer;
  chaine,DernierMorceau:string;
begin
  Chaine:=ChaineStruct;
  posuiv:=1;
  while (posuiv>0) and (posuiv<Length(Chaine)) do
    begin
      DernierMorceau:=ExtraitChaineJusquaLimDSim(Chaine,limG,limD,posuiv);
      If DernierMorceau='Erreur' then
        begin
          MessageDlg('Erreur',mtError,[mbOK],0);
          exit;
        end;
      Case TypeStruct of
        0:NvBrancheDApresStructArbre(BrancheParente,DernierMorceau,limG,limD);
        1:NvBrancheDApresStructBoite(BrancheParente,DernierMorceau,limG,limD);
        2:NvBrancheDApresStructAPG(BrancheParente,DernierMorceau,limG,limD);
      end;
      Delete(Chaine,1,posuiv-1);
      posuiv:=1;
    end;
end;

Procedure TArbreDate.CalculeEspVertArbreDate(LeBitMap:TBitMap32);
Var
  n,i,niv,SpYT,SupYmax:integer;
  BrPremA:TBranche;
begin
  SupXBoiteG:=0;   //G = ici Haut
  SupXBoiteD:=0;   //B = ici Bas
  SupYBoite:=0;    //ici  droite
  SupIntBoites:=0;  //ici verticalement
  HauteurTexte:=LeBitMap.TextHeight('T');
  RAZEspB;//remise  zro des espaces Botes
  //Calcul de l'espace ncessaire aux botes
  //
  if DessinerBoites then
    begin
      SetLength(SupYNiv,NombreNiveaux);  //ici horizontalement
      For n:=0 to Length(SupYNiv)-1 do
        SupYNiv[n]:=0;
      For i:=0 to Length(Branches)-1 do
        begin
          if Branches[i].EstUnTaxon and Branches[i].TracerBoite then
            begin
              if AfficherNomsGroupes then
                begin
                  Branches[i].EspBG:=HauteurTexte+4+EspBoites;
                  Branches[i].EspBD:=EspBoites;
                end
              else
                begin
                  Branches[i].EspBG:=EspBoites;
                  Branches[i].EspBD:=EspBoites;
                end;
                Branches[i].EspBGCalcule:=True;
                Branches[i].EspBDCalcule:=True;
              If Branches[i].AncetreDirect<>Nil then
                niv:=Branches[i].AncetreDirect.Niveau-1
              else
                niv:=NombreNiveaux-1;
              SpYT:=MargeH+Branches[i].EspaceMaxEtiqTax+4;
              SupYNiv[niv]:=Max(SupYNiv[niv],SpYT);
            end;
        end;
      For n:=1 to NombreNiveaux do
        begin
          For i:=0 to Length(Branches)-1 do
            begin
              if Branches[i].Niveau=n then
                begin
                  Branches[i].CalcEspG;
                  Branches[i].CalcEspD;
                  If Branches[i].AncetreDirect<>Nil then
                    niv:=Branches[i].AncetreDirect.Niveau-1
                  else
                    niv:=NombreNiveaux-1;
                  SpYT:=MargeH+Branches[i].EspaceMaxEtiqTax+4;
                  if BoitesSansTaxons then
                    begin
                      SupYNiv[niv]:=Max(SupYNiv[niv],SpYT);
                    end
                  else
                    begin
                      if Branches[i].EstUnGroupeMonoPhyl then
                        begin
                          SupYNiv[niv]:=Max(SupYNiv[niv],SpYT);
                        end;
                    end;
                end;
            end;
        end;
      For n:=1 to NombreNiveaux-1 do
        begin
          SpYT:=SupYNiv[n-1]+EspBoites;
          SupYNiv[n]:=Max(SupYNiv[n],SpYT);
        end;
      SupYmax:=SupYNiv[NombreNiveaux-1];
      SupYBoite:=SupYmax;
      For i:=0 to Length(Branches)-1 do
        begin
          if Branches[i].AncetreDirect=Nil then
            begin
              SupXBoiteG:=SupXBoiteG+Branches[i].CalcEspG;
              SupXBoiteD:=SupXBoiteD+Branches[i].CalcEspD;
            end;
        end;
      SupIntBoites:=0;
      For i:=0 to Length(Branches)-1 do
        begin
          if Branches[i].EstUnTaxon then
            begin
              BrPremA:=AncPlusVieuxPrem(Branches[i]);
              if (BrPremA<>Nil) then
                begin
                  if (Not BrPremA.EstUnTaxon) or BrPremA.TracerBoite then
                  SupIntBoites:=SupIntBoites+BrPremA.EspBG;
                end;
              BrPremA:=AncPlusVieuxDern(Branches[i]);
              if (BrPremA<>Nil) then
                begin
                  if (Not BrPremA.EstUnTaxon) or BrPremA.TracerBoite then
                  SupIntBoites:=SupIntBoites+BrPremA.EspBD;
                end;
            end;
        end;
    end;
end;
Procedure TArbreDate.CalculeTailleArbreDate(LeBitMap:TBitMap32);
Var
  i,n,nbd,l,DernY:integer;
  LaBranche,BrPremA:TBranche;
  LeRectangle:TFloatRect;
  CatItemStrati:TTypeItemStrati;
begin
  HauteurTaxon:=LeBitMap.TextHeight('T')+2*MargeV;
  EchelleMa:=((MaxiAge-MiniAge)>800);
  EcartAge:=Round((MaxiAge-MiniAge)/100);
  If EchelleMa then
    LargeurEtiqTaxons:=LeBitMap.TextWidth('Temps(Ma)')
  else
    LargeurEtiqTaxons:=LeBitMap.TextWidth('Temps(annes)');
  ConstruitListeTaxons;
  ChercheNombreNiveaux;

  CalculeEspVertArbreDate(LeBitMap);
  DernY:=MargeV;//  +SupXBoiteG
  HauteurAxeTemps:=HauteurTaxon+2*MargeV;
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche<>Nil then
        if Length(LaBranche.Descendants)=0 then
          begin
            LaBranche.Hauteur:=HauteurTaxon;
            l:=LeBitMap.TextWidth(LaBranche.EtiqTaxon);
            LaBranche.LargeurTexte:=l+MargeH;
            if l>LargeurEtiqTaxons then
              LargeurEtiqTaxons:=l;
            if DessinerBoites then
              begin
                BrPremA:=AncPlusVieuxPrem(LaBranche);
                if (BrPremA<>Nil) then
                  DernY:=DernY+BrPremA.EspBG;
                BrPremA:=AncPlusVieuxDern(LaBranche);
                if (LaBranche.TracerBoite) and (BrPremA=LaBranche) then
                  begin
                    DernY:=DernY+LaBranche.EspBG;
                    if LaBranche.AncetreDirect<>Nil then
                      LaBranche.AncetreDirect.EspBG:=LaBranche.AncetreDirect.EspBG+LaBranche.EspBG;
                  end;
              end;
            LaBranche.Y:=DernY;
            DernY:=DernY+LaBranche.Hauteur; //
            if DessinerBoites then
              begin
                BrPremA:=AncPlusVieuxDern(LaBranche);
                if (BrPremA<>Nil) then
                  DernY:=DernY+BrPremA.EspBD;
              end;
            LaBranche.YBranche:=LaBranche.Y+LaBranche.Hauteur div 2;
            If LaBranche.PosAgeDisp<0 then
              LaBranche.PosAgeDisp:=0;
            If Labranche.PosAgeApp<LaBranche.PosAgeDisp then
              Labranche.PosAgeApp:=LaBranche.PosAgeDisp;
          end;
    end;
  LargeurEtiqTaxons:=LargeurEtiqTaxons+2*MargeH+SupYBoite;
  PosXMiniAge:=LeBitMap.Width-2*MargeH-LargeurEtiqTaxons;
  For n:=1 to NombreNiveaux do
    begin
      For i:=0 to Length(Branches)-1 do
        begin
          LaBranche:=Branches[i];
          if (LaBranche<>Nil) and (LaBranche.Niveau=n) then
            begin
              nbd:=Length(LaBranche.Descendants);
              if nbd>0 then
                begin
                  Labranche.Y:=LaBranche.Descendants[0].YBranche;//+(LaBranche.Descendants[0].Hauteur div 2);
                  LaBranche.Hauteur:=LaBranche.Descendants[nbd-1].YBranche-LaBranche.Descendants[0].YBranche;
                  if (nbd mod 2)=1 then
                    LaBranche.YBranche:=LaBranche.Descendants[(nbd div 2)].YBranche
                  else
                    LaBranche.YBranche:=(LaBranche.Descendants[(nbd div 2)].YBranche+LaBranche.Descendants[(nbd div 2-1)].YBranche)div 2;
                  //LaBranche.YBranche:=LaBranche.Y+LaBranche.Hauteur div 2;
                end;
            end;
        end;
    end;
  YAxetemps:=DernY+2*MargeV;  //+SupXBoiteD
  // ajuster la largeur des curseurs  l'chelle (si elle a chang)
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche<>Nil then
        if Length(LaBranche.Descendants)=0 then
          begin
            if Labranche.Curseurs<>Nil then
              begin
                LeRectangle:=Labranche.Curseurs.Location;
                LeRectangle.Left:=AgeToPosX(Labranche.PosAgeApp);
                if Labranche.PosAgeDisp>Labranche.PosAgeApp then Labranche.PosAgeDisp:=Labranche.PosAgeApp;
                Labranche.Curseurs.Largeur:=Round((Labranche.PosAgeDisp-Labranche.PosAgeApp)*CoeffAgeToPosX);
                LeRectangle.Right:=LeRectangle.Left+Labranche.Curseurs.Largeur+Labranche.Curseurs.LargeurTexte;
                Labranche.Curseurs.Location:=LeRectangle;
              end;
          end;
    end;
  n:=0;

  For CatItemStrati:=Ere to Epoque do
    if AfficherCatStrati[CatItemStrati] then inc(n);
  //if AfficherEre then inc(n);
  //if AfficherEpoque then inc(n);
  //if AfficherPeriode then inc(n);
  if n>0 then
    begin
      AfficherStrati:=True;
      YEchelleStrati:=YAxetemps+17;//HauteurAxeTemps-HauteurTaxon;
      HauteurEchelleStrati:=(HauteurTaxon-MargeV)*n;
      YCurseur:=YEchelleStrati+HauteurEchelleStrati+5;
      LeBitMap.Height:=YEchelleStrati+HauteurEchelleStrati+HauteurTaxon;
    end
  else
    begin
      YEchelleStrati:=YAxetemps;
      YCurseur:=YAxetemps+15;
      HauteurEchelleStrati:=0;
      LeBitMap.Height:=YEchelleStrati+HauteurEchelleStrati;
    end;
  if LeNouvCaractere<>Nil then
    begin
      YLegende:=LeBitMap.Height;
      LeBitMap.Height:=LeBitMap.Height+2*HauteurTaxon;
    end;

{  YZoneInfo:=YAxetemps+HauteurAxeTemps;
  HauteurZoneInfo:=HauteurTaxon;
  if (LeBitMap.Height<YZoneInfo+HauteurZoneInfo+MargeV) then LeBitMap.Height:=YZoneInfo+HauteurZoneInfo+MargeV;}
end;
Procedure TArbreDate.CalculeTailleArbreClade(LeBitMap:TBitMap32);
Var
  i,n,l,DernX,p,ET1,ET2:integer;
  LaBranche,BrPremA:TBranche;
  DeltaX:integer;
  largeurArbre:integer;
  Condition:Boolean;
  texte:string;
  SupRacine:integer;
  SupYmax:integer;
  SpYT,niv:integer;
begin
  ConstruitListeTaxons;
  ChercheNombreNiveaux;
  SupXBoiteG:=0;
  SupXBoiteD:=0;
  SupYBoite:=0;
  SupIntBoites:=0;
  NumeroGroupe:=0;// pour numrotation si pas de place pour crire le nom
  HauteurTexte:=LeBitMap.TextHeight('T');
  RAZEspB;//remise  zro des espaces Botes
  //Calcul de l'espace ncessaire aux botes
  //
  if DessinerBoites then
    begin
      For i:=0 to Length(Branches)-1 do
        begin
          if Branches[i].AncetreDirect=Nil then
            Branches[i].CalculeEspaceMaxEtiqTax(LeBitMap);
        end;
      SetLength(SupYNiv,NombreNiveaux);
      For n:=0 to Length(SupYNiv)-1 do
        SupYNiv[n]:=0;
      //SupYmax:=0;
      For i:=0 to Length(Branches)-1 do
        begin
          if Branches[i].EstUnTaxon and Branches[i].TracerBoite then
            begin
              Branches[i].EspBG:=(HauteurTexte div 2)+EspBoites+1;
              Branches[i].EspBD:=(HauteurTexte div 2)+EspBoites+1;
              If Branches[i].AncetreDirect<>Nil then
                niv:=Branches[i].AncetreDirect.Niveau-1
              else
                niv:=NombreNiveaux-1;
              if AfficherNomsGroupes then
                SpYT:=HauteurTexte+4+Branches[i].EspaceMaxEtiqTax+MargeV
              else
                SpYT:=MargeV+Branches[i].EspaceMaxEtiqTax+4;
              SupYNiv[niv]:=Max(SupYNiv[niv],SpYT);
            end;
        end;
      For n:=1 to NombreNiveaux do
        begin
          For i:=0 to Length(Branches)-1 do
            begin
              if Branches[i].Niveau=n then
                begin
                  Branches[i].CalcEspG;
                  Branches[i].CalcEspD;
                  If Branches[i].AncetreDirect<>Nil then
                    niv:=Branches[i].AncetreDirect.Niveau-1
                  else
                    niv:=NombreNiveaux-1;
                  if AfficherNomsGroupes then
                    SpYT:=HauteurTexte+4+Branches[i].EspaceMaxEtiqTax+MargeV
                  else
                    SpYT:=MargeV+Branches[i].EspaceMaxEtiqTax+4;
                  if BoitesSansTaxons then
                    begin
                      if Branches[i].BoiteQuiInclutUneAutre and AfficherNomsGroupes then
                        begin
                          SupYNiv[niv]:=Max(SupYNiv[niv],SpYT);
                        end
                      else
                        SupYNiv[niv]:=Max(SupYNiv[niv],SpYT);
                    end
                  else
                    begin
                      if Branches[i].EstUnGroupeMonoPhyl then
                        begin
                          SupYNiv[niv]:=Max(SupYNiv[niv],SpYT);
                        end;
                    end;
                end;
            end;
        end;
      For n:=1 to NombreNiveaux-1 do
        begin
          SpYT:=SupYNiv[n-1]+EspBoites;
          if AfficherNomsGroupes then
            SpYT:=SpYT+HauteurTexte+4;
          SupYNiv[n]:=Max(SupYNiv[n],SpYT);
        end;
     SupYmax:=SupYNiv[NombreNiveaux-1];
      SupYBoite:=SupYmax;
      For i:=0 to Length(Branches)-1 do
        begin
          if Branches[i].AncetreDirect=Nil then
            begin
              SupXBoiteG:=SupXBoiteG+Branches[i].CalcEspG;
              SupXBoiteD:=SupXBoiteD+Branches[i].CalcEspD;
            end;
        end;
      SupIntBoites:=0;
      For i:=0 to Length(Branches)-1 do
        begin
          if Branches[i].EstUnTaxon then
            begin
              BrPremA:=AncPlusVieuxPrem(Branches[i]);
              if (BrPremA<>Nil) then
                begin
                  if (Not BrPremA.EstUnTaxon) or BrPremA.TracerBoite then
                  SupIntBoites:=SupIntBoites+BrPremA.EspBG;
                end;
              BrPremA:=AncPlusVieuxDern(Branches[i]);
              if (BrPremA<>Nil) then
                begin
                  if (Not BrPremA.EstUnTaxon) or BrPremA.TracerBoite then
                  SupIntBoites:=SupIntBoites+BrPremA.EspBD;
                end;
            end;
        end;
    end;
  MargeG:=4+(HauteurTexte div 2);
{  Condition:=True;
  SupRacine:=0;
  For i:=0 to Length(Racines)-1 do
    begin
      condition:=condition and (Not Racines[i].RacineFictive);
    end;
  if Condition then SupRacine:=LongueurRacine;
  }
  //sparer ce qui concerne le calcul de largeurEtiqTaxon et le reste qui est  replacer plus bas
  LargeurEtiqTaxons:=0;
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if (LaBranche<>Nil) and (Labranche.AncetreDirect=Nil) then
        begin
          Labranche.CalculeEspaceMaxEtiqTax(LeBitMap);
          LargeurEtiqTaxons:=Max(LargeurEtiqTaxons,LaBranche.EspaceMaxEtiqTax);
        end;
    end;
  LargeurEtiqTaxons:=LargeurEtiqTaxons+2*MargeV;

  HauteurGraphe:=HauteurDisponible-(MargeV+LongueurRacine+2);

  if NombreTaxons>(NombreTaxonsLibres+1) then
    begin
      if DessinerBoites then
        ET1:=Trunc((2*(HauteurGraphe-SupYBoite)-SupIntBoites)/(NombreTaxons-NombreTaxonsLibres-1))
      else
        ET1:=Trunc((2*(HauteurGraphe-LargeurEtiqTaxons)-SupIntBoites)/(NombreTaxons-NombreTaxonsLibres-1));
    end
  else
    ET1:=10000;
  //HauteurGraphe:=LargeurEtiqTaxons+(((NombreTaxons-1)*EcartTaxons+SupIntBoites) div 2)+SupYBoite;
  LargeurArbre:=LargeurDisponible-SupIntBoites-2*MargeG;//-SupXBoiteG-SupXBoiteD;
  if NombreTaxons>1 then
    ET2:=Trunc(LargeurArbre/(NombreTaxons-1))
  else ET2:=60;

  EcartTaxons:=min(ET1,ET2);
  If EcartTaxons<(HauteurTexte+MargeHMini) then
    EcartTaxons:=HauteurTexte+MargeHMini;
  If EcartTaxons>(HauteurTexte+MargeHMax) then
    EcartTaxons:=HauteurTexte+MargeHMax;
  MargeG:=(LargeurDisponible-(NombreTaxons-1)*EcartTaxons-SupIntBoites) div 2; //-SupXBoiteG-SupXBoiteD
  if MargeG<(4+(HauteurTexte div 2)) then MargeG:=4+(HauteurTexte div 2);
  if DessinerBoites then
    HauteurGraphe:=(((NombreTaxons-NombreTaxonsLibres-1)*EcartTaxons+SupIntBoites) div 2)+SupYBoite+MargeV
  else
    HauteurGraphe:=LargeurEtiqTaxons+(((NombreTaxons-NombreTaxonsLibres-1)*EcartTaxons+SupIntBoites) div 2)+MargeV; //+SupXBoiteG+SupXBoiteD
  if HauteurGraphe<(LargeurEtiqTaxons+LongueurRacine)then
    HauteurGraphe:=HauteurGraphe+LongueurRacine;

  //placement Horizontal des Taxons
  DernX:=MargeG;
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche<>Nil then
        if Length(LaBranche.Descendants)=0 then //branche terminale
          begin
            if DessinerBoites then
              begin
                BrPremA:=AncPlusVieuxPrem(Branches[i]);
                if (BrPremA<>Nil) then
                  DernX:=DernX+BrPremA.EspBG;
              end;
            LaBranche.XCible:=DernX;
            DernX:=DernX+EcartTaxons;
            if DessinerBoites then
              begin
                BrPremA:=AncPlusVieuxDern(Branches[i]);
                if (BrPremA<>Nil) then
                  DernX:=DernX+BrPremA.EspBD;
              end;
            //LaBranche.X:=DernX;
            //DernX:=DernX+LaBranche.Largeur;
            //LaBranche.XBranche:=LaBranche.X+LaBranche.Largeur div 2;
            //LaBranche.XCible:=LaBranche.X+LaBranche.Largeur div 2;
            LaBranche.PremierDescendant:=LaBranche;
            LaBranche.DernierDescendant:=LaBranche;
          end;
    end;

  //retirer le nombre de taxons libres
  if DessinerBoites then
    YTaxons:=MargeV+2+SupYBoite
  else
    YTaxons:=MargeV+LargeurEtiqTaxons;
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche<>Nil then
        if Length(LaBranche.Descendants)=0 then
          begin
            LaBranche.YCible:=YTaxons;
          end;
    end;
  For n:=1 to NombreNiveaux-1 do
    begin
      For i:=0 to Length(Branches)-1 do
        begin
          LaBranche:=Branches[i];
          if (LaBranche<>Nil) and (LaBranche.Niveau=n) then
            begin
              LaBranche.CherchePremierDescendant;
              LaBranche.ChercheDernierDescendant;
              DeltaX:=(LaBranche.DernierDescendant.XCible-LaBranche.PremierDescendant.XCible)div 2;
              LaBranche.XCible:=LaBranche.PremierDescendant.XCible+DeltaX;
              LaBranche.YCible:=LaBranche.PremierDescendant.YCible+DeltaX;
            end;
        end;
    end;
  LeBitMap.Height:=HauteurGraphe+MargeV+LongueurRacine+1;
  Height:=LeBitMap.Height;
  if ((NombreTaxons-1)*EcartTaxons+MargeG*2+SupIntBoites)<(LargeurDisponible+4) then //+SupXBoiteG+SupXBoiteD
    begin
      LeBitMap.Width:=LargeurDisponible;
      Width:=LargeurDisponible;
    end
  else
    begin
      LeBitMap.Width:=((NombreTaxons-1)*EcartTaxons+MargeG*2+SupIntBoites); //+SupXBoiteG+SupXBoiteD
      Width:=LeBitMap.Width;
    end;
end;
Procedure TArbreDate.DessineBoiteDate(n:integer;LaBranche:TBranche;LeBitMap:TBitmap32);
Var
  LePoint,PointB:TFixedPoint;
  ContourBoite,OutLine,OutLine2,Bandeau:TPolygon32;
  Y1,Y2,X1,X2:single;
  Texte:string;
  XT,YT:integer;
begin
  ContourBoite:=TPolygon32.Create;
  ContourBoite.Closed:=True;
  ContourBoite.Antialiased:=True;
  ContourBoite.AntialiasMode:=am32times;
  Bandeau:=TPolygon32.Create;
  Bandeau.Closed:=True;
  Bandeau.Antialiased:=False;
  if LaBranche.EstUnTaxon  then    
    begin
      Y1:=(LaBranche.Y-LaBranche.EspBG-2);  //  revoir
      Y2:=(LaBranche.Y+LaBranche.EspBD+HauteurTaxon-4);
      X1:=AgeToPosX(LaBranche.PosAgeApp);
    end
  else
    begin
      LaBranche.CherchePremierDescendant;
      LaBranche.ChercheDernierDescendant;
      Y1:=(LaBranche.PremierDescendant.Y-LaBranche.EspBG);  //LaBranche.PremierDescendant.YCible
      Y2:=(LaBranche.DernierDescendant.Y+LaBranche.EspBD+HauteurTaxon-4);
      X1:=LaBranche.XCible;
    end;
//point Bas Gauche
  LePoint.Y:=Round(Y2*65536);
  LePoint.X:=Round((X1-2)*65536);
  ContourBoite.Add(LePoint);
//point Haut Gauche
  YT:=Round(Y1);
  LePoint.Y:=Round(Y1*65536);
  ContourBoite.Add(LePoint);
  PointB:=LePoint;
  PointB.Y:=Round((Y1+HauteurTexte+4)*65536);
  Bandeau.Add(PointB);
  Bandeau.Add(LePoint);
//point Haut droit
  if n>=0 then
    X2:=LeBitmap.Width-MargeH-SupYBoite+n*EspBoites
  else X2:=LeBitmap.Width-MargeH;
  LePoint.X:=Round(X2*65536);
  ContourBoite.Add(LePoint);
  PointB.X:=LePoint.X;
  Bandeau.Add(LePoint);
  Bandeau.Add(PointB);
//point Bas droit
  LePoint.Y:=Round(Y2*65536);
  ContourBoite.Add(LePoint);
  //*********** ecrire le nom ou un nombre si besoin
  //if AfficherNomsGroupes and((Not BoitesSansTaxons) or LaBranche.BoiteQuiInclutUneAutre) then
  if AfficherNomsGroupes then
    begin
      Bandeau.DrawFill(Lebitmap,LaBranche.CouleurBoite);
      Texte:=LaBranche.NomGroupe;
      if Texte='' then Texte:=StrGroupeNonNomme;
      if Lebitmap.TextWidth(Texte)>(X2-X1-2*EspBoites) then
        begin
          inc(NumeroGroupe);
          Texte:=IntToStr(NumeroGroupe);
          LaBranche.NumeroGroupe:=NumeroGroupe;
          LaBranche.PositionNumero.Top:=YT+1;
          LaBranche.PositionNumero.Bottom:=YT+3+Lebitmap.TextHeight(Texte);
        end
      else
        LaBranche.NumeroGroupe:=-1;
      if LaBranche.NomGroupe='' then
        begin
          LaBranche.PositionEtiqGroupe.Top:=YT+1;
          LaBranche.PositionEtiqGroupe.Bottom:=YT+3+Lebitmap.TextHeight(Texte);
        end;

      XT:=Round(X1+(X2-X1-Lebitmap.TextWidth(Texte))/2);
      if LaBranche.NumeroGroupe>-1 then
        begin
          LaBranche.PositionNumero.Left:=XT-2;
          LaBranche.PositionNumero.Right:=XT+Lebitmap.TextWidth(Texte)+2;
        end;
      if LaBranche.NomGroupe='' then
        begin
          LaBranche.PositionEtiqGroupe.Left:=XT-2;
          LaBranche.PositionEtiqGroupe.Right:=XT+Lebitmap.TextWidth(Texte)+2;
        end;


      LeBitmap.Textout(XT,YT+2,Texte);
    end;

  OutLine:=ContourBoite.Outline;
  OutLine:=OutLine.Grow(65536,0.99);
  OutLine.DrawFill(Lebitmap,LaBranche.CouleurBoite);
  if LaBranche.CouleurSurBoite<>0 then
    begin
      OutLine2:=ContourBoite.Grow(-65536*2,0.99).Outline;
      OutLine2:=OutLine2.Grow(65536,0.99);
      OutLine2.DrawFill(Lebitmap,LaBranche.CouleurSurBoite);
      OutLine2.Free;
    end;
  ContourBoite.Free;
  OutLine.Free;
end;
Procedure TArbreDate.DessineBoiteClade(BaseHautBoite,n:integer;LaBranche:TBranche;LeBitMap:TBitmap32);
Var
  LePoint,PointB:TFixedPoint;
  ContourBoite,OutLine,OutLine2,Bandeau:TPolygon32;
  X1,X2:single;
  Texte:string;
  XT,YT:integer;
begin
  ContourBoite:=TPolygon32.Create;
  ContourBoite.Closed:=True;
  ContourBoite.Antialiased:=True;
  ContourBoite.AntialiasMode:=am32times;
  Bandeau:=TPolygon32.Create;
  Bandeau.Closed:=True;
  Bandeau.Antialiased:=False;
  if LaBranche.EstUnTaxon  then
    begin
      X1:=(LaBranche.XCible-epaisseurBranche-LaBranche.EspBG);
      X2:=(LaBranche.XCible+epaisseurBranche+LaBranche.EspBD);
    end
  else
    begin
      X1:=(LaBranche.PremierDescendant.XCible-epaisseurBranche-LaBranche.EspBG);
      X2:=(LaBranche.DernierDescendant.XCible+epaisseurBranche+LaBranche.EspBD);
    end;
//pointe du bas
  LePoint.Y:=Round((YTaxons+(X2-X1)/2)*65536);
  LePoint.X:=Round((X1+X2)/2*65536);//Round(LaBranche.XCible*65536);
  //Contour[0]:=LePoint;
  ContourBoite.Add(LePoint);
//point niveau taxon droit
  LePoint.Y:=Round(YTaxons*65536);
  LePoint.X:=Round(X2*65536);
  //Contour[1]:=LePoint;
  ContourBoite.Add(LePoint);
//point haut droit
  if n>=0 then
    YT:=BaseHautBoite-SupYNiv[n]
    //YT:=BaseHautBoite-(n*EspBoites)-SupYNiv[n]
  else
    YT:=BaseHautBoite-SupYNiv[0];
    //YT:=BaseHautBoite-(n*EspBoites)-SupYNiv[0];
  LePoint.Y:=Round(YT*65536);
  PointB:=LePoint;
  PointB.Y:=Round((YT+HauteurTexte+4)*65536);
  //Contour[2]:=LePoint;
  ContourBoite.Add(LePoint);
  Bandeau.Add(PointB);
  Bandeau.Add(LePoint);
//point haut gauche
  LePoint.X:=Round(X1*65536);
  PointB.X:=LePoint.X;
  ContourBoite.Add(LePoint);
  Bandeau.Add(LePoint);
  Bandeau.Add(PointB);
//point niveau taxons  gauche
  LePoint.Y:=Round(YTaxons*65536);
  //Contour[4]:=LePoint;
  ContourBoite.Add(LePoint);
  //*********** ecrire le nom ou un nombre si besoin
  if AfficherNomsGroupes and((Not BoitesSansTaxons) or LaBranche.BoiteQuiInclutUneAutre) then
    begin
      Bandeau.DrawFill(Lebitmap,LaBranche.CouleurBoite);
      Texte:=LaBranche.NomGroupe;
      if Texte='' then Texte:=StrGroupeNonNomme;
      if Lebitmap.TextWidth(Texte)>(X2-X1-2*EspBoites) then
        begin
          inc(NumeroGroupe);
          Texte:=IntToStr(NumeroGroupe);
          LaBranche.NumeroGroupe:=NumeroGroupe;
          LaBranche.PositionNumero.Top:=YT+1;
          LaBranche.PositionNumero.Bottom:=YT+3+Lebitmap.TextHeight(Texte);
        end
      else
        LaBranche.NumeroGroupe:=-1;
      if LaBranche.NomGroupe='' then
        begin
          LaBranche.PositionEtiqGroupe.Top:=YT+1;
          LaBranche.PositionEtiqGroupe.Bottom:=YT+3+Lebitmap.TextHeight(Texte);
        end;

      XT:=Round(X1+(X2-X1-Lebitmap.TextWidth(Texte))/2);
      if LaBranche.NumeroGroupe>-1 then
        begin
          LaBranche.PositionNumero.Left:=XT-2;
          LaBranche.PositionNumero.Right:=XT+Lebitmap.TextWidth(Texte)+2;
        end;
      if LaBranche.NomGroupe='' then
        begin
          LaBranche.PositionEtiqGroupe.Left:=XT-2;
          LaBranche.PositionEtiqGroupe.Right:=XT+Lebitmap.TextWidth(Texte)+2;
        end;


      LeBitmap.Textout(XT,YT+2,Texte);
    end;

  OutLine:=ContourBoite.Outline;
  OutLine:=OutLine.Grow(65536,0.99);
  OutLine.DrawFill(Lebitmap,LaBranche.CouleurBoite);
  if LaBranche.CouleurSurBoite<>0 then
    begin
      OutLine2:=ContourBoite.Grow(-65536*2,0.99).Outline;
      OutLine2:=OutLine2.Grow(65536,0.99);
      OutLine2.DrawFill(Lebitmap,LaBranche.CouleurSurBoite);
      OutLine2.Free;
    end;
  ContourBoite.Free;
  OutLine.Free;
end;
Procedure TArbreDate.TraceBrancheCladeSur(LeBitMap:TBitmap32;CouleurHaut,CouleurBas:TColor32;HautGrise,BasGrise:Boolean;LePointHG,LePointHD,LePointMG,LePointMD,LePointBG,LePointBD:TFixedPoint);
Var
  Contour:TArrayOfFixedPoint;
begin
  SetLength(Contour,4);
  Contour[0]:=LePointHG;
  Contour[1]:=LePointHD;
  MonRemplissage.pattern:=MonPointille;
  if BranchesCreuses then
    begin
      Contour[2]:=LePointBD;
      Contour[3]:=LePointBG;
      PolylineXS(LeBitMap,Contour,clBlack32,true,nil); //LaBranche.AncetreDirect.CouleurTrait
    end
  else
    begin
      Contour[2]:=LePointMD;
      Contour[3]:=LePointMG;
      if HautGrise then
        PolygonXS(LeBitMap,Contour,MonRemplissage,pfAlternate,am32times,nil)
      else
        PolygonXS(LeBitMap,Contour,CouleurHaut,pfAlternate,am32times,nil);
      Contour[0]:=LePointMG;
      Contour[1]:=LePointMD;
      Contour[2]:=LePointBD;
      Contour[3]:=LePointBG;
      if BasGrise then
        PolygonXS(LeBitMap,Contour,MonRemplissage,pfAlternate,am32times,nil)
      else
        PolygonXS(LeBitMap,Contour,CouleurBas,pfAlternate,am32times,nil);
      Contour[0]:=LePointHG;
      Contour[1]:=LePointHD;
      PolylineXS(LeBitMap,Contour,clBlack32,true,nil); //LaBranche.AncetreDirect.CouleurTrait
    end;
end;
Procedure TArbreDate.DessineArbreCladeSur(LeBitMap:TBitmap32);
Var
  LaBranche:TBranche;
  n,i,nv:integer;
  CouleurHaut,CouleurBas:TColor32;
  LePointHG,LePointHD,LePointMG,LePointMD,LePointBG,LePointBD:TFixedPoint; //LePoint,
  BaseHautBoite:integer;
  HautGrise,BasGrise:Boolean;
begin
  //If Attente then exit;
  //Attente:=True;
  HautGrise:=False;
  BasGrise:=False;
  If Length(Branches)>0 then
    CalculeTailleArbreClade(LeBitMap);
  LeBitMap.Clear($FFFFFFFF);
  If Length(Branches)=0 then exit;
  //SetLength(Contour,4);
  //BaseHautBoite:=YTaxons-LargeurEtiqTaxons-MargeV;
  BaseHautBoite:=YTaxons;
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche<>Nil then
        if LaBranche.EstUnTaxon then
          begin
            if ((Not DessinerBoites)or(Not BoitesSansTaxons)) or LaBranche.TracerBoite then   //(LaBranche.NomGroupe<>'')
              begin
                LaBranche.Curseurs.Positionne(LaBranche.XCible,LaBranche.YCible);
                LaBranche.Curseurs.Cursor:=CrHandPoint;
                if LaBranche.AncetreDirect<>Nil then
                  begin
                    LePointHG.Y:=Round(LaBranche.YCible*65536);
                    LePointHG.X:=Round((LaBranche.XCible-epaisseurBranche)*65536);
                    LePointHD.Y:=LePointHG.Y;
                    LePointHD.X:=Round((LaBranche.XCible+epaisseurBranche)*65536);
                    LePointBD.Y:=Round(LaBranche.AncetreDirect.YCible*65536);
                    LePointBD.X:=Round((LaBranche.AncetreDirect.XCible+epaisseurBranche)*65536);
                    LePointMD.Y:=(LePointHD.Y+LePointBD.Y)Div 2;
                    LePointMD.X:=(LePointHD.X+LePointBD.X)Div 2;
                    LePointBG.Y:=LePointBD.Y;
                    LePointBG.X:=Round((LaBranche.AncetreDirect.XCible-epaisseurBranche)*65536);
                    LePointMG.Y:=LePointMD.Y;//(LePointHG.Y+LePointBD.Y)Div 2;
                    LePointMG.X:=(LePointHG.X+LePointBG.X)Div 2;
                    CouleurHaut:=LaBranche.CouleurTrait;
                    CouleurBas:=LaBranche.AncetreDirect.CouleurTrait;
                    HautGrise:=LaBranche.Grise;
                    BasGrise:=LaBranche.AncetreDirect.Grise;
                    TraceBrancheCladeSur(LeBitMap,CouleurHaut,CouleurBas,HautGrise,BasGrise,LePointHG,LePointHD,LePointMG,LePointMD,LePointBG,LePointBD);
                  end
                else
                  begin
                    LePointHG.Y:=Round(LaBranche.YCible*65536);
                    LePointHG.X:=Round((LaBranche.XCible-epaisseurBranche)*65536);
                    LePointHD.Y:=LePointHG.Y;
                    LePointHD.X:=Round((LaBranche.XCible+epaisseurBranche)*65536);
                    LePointBD.Y:=Round((LaBranche.YCible+LongueurRacine)*65536);
                    LePointBD.X:=Round((LaBranche.XCible+epaisseurBranche)*65536);
                    LePointMD.Y:=(LePointHD.Y+LePointBD.Y)Div 2;
                    LePointMD.X:=LePointBD.X;
                    LePointBG.Y:=LePointBD.Y;
                    LePointBG.X:=Round((LaBranche.XCible-epaisseurBranche)*65536);
                    LePointMG.Y:=LePointMD.Y;
                    LePointMG.X:=LePointHG.X;
                    CouleurHaut:=LaBranche.CouleurTrait;
                    CouleurBas:=CouleurHaut;
                    //CouleurBas:=CouleurTraitRacine;
                    HautGrise:=LaBranche.Grise;
                    BasGrise:=False;
                    TraceBrancheCladeSur(LeBitMap,CouleurHaut,CouleurBas,HautGrise,BasGrise,LePointHG,LePointHD,LePointMG,LePointMD,LePointBG,LePointBD);
                  end;
                if DessinerBoites and LaBranche.TracerBoite then
                  begin
                    if LaBranche.AncetreDirect<>Nil then
                      nv:=LaBranche.AncetreDirect.Niveau-1
                    else
                      nv:=NombreNiveaux-1;
                    DessineBoiteClade(BaseHautBoite,nv,LaBranche,LeBitMap);
                  end;

              end;
          end;
    end;
  For n:=1 to NombreNiveaux-1 do
    begin
      For i:=0 to Length(Branches)-1 do
        begin
          LaBranche:=Branches[i];
          if (LaBranche<>Nil) and (LaBranche.Niveau=n) then
            begin
              if LaBranche.AncetreDirect<>Nil then
                begin
                  LePointHG.Y:=Round(LaBranche.YCible*65536);
                  LePointHG.X:=Round((LaBranche.XCible-epaisseurBranche)*65536);
                  LePointHD.Y:=LePointHG.Y;
                  LePointHD.X:=Round((LaBranche.XCible+epaisseurBranche)*65536);
                  LePointBD.Y:=Round(LaBranche.AncetreDirect.YCible*65536);
                  LePointBD.X:=Round((LaBranche.AncetreDirect.XCible+epaisseurBranche)*65536);
                  LePointMD.Y:=(LePointHD.Y+LePointBD.Y)Div 2;
                  LePointMD.X:=(LePointHD.X+LePointBD.X)Div 2;
                  LePointBG.Y:=LePointBD.Y;
                  LePointBG.X:=Round((LaBranche.AncetreDirect.XCible-epaisseurBranche)*65536);
                  LePointMG.Y:=LePointMD.Y;//(LePointHG.Y+LePointBD.Y)Div 2;
                  LePointMG.X:=(LePointHG.X+LePointBG.X)Div 2;
                  CouleurHaut:=LaBranche.CouleurTrait;
                  CouleurBas:=LaBranche.AncetreDirect.CouleurTrait;
                  HautGrise:=LaBranche.Grise;
                  BasGrise:=LaBranche.AncetreDirect.Grise;
                  TraceBrancheCladeSur(LeBitMap,CouleurHaut,CouleurBas,HautGrise,BasGrise,LePointHG,LePointHD,LePointMG,LePointMD,LePointBG,LePointBD);
                end
              else
                begin
                  LePointHG.Y:=Round(LaBranche.YCible*65536);
                  LePointHG.X:=Round((LaBranche.XCible-epaisseurBranche)*65536);
                  LePointHD.Y:=LePointHG.Y;
                  LePointHD.X:=Round((LaBranche.XCible+epaisseurBranche)*65536);
                  LePointBD.Y:=Round((LaBranche.YCible+LongueurRacine)*65536);
                  LePointBD.X:=Round((LaBranche.XCible+epaisseurBranche)*65536);
                  LePointMD.Y:=(LePointHD.Y+LePointBD.Y)Div 2;
                  LePointMD.X:=LePointBD.X;
                  LePointBG.Y:=LePointBD.Y;
                  LePointBG.X:=Round((LaBranche.XCible-epaisseurBranche)*65536);
                  LePointMG.Y:=LePointMD.Y;
                  LePointMG.X:=LePointHG.X;
                  CouleurHaut:=LaBranche.CouleurTrait;
                  CouleurBas:=CouleurTraitRacine;
                  HautGrise:=LaBranche.Grise;
                  BasGrise:=False;
                  TraceBrancheCladeSur(LeBitMap,CouleurHaut,CouleurBas,HautGrise,BasGrise,LePointHG,LePointHD,LePointMG,LePointMD,LePointBG,LePointBD);
                end;
              if LaBranche.Ancetre<>Nil then
                begin
                  LaBranche.Ancetre.Cursor:=CrHandPoint;
                  LaBranche.Ancetre.Positionne(LaBranche.XCible,LaBranche.YCible);
                end;
              if DessinerBoites and LaBranche.TracerBoite then
                begin
                  if LaBranche.AncetreDirect<>Nil then
                    nv:=LaBranche.AncetreDirect.Niveau-1
                  else
                    nv:=NombreNiveaux-1;
                  DessineBoiteClade(BaseHautBoite,nv,LaBranche,LeBitMap);
                end;
            end;
        end;
    end;
  Attente:=False;
  Height:=LeBitMap.Height;
end;

Function TArbreDate.AgeToPosX(LAge:integer):integer;
begin
  if MaxiAge>MiniAge then
    begin
      CoeffAgeToPosX:=(PosXMaxiAge-PosXMiniAge)/(MaxiAge-MiniAge);
      Result:=PosXMiniAge+Round((LAge-MiniAge)*CoeffAgeToPosX);// /(MaxiAge-MiniAge)*(PosXMaxiAge-PosXMiniAge));
    end
  else
    begin
      CoeffAgeToPosX:=0;
      Result:=-1;
    end;
end;
Function TArbreDate.PosXToAge(LaPosX:integer):integer;
begin
  if PosXMaxiAge<PosXMiniAge then
    begin
      CoeffPosXToAge:=(MaxiAge-MiniAge)/(PosXMaxiAge-PosXMiniAge);
      Result:=MiniAge+Round((LaPosX-PosXMiniAge)*CoeffPosXToAge);
    end
  else
    begin
      CoeffPosXToAge:=0;
      Result:=-1;
    end;
end;
procedure TArbreDate.Redessine;
begin
  if Bitmap=Nil then exit;
  BitMap.Width:=ClientWidth;
  BitMap.Height:=ClientHeight;
  //CalculeTailleArbreDate(Bitmap);
  //
  if TypeDArbre=0 then DessineArbreDateSur(Bitmap)
  else DessineArbreCladeSur(Bitmap);
  ClientHeight:=BitMap.Height;
  ClientWidth:=Bitmap.Width;
  Refresh;
  if Assigned(AjusterInfo) Then AjusterInfo(Self);
  Attente:=False;
end;
procedure TArbreDate.VerifiePosAges;
Var
  i,j,n:integer;
  a:integer;
  LeRectangle:TFloatRect;
begin
{  For i:=0 to Length(Branches)-1 do
    begin
      if Branches[i].EstUnTaxon then
        begin
          If Branches[i].AncetreDirect<>Nil then
            begin
              if (Branches[i].AncetreDirect.PosAgeDisp<(Branches[i].AgeApp+EcartAge)) then
                begin
                  Branches[i].AncetreDirect.PosAgeDisp:=Branches[i].AgeApp+EcartAge;
                  if Branches[i].AncetreDirect.Ancetre<>Nil then
                    begin
                      LeRectangle:=Branches[i].AncetreDirect.Ancetre.Location;
                      LeRectangle.Left:=AgeToPosX(Branches[i].AncetreDirect.PosAgeDisp)+Branches[i].AncetreDirect.Ancetre.Rayon;
                      LeRectangle.Right:=LeRectangle.Left+2*Branches[i].AncetreDirect.Ancetre.Rayon;
                    end;
                end;
              Branches[i].AncetreDirect.AgeMin:=Branches[i].AgeApp;
            end;
        end;
    end;
  //Vrifications par niveaux
  For j:=1 to NombreNiveaux-2 do
    For i:=0 to Length(Branches)-1 do
      if Branches[i].niveau=j then
        begin
          If (Branches[i].AncetreDirect<>Nil) and (Branches[i].AncetreDirect.PosAgeDisp<(Branches[i].PosAgeDisp+EcartAge)) then
            begin
              Branches[i].AncetreDirect.PosAgeDisp:=Branches[i].PosAgeDisp+EcartAge;
              if Branches[i].AncetreDirect.Ancetre<>Nil then
                begin
                  LeRectangle:=Branches[i].AncetreDirect.Ancetre.Location;
                  LeRectangle.Left:=AgeToPosX(Branches[i].AncetreDirect.PosAgeDisp)+Branches[i].AncetreDirect.Ancetre.Rayon;
                  LeRectangle.Right:=LeRectangle.Left+2*Branches[i].AncetreDirect.Ancetre.Rayon;
                end;
            end;
        end;
}
  ChercheNombreNiveaux;
  For n:=1 to NombreNiveaux do
    begin
      for i:=0 to Length(Branches)-1 do
        begin
          if (Branches[i]<>Nil) and (Branches[i].Niveau=n) then
            begin
              if Length(Branches[i].Descendants)>0 then
                begin
                  a:=0;
                  For j:=0 to Length(Branches[i].Descendants)-1 do
                    begin
                      if a<Branches[i].Descendants[j].PosAgeApp then
                        a:=Branches[i].Descendants[j].PosAgeApp;
                    end;
                  if a>0 then
                    begin
                      Branches[i].PosAgeDisp:=a+2*EcartAge;
                      Branches[i].PosAgeApp:=a+2*EcartAge;
                      Branches[i].AgeDisp:=a+2*EcartAge;
                      Branches[i].AgeApp:=a+2*EcartAge;
                      if Branches[i].Ancetre<>Nil then
                        begin
                          LeRectangle:=Branches[i].Ancetre.Location;
                          LeRectangle.Left:=AgeToPosX(Branches[i].PosAgeDisp)+Branches[i].Ancetre.Rayon;
                          LeRectangle.Right:=LeRectangle.Left+2*Branches[i].Ancetre.Rayon;
                        end;
                      Branches[i].AgeMin:=Branches[i].PosAgeApp;
                    end;
                end;
            end;
        end;
    end;
end;
Procedure TArbreDate.DessineArbreDateSur(LeBitMap:TBitmap32);
Var
  i,n,j,k,nv:integer;
  X,X1,X2,Y,Y1,Y2:integer;
  LaBranche:TBranche;
  Segment:integer;
  XText,YText:integer;
  Texte:string;
  ordreg:real;
  ordregE:integer;
  deltaAge:integer;
  nbG:integer;
begin
  //DessinerBoites:=True;  //pour test
  //AfficherNomsGroupes:=True; //pour test
  CalculeTailleArbreDate(LeBitMap);
  ClientHeight:=BitMap.Height;

  If Attente then exit;
  Attente:=True;
  //XText:=0;
  //YText:=LeBitMap.Height-LeBitMap.TextHeight('T');
  LeBitMap.Width:=Width;
  LeBitMap.Clear($FFFFFFFF);
  PrecisionDate:=0;
  if EchelleMa and ((MaxiAge-MiniAge)<100000)then PrecisionDate:=1;
  if EchelleMa and ((MaxiAge-MiniAge)<10000)then PrecisionDate:=2;
  Segment:=(PosXMiniAge-PosXMaxiAge) div NombreNiveaux;
  SansAncetre:=True;
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if (LaBranche<>Nil) then
        begin
          if (LaBranche.AncetreDirect=Nil) then  //racine
            begin
              X1:=0;
              if LaBranche.PosAgeDisp>=0 then
                X2:=AgeToPosX(LaBranche.PosAgeDisp)
              else
                begin
                  X2:=PosXMiniAge-LaBranche.Niveau*segment;
                  LaBranche.PosAgeDisp:=PosXToAge(X2);
                end;
              Y:=LaBranche.YBranche;//LaBranche.Y+(LaBranche.Hauteur div 2);
              LaBranche.Ycible:=Y;
              LaBranche.XCible:=X2;
              if (Length(LaBranche.Descendants)>0) then
                begin
                  LeBitMap.HorzLineS(X1,Y,X2,LaBranche.CouleurTrait);
                  For k:=1 to (epaisseurBranche  div 2) do
                    begin
                     LeBitMap.HorzLineS(X1,Y+k,X2,LaBranche.CouleurTrait);
                     LeBitMap.HorzLineS(X1,Y-k,X2,LaBranche.CouleurTrait);
                    end;
                end;
            end
          else
            begin
              SansAncetre:=False;
              if LaBranche.AncetreDirect.PosAgeDisp>=0 then
                X1:=AgeToPosX(LaBranche.AncetreDirect.PosAgeDisp)
              else
                begin
                  X1:=PosXMiniAge-LaBranche.AncetreDirect.Niveau*segment;
                  LaBranche.AncetreDirect.PosAgeDisp:=PosXToAge(X1);
                end;
              if LaBranche.PosAgeDisp>=0 then
                X2:=AgeToPosX(LaBranche.PosAgeDisp)
              else
                begin
                  X2:=PosXMiniAge-LaBranche.Niveau*segment;
                  LaBranche.PosAgeDisp:=PosXToAge(X2);
                end;
              Y:=LaBranche.YBranche;//LaBranche.Y+(LaBranche.Hauteur div 2);
              LaBranche.Ycible:=Y;
              LaBranche.XCible:=X2;
              LeBitMap.HorzLineS(X1,Y,X2,LaBranche.CouleurTrait);
              For k:=1 to (epaisseurBranche  div 2) do
                begin
                 LeBitMap.HorzLineS(X1,Y+k,X2,LaBranche.CouleurTrait);
                 LeBitMap.HorzLineS(X1,Y-k,X2,LaBranche.CouleurTrait);
                end;
            end;
          if Length(LaBranche.Descendants)>0 then
            begin
              Y1:=LaBranche.Y;
              Y2:=LaBranche.Y+LaBranche.Hauteur;
              LeBitMap.VertLineS(X2,Y1,Y2,LaBranche.CouleurTrait);
              For k:=1 to (epaisseurBranche  div 2) do
                begin
                 LeBitMap.VertLineS(X2+k,Y1,Y2,LaBranche.CouleurTrait);
                 LeBitMap.VertLineS(X2-k,Y1,Y2,LaBranche.CouleurTrait);
                end;
            end
          else
            begin
              //LeBitMap.TextOut(AgeToPosX(LaBranche.PosAgeDisp)+MargeH,LaBranche.Y+MargeV,LaBranche.EtiqTaxon);
            end;
          if LaBranche.Ancetre<>Nil then
            begin
              LaBranche.Ancetre.Positionne(LaBranche.XCible,LaBranche.Ycible);
              {Texte:=LaBranche.Nom+', X='+IntToStr(LaBranche.XCible)+', Y='+IntToStr(LaBranche.YCible)+' - ';
              LeBitMap.Textout(XText,YText,Texte);
              XText:=XText+LeBitMap.TextWidth(Texte); }
            end;
          if LaBranche.Curseurs<>Nil then
            LaBranche.Curseurs.Positionne(LaBranche.XCible,LaBranche.Ycible);
          if DessinerBoites and LaBranche.TracerBoite then
            begin
              if LaBranche.AncetreDirect<>Nil then
                nv:=LaBranche.AncetreDirect.Niveau-1
              else
                nv:=NombreNiveaux-1;
                  DessineBoiteDate(nv,LaBranche,LeBitMap);
            end;
        end;
    end;
  // trac de l'axe du temps
  LeBitMap.HorzLineS(5,YAxetemps,AgeToPosX(0)+10,ClBlack32);
  LeBitMap.LineS(AgeToPosX(0)+8,YAxetemps,AgeToPosX(0)+4,YAxetemps-4,ClBlack32);
  LeBitMap.LineS(AgeToPosX(0)+8,YAxetemps,AgeToPosX(0)+4,YAxetemps+4,ClBlack32);
  Texte:='Temps ';
  if EchelleMa then Texte:=Texte+'(Ma)' else Texte:=Texte+'(annes)';
  YText:=YAxetemps-(LeBitMap.TextHeight('T') div 2);
  LeBitMap.Textout(AgeToPosX(0)+15,YText,Texte);
  // trac des graduations
  ordreg:=Log10(MaxiAge);
  ordregE:=Trunc(ordreg);
  deltaAge:=Round(Power(10,ordregE));
  if (ordreg-ordreg)<0.8 then
    deltaAge:=DeltaAge Div 2;
  nbG:=MaxiAge div deltaAge;
  YText:=YAxetemps+MargeV;
  For i:=0 to nbG do
    begin
      LeBitMap.VertLineS(AgeToPosX(i*deltaAge),YAxetemps,YAxetemps+3,ClBlack32);
      Texte:=TranscritAge(i*deltaAge,True,False,'');
      Xtext:=AgeToPosX(i*deltaAge)-(LeBitMap.TextWidth(Texte) div 2);
      if XText<0 then XText:=0;
      LeBitMap.Textout(XText,YText,Texte);
    end;
  if AfficherStrati then
    DessineEchelleStrati(LeBitmap);
  if LeNouvCaractere<>Nil then
    DessineLegendeArbreDate(LeBitmap);
//  YText:=YZoneInfo+MargeV;
//  LeBitMap.HorzLineS(0,YZoneInfo,LeBitMap.Width,ClBlack32);
  if CurseursDeplaces<>Nil then
    begin
      if CurseursDeplaces.DeuxCurseurs and(CurseursDeplaces.Branche.PosAgeApp>0) then
        begin
          if SimpleDiagramme then
            Texte:=CurseursDeplaces.Branche.EtiqTaxon+' - sur le diagramme : de '
          else
            Texte:=CurseursDeplaces.Branche.EtiqTaxon+' - sur l''arbre : de ';
          Texte:=Texte+TranscritAge(CurseursDeplaces.Branche.PosAgeApp,True,True,'l''')
             +'  '+TranscritAge(CurseursDeplaces.Branche.PosAgeDisp,True,True,'l''')
             +' - dans le tableau : de '
             +TranscritAge(CurseursDeplaces.Branche.AgeApp,True,True,'l''')
             +'  '+TranscritAge(CurseursDeplaces.Branche.AgeDisp,True,True,'l''');
        end
      else
        begin
          if SimpleDiagramme then
            Texte:=CurseursDeplaces.Branche.EtiqTaxon+' - date : - sur le diagramme : '+TranscritAge(CurseursDeplaces.Branche.PosAgeDisp,True,True,'')
          else
            Texte:=CurseursDeplaces.Branche.EtiqTaxon+' - date : - sur l''arbre : '+TranscritAge(CurseursDeplaces.Branche.PosAgeDisp,True,True,'');
          Texte:=Texte+' - dans le tableau : '+TranscritAge(CurseursDeplaces.Branche.AgeDisp,True,True,'');
        end;
      TexteInfo:=Texte;
      if EffacerCurseursDeplaces then
        begin
          CurseursDeplaces:=Nil;
          EffacerCurseursDeplaces:=False;
        end;
    end
  else if AncetreDeplace<>Nil then
    begin
      try
        if SimpleDiagramme then
          Texte:=AncetreDeplace.Branche.Nom+' - date estime (sur le diagramme) : '
        else
          Texte:=AncetreDeplace.Branche.Nom+' - date estime (sur l''arbre) : ';
        
        Texte:=Texte+TranscritAge(AncetreDeplace.Branche.PosAgeDisp,True,True,'l''');
        TexteInfo:=Texte;
      except
        Texte:='Erreur 1';
      end;
    end;
  //LeBitMap.Textout(5,YText,TexteInfo);
end;
Procedure TArbreDate.DessineLegendeArbreDate(LeBitmap:TBitmap32);
Var
  i,margeH,margeG,decX,decY:integer;
  texte:string;
  Xi:Array[0..4] of integer;
  Yi:Array[0..4] of integer;
  textel:Array[1..2]of string;
  nl,fl1:integer;
begin
  If LeNouvCaractere<>Nil then
    begin
      decX:=12;
      decY:=5;
      nl:=1;
      fl1:=0;
      textel[1]:=LeNouvCaractere.Nom + ' :  ';
      For i:=0 to LeNouvCaractere.ListeEtats.Count-1 do
        begin
          if i=0 then Yi[i]:=YLegende
          else Yi[i]:=Yi[i-1];
          Xi[i]:=LeBitmap.TextWidth(textel[nl]);
          texte:=textel[nl]+'         '+LeNouvCaractere.ListeEtats[i];
          if LeBitmap.TextWidth(texte)>LeBitmap.Width then
            begin
              if nl=2 then
                exit
              else
                begin
                  inc(nl);
                  Xi[i]:=0;
                  Yi[i]:=YLegende+HauteurTaxon;
                  textel[nl]:='         '+LeNouvCaractere.ListeEtats[i];
                  fl1:=i-1;
                end;
            end
          else
            textel[nl]:=texte;
        end;

      margeG:=(LeBitmap.Width-LeBitmap.TextWidth(textel[1]))div 2;
      margeH:=0;
      if nl=1 then
        begin
          margeH:=5;
          fl1:=LeNouvCaractere.ListeEtats.Count-1;
        end;
      LeBitMap.Font.Color:=clBlack;
      LeBitMap.Textout(margeG,margeH+YLegende,textel[1]);
      For i:=0 to fl1 do
        begin
          LeBitMap.HorzLine(margeG+Xi[i]+decX,Yi[i]+decY+margeH,margeG+Xi[i]+decX+10,Color32(LeNouvCaractere.CouleursEtats[i].CouleurFond));
          LeBitMap.HorzLine(margeG+Xi[i]+decX,Yi[i]+decY+1+margeH,margeG+Xi[i]+decX+10,Color32(LeNouvCaractere.CouleursEtats[i].CouleurFond));
          LeBitMap.HorzLine(margeG+Xi[i]+decX,Yi[i]+decY+2+margeH,margeG+Xi[i]+decX+10,Color32(LeNouvCaractere.CouleursEtats[i].CouleurFond));
        end;
      if nl=2 then
        begin
          margeG:=(LeBitmap.Width-LeBitmap.TextWidth(textel[2]))div 2;
          LeBitMap.Textout(margeG,margeH+YLegende+HauteurTaxon,textel[2]);
          For i:=fl1+1 to LeNouvCaractere.ListeEtats.Count-1 do
            begin
              LeBitMap.HorzLine(margeG+Xi[i]+decX,Yi[i]+decY+margeH,margeG+Xi[i]+decX+10,Color32(LeNouvCaractere.CouleursEtats[i].CouleurFond));
              LeBitMap.HorzLine(margeG+Xi[i]+decX,Yi[i]+decY+1+margeH,margeG+Xi[i]+decX+10,Color32(LeNouvCaractere.CouleursEtats[i].CouleurFond));
              LeBitMap.HorzLine(margeG+Xi[i]+decX,Yi[i]+decY+2+margeH,margeG+Xi[i]+decX+10,Color32(LeNouvCaractere.CouleursEtats[i].CouleurFond));
            end;
        end;
    end;
end;

Procedure TArbreDate.DessineEchelleStrati(LeBitmap:TBitmap32);
Var
  i,X,X1,X2,Y1,Y2,l:integer;
  Texte:string;
  CatItemStrati:TTypeItemStrati;
  Couleur:TColor32;
begin
  Y1:=YEchellestrati;
  HauteurItemsEchelleStrati:=HauteurTaxon-MargeV;
  Y2:=Y1+HauteurItemsEchelleStrati;
  For CatItemStrati:=Epoque Downto Ere do //(Eon,Ere,Periode,Epoque,Etage);
    if AfficherCatStrati[CatItemStrati] then
      begin
        YItemsEchelleStrati[CatItemStrati]:=Y1;
        For i:=0 to Length(EchelleStrati)-1 do
          begin
            if EchelleStrati[i].TypeItem=CatItemStrati then
              begin
                if EchelleStrati[i].AgeFin<MaxiAge then
                  begin
                    X2:=AgeToPosX(EchelleStrati[i].AgeFin);
                    if (EchelleStrati[i].AgeDebut>0)and(EchelleStrati[i].AgeDebut<MaxiAge) then
                      X1:=AgeToPosX(EchelleStrati[i].AgeDebut)
                    else
                      X1:=AgeToPosX(MaxiAge);
                    Couleur:=EchelleStrati[i].Couleur;
                    LeBitmap. FillRectS(X1,Y1,X2,Y2,Couleur);
                    if (RedComponent(Couleur)+GreenComponent(Couleur)+BlueComponent(Couleur))>381 then
                      LeBitmap.Font.Color:=clBlack
                    else
                      LeBitmap.Font.Color:=clWhite;
                    Texte:=EchelleStrati[i].Nom;
                    if LeBitmap.TextWidth(Texte)>(X2-X1-2) then
                      Texte:=Texte[1];
                    l:=LeBitmap.TextWidth(Texte);
                    if (Texte<>'')and(l<=(X2-X1-2)) then
                      begin
                        X:=X1+((X2-X1-l)div 2);
                        LeBitMap.Textout(X,Y1+2,Texte);
                      end;
                  end;
              end;
          end;
        Y1:=Y2;
        Y2:=Y1+HauteurItemsEchelleStrati;
      end
    else
      begin
        YItemsEchelleStrati[CatItemStrati]:=-1;
      end;
  LeBitmap.Font.Color:=clBlack;
  If AfficherCrises then
    begin
      Y1:=YEchelleStrati;
      Y2:=YEchelleStrati+HauteurEchellestrati;
      For i:=0 to Length(Crises)-1 do
        begin
          X:=AgeToPosX(Crises[i].Age);
          LeBitMap.VertLineS(X,Y1,Y2,CouleurCrises);
          LeBitMap.VertLineS(X+1,Y1,Y2,CouleurCrises);
          LeBitMap.LineS(X+1,Y1,X+7,Y1+8,CouleurCrises);
          LeBitMap.LineS(X,Y1,X-6,Y1+8,CouleurCrises);
        end;
      Y1:=Y1+3;
      Y2:=Y2+3;
      X:=AgeToPosX(0)+20;
      LeBitMap.VertLineS(X,Y1,Y2,CouleurCrises);
      LeBitMap.VertLineS(X+1,Y1,Y2,CouleurCrises);
      LeBitMap.LineS(X+1,Y1,X+7,Y1+8,CouleurCrises);
      LeBitMap.LineS(X,Y1,X-6,Y1+8,CouleurCrises);
      LeBitMap.Textout(X+5,Y2-LeBitMap.TextHeight('T')+3,'Crise');
    end;
end;
Procedure TArbreDate.ReclasseBranches;
Var
  i,n:integer;
begin
  NumeroAncetre:=0;
  GetRacines;
  RAZPremDerDesc;

  SetLength(Branches,0);
  For i:=0 to Length(FRacines)-1 do
    begin
      n:=Length(Branches);
      SetLength(Branches,n+1);
      Branches[n]:=FRacines[i];
      FRacines[i].RepertorieBranches;
    end;
end;
Procedure TArbreDate.RAZPremDerDesc;
Var
  LaBranche:TBranche;
  i:integer;
begin
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche<>Nil then
        begin
          LaBranche.PremierDescendant:=Nil;
          LaBranche.DernierDescendant:=Nil;
        end;
    end;
end;

procedure TArbreDate.SupprimeLayer(LeLayer:TPositionedLayer);
Var
  i:integer;
begin
  For i:=0 to Layers.Count-1 do
    if Layers[i]=LeLayer then
      begin
        Layers.Delete(i);
        exit;
      end;
end;
Function TArbreDate.LabrancheDuTaxon(NomTaxon:string):TBranche;
Var
  i:integer;
  LaBranche:TBranche;
begin
  Result:=Nil;
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if (LaBranche<>Nil) and (LaBranche.Nom=NomTaxon) then
        begin
          Result:=LaBranche;
          Break;
        end;
    end;
end;
Function TArbreDate.LAncetreDesTaxons(NomsTaxons:string):TBranche;
Var
  i,j:integer;
  LaBranche:TBranche;
  ListeTaxonsBranche:TStringList;
  ListedesNomsTaxons:TStringList;
  correct:Boolean;
begin
  Result:=Nil;
  ListeTaxonsBranche:=TStringList.Create;
  ListedesNomsTaxons:=TStringList.Create;
  ListedesNomsTaxons.CommaText:=NomsTaxons;
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if (LaBranche<>Nil) then
        begin
          if ListedesNomsTaxons.Count>1 then
            begin
              ListeTaxonsBranche.CommaText:=LaBranche.TaxonsDescendants;
              if ListedesNomsTaxons.Count=ListeTaxonsBranche.Count then
                begin
                  Correct:=True;
                  For j:=0 to ListedesNomsTaxons.Count-1 do
                    begin
                      if ListeTaxonsBranche.IndexOf(ListedesNomsTaxons[j])<0 then
                        begin
                          correct:=False;
                          Break;
                        end;
                    end;
                  if Correct then
                    begin
                      Result:=LaBranche;
                      Break;
                    end;
                end;
            end
          else
            begin
              if Labranche.Nom=ListedesNomsTaxons[0] then
                begin
                  Result:=LaBranche;
                  Break;
                end;
            end;
        end;
    end;
  ListeTaxonsBranche.Free;
  ListedesNomsTaxons.Free;
end;

Procedure TArbreDate.PaintCurseursTaxon(Sender: TObject; Buffer: TBitmap32);
Var
  LesCurseurs:TCurseursLayer;
  X1,X2,Y,Y1,Y2,Yt,i,Xt,p:integer;
  Texte:string;
  BtmText:TBitMap32;
  htt:integer;
  Couleur:TColor32;
  Condition:Boolean;
begin
  LesCurseurs:=(Sender as TCurseursLayer);
  If LesCurseurs<>Nil then
    begin
      X1:=Round(LesCurseurs.Location.Left);
      X2:=X1+LesCurseurs.Largeur;
      Yt:=Round(LesCurseurs.Location.Top);
      Y:=Yt+LesCurseurs.HauteurTexte div 2;
      Y1:=Y-LesCurseurs.Hauteur div 2;
      Y2:=Y+LesCurseurs.Hauteur div 2;
      if TypeDArbre=0 then
        begin
          Buffer.VertLineS(X1,Y1,Y2,LesCurseurs.Couleur);
          Buffer.HorzLineS(X1,Y,X2,LesCurseurs.Couleur);
{          if SansAncetre then
            begin
              For i:=1 to epaisseurBranche do
                begin
                  Buffer.HorzLineS(X1,Y+i,X2,LesCurseurs.Couleur);
                  Buffer.HorzLineS(X1,Y-i,X2,LesCurseurs.Couleur);
                end;
            end
          else
            begin }
              For i:=1 to epaisseurBranche div 2 do
                begin
                  Buffer.HorzLineS(X1,Y+i,X2,LesCurseurs.Couleur);
                  Buffer.HorzLineS(X1,Y-i,X2,LesCurseurs.Couleur);
                end;
           { end;}
          Buffer.VertLineS(X2,Y1,Y2,LesCurseurs.Couleur);
          Texte:=LesCurseurs.Branche.EtiqTaxon;
          if Not ((TypeDarbre=0) and BoitesSansTaxons) then
            Buffer.Textout(X2+MargeH,Yt,Texte);
          if LesCurseurs=CurseursDeplaces then
            begin
              Buffer.SetStipple([clBlack32, clBlack32, clWhite32, clWhite32]);
              Buffer.StippleStep := 5;
              if CurseursDeplaces.DeuxCurseurs then
                begin
                  if CurseursDeplaces.CurseurD=1 then// dplacer le curseur de gauche
                    begin
                      Buffer.VertLineTSP(X1,Y2,YCurseur);
                      Texte:=TranscritAge(CurseursDeplaces.Branche.PosAgeApp,true,true,'');
                      Xt:=X1-(Buffer.TextWidth(Texte) div 2);
                      Buffer.TextOut(Xt,YCurseur+2,Texte);
                    end
                  else if CurseursDeplaces.CurseurD=2 then
                    begin
                      Buffer.VertLineTSP(X2,Y2,Ycurseur);
                      Texte:=TranscritAge(CurseursDeplaces.Branche.PosAgeDisp,true,true,'');
                      Xt:=X2-(Buffer.TextWidth(Texte) div 2);
                      Buffer.TextOut(Xt,YCurseur+2,Texte);
                    end
                  else
                    begin
                      Buffer.VertLineTSP(X1,Y2,YCurseur);
                      Buffer.VertLineTSP(X2,Y2,YCurseur);
                      Texte:='de '+TranscritAge(CurseursDeplaces.Branche.PosAgeApp,true,true,'')
                              +'  '+TranscritAge(CurseursDeplaces.Branche.PosAgeDisp,true,true,'');
                      Xt:=(X1+X2-Buffer.TextWidth(Texte)) div 2;
                      Buffer.TextOut(Xt,YCurseur+2,Texte);
                    end;
                end
              else
                begin
                  Buffer.VertLineTSP(X1,Y2,YCurseur);
                  Texte:=TranscritAge(CurseursDeplaces.Branche.PosAgeApp,true,true,'');
                  Xt:=X1-(Buffer.TextWidth(Texte) div 2);
                  Buffer.TextOut(Xt,YCurseur+2,Texte);
                end;
            end;
        end
      else
        begin
          condition:=True;
          if DessinerBoites and BoitesSansTaxons then
            begin
              if LesCurseurs.Branche.AncetreDirect<>Nil then
                begin
                  Condition:=(LesCurseurs.Branche=LesCurseurs.Branche.AncetreDirect.Descendants[0]);
                  Condition:=Condition or LesCurseurs.Branche.TracerBoite;
                end;
            end;
          if Condition then
            begin
              BtmText:=TBitMap32.Create;
              BtmText.Font.Assign(Bitmap.Font);
              htt:=BtmText.TextHeight('T');
              BtmText.Height:=htt;
              if LesCurseurs.EstExterne then
                Couleur:=CouleurExterne
              else if LesCurseurs.EstFossile then
                Couleur:=CouleurFossile
              else Couleur:=clBlack32;
              //BtmText.Textout(0,0,LesCurseurs.Branche.EtiqTaxon);
              if DessinerBoites and BoitesSansTaxons then
                begin
                  Texte:='';
                  If LesCurseurs.Branche.TracerBoite then
                    Texte:=LesCurseurs.Branche.NomGroupe
                  else if LesCurseurs.Branche.AncetreDirect<>Nil then
                    Texte:=LesCurseurs.Branche.AncetreDirect.NomGroupe;
                  if Texte='' then
                    Texte:=StrGroupeNonNomme;
                  p:=Pos('=',Texte);
                  if p>0 then
                    begin
                      if p<(length(Texte) div 2) then
                        Delete(Texte,p,Length(Texte)-p+1)
                      else
                        Delete(Texte,1,p);
                    end;
                end
              else
                Texte:=LesCurseurs.Branche.EtiqTaxon;
              BtmText.Width:=BtmText.TextWidth(Texte);// LesCurseurs.LargeurTexte-MargeV;
              BtmText.Clear($00FFFFFF);
              //BtmText.Font.Style:=[fsBold];
              if DessinerBoites and BoitesSansTaxons then
                BtmText.Font.Color:=clBlack
              else
                BtmText.Font.Color:=WinColor(Couleur);
              //BtmText.RenderText(0,0,Texte,1,Couleur);
              BtmText.TextOut(0,0,Texte);
              BtmText.Rotate270(nil);
              //Buffer.Draw(LesCurseurs.Branche.XCible-htt div 2,LesCurseurs.Branche.YCible-MargeV-LesCurseurs.LargeurTexte,BtmText);
              Buffer.Draw(LesCurseurs.Branche.XCible-htt div 2,LesCurseurs.Branche.YCible-BtmText.Height-MargeV,BtmText);
              BtmText.Free;
            end;
        end;
    end;
end;
Procedure TArbreDate.PaintAncetre(Sender: TObject; Buffer: TBitmap32);
Var
  LAncetre:TAncetreLayer;
  X1,Y1,X2,Y2,Xt:integer;
  Texte:string;
begin
  LAncetre:=(Sender as TAncetreLayer);
  If LAncetre<>Nil then
    begin
      X1:=Round(LAncetre.Location.Left);
      Y1:=Round(LAncetre.Location.Top);
      X2:=X1+2*LAncetre.rayon;
      Y2:=Y1+2*LAncetre.rayon;
      Buffer.FillRectS(X1,Y1,X2,Y2,LAncetre.Couleur);
      Buffer.FrameRectS(X1,Y1,X2,Y2,clBlack32);
      //TraceCercleSur(Buffer,X1+LAncetre.rayon,Y1+LAncetre.rayon,LAncetre.rayon,LAncetre.Couleur,clBlack32);
      if LAncetre=AncetreDeplace then
        begin
          Buffer.SetStipple([clBlack32, clBlack32, clWhite32, clWhite32]);
          Buffer.StippleStep := 5;
          Buffer.VertLineTSP(X1+LAncetre.rayon,Y2,YCurseur);
          Texte:=TranscritAge(LAncetre.Branche.PosAgeDisp,true,true,'');
          Xt:=X1+LAncetre.rayon-(Buffer.TextWidth(Texte) div 2);
          Buffer.TextOut(Xt,YCurseur+2,Texte);
        end;
    end;
end;

procedure TArbreDate.MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
begin
  if TypeDArbre=0 then ArbreDateMouseDown (Button,Shift,X,Y,Layer)
  else ArbreCladeMouseDown (Button,Shift,X,Y,Layer);
  inherited MouseDown(Button,Shift, X, Y, Layer);
end;
procedure TArbreDate.ArbreCladeMouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
Var
  AncetreClique:TAncetreLayer;
  TaxonClique:TCurseursLayer;
  LaBranche:TBranche;
  SurLeNoeud:Boolean;
begin
  X0Souris:=X;
  Y0Souris:=Y;
  If (Layer is TAncetreLayer) and ModeInversion then
    begin
      AncetreClique:=Layer as TAncetreLayer;
      if AncetreClique<>Nil then
        begin
          If AncetreClique.Branche<>Nil then
            begin
              AncetreClique.Branche.InverseDescendants;
              Redessine;
            end;
        end;
    end
  Else If (Layer is TAncetreLayer) and (Not EstModifiable) then
    begin
      AncetreClique:=Layer as TAncetreLayer;
      if AncetreClique<>Nil then
        begin
          X0Souris:=X;
          AncetreClique.Cursor:=CrHandPoint;
          BrancheCliquee:=AncetreClique.Branche;
          NoeudClique:=True;
          if Assigned(UneBrancheEstCliquee) then UneBrancheEstCliquee(Self);
        end;
    end
  Else if  (Layer is TCurseursLayer) and (Not EstModifiable) then
    begin
      TaxonClique:=Layer as TCurseursLayer;
      if TaxonClique<>Nil then
        begin
          X0Souris:=X;
          TaxonClique.Cursor:=CrHandPoint;
          BrancheCliquee:=TaxonClique.Branche;
          NoeudClique:=False;
          if BrancheCliquee.EstUnGroupeMonoPhyl then
            if Assigned(UneBrancheEstCliquee) then
              begin
                NoeudClique:=True;
                UneBrancheEstCliquee(Self);
              end;
        end;
    end
  Else
    begin
      LaBranche:=BrancheAPosition(X,Y,SurLeNoeud);
      If LaBranche<>Nil then
        begin
          BrancheCliquee:=LaBranche;
          NoeudClique:=SurLeNoeud;
        end;
    end;
  if BrancheCliquee<>Nil then
    begin
      if NoeudClique then
        begin
          if BrancheCliquee.NomGroupe<>'' then
            TexteInfo:='Noeud de l''anctre des '+BrancheCliquee.NomGroupe
          else
            TexteInfo:='Noeud : '+ BrancheCliquee.Nom;
        end
      else
        begin
          if BrancheCliquee.EstUnTaxon then
            TexteInfo:='Branche de '+BrancheCliquee.Nom
          else
            begin
              if BrancheCliquee.NomGroupe<>'' then
                TexteInfo:='Branche de l''anctre des '+ BrancheCliquee.NomGroupe
              else
                TexteInfo:='Branche de '+ BrancheCliquee.Nom;
            end;
        end;
      If Assigned(AjusterInfo) then AjusterInfo(Self);
    end;
end;
procedure TArbreDate.ArbreDateMouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
begin
  If Layer is TAncetreLayer then
    begin
      AncetreDeplace:=Layer as TAncetreLayer;
      if AncetreDeplace<>Nil then
        begin
          X0Souris:=X;
          AncetreDeplace.Cursor:=CrSizeWE;
          CurseursDeplaces:=Nil;
        end;
    end
  Else if  Layer is TCurseursLayer then
    begin
      CurseursDeplaces:=Layer as TCurseursLayer;
      if CurseursDeplaces<>Nil then
        begin
          X0Souris:=X;
          //CurseursDeplaces.Cursor:=CrSizeWE;
          if CurseursDeplaces.DeuxCurseurs then
            begin
             if (CurseursDeplaces.Largeur<5) or (X-Round(CurseursDeplaces.Location.Left)<4) then
               CurseursDeplaces.CurseurD:=1 // dplacer le curseur de gauche
             else if (Round(CurseursDeplaces.Location.Right-CurseursDeplaces.LargeurTexte-X)<4) then
               CurseursDeplaces.CurseurD:=2  //dplacer le curseur de droite
             else
               CurseursDeplaces.CurseurD:=0;
            end
          else CurseursDeplaces.CurseurD:=0;//dplacer les deux curseurs ensemble
        end;
    end;
end;
procedure TArbreDate.ArbreDateMouseMove (Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
Var
  LeRectangle,RectProv:TFloatRect;
  deltax,LRect,HRect:integer;
  LaBranche:TBranche;
  LAncetre:TAncetreLayer;
  LeCurseur:TCurseursLayer;
  LaCrise:TItemCrise;
  UnItemStrati:TItemStrati;
begin
  TexteInfo:='';
  DessinProv.Bitmap.SetSize(1,1);
  DessinProv.Location:=FloatRect(0,0,1,1);
  DessinProv.Bitmap.Clear($FFFFFFFF);
  If (ssLeft in Shift)and(Layer is TAncetreLayer) then
    begin
      //AncetreDeplace:=Layer as TAncetreLayer;
      if (AncetreDeplace<>Nil)and (Layer=AncetreDeplace) then
        begin
          LeRectangle:=AncetreDeplace.Location;
          deltaX:=X-X0Souris;
          If DelTaX<>0 then
            begin
              X0Souris:=X;
              if (LeRectangle.Left+DeltaX+AncetreDeplace.Rayon)<PosXMaxiAge then
                DeltaX:=PosXMaxiAge-Round(LeRectangle.Left)-AncetreDeplace.Rayon;
              LeRectangle.Left:=LeRectangle.Left+DeltaX;
              LeRectangle.Right:=LeRectangle.Right+DeltaX;
              AncetreDeplace.Branche.PosAgeDisp:=PosXToAge(Round((LeRectangle.Right+LeRectangle.Left)/2));
            end;
          ReDessine;
        end;
    end
  Else If (ssLeft in Shift)and(Layer is TCurseursLayer) then
    begin
      if (CurseursDeplaces<>Nil)and (Layer=CurseursDeplaces) then
        begin
          LeRectangle:=CurseursDeplaces.Location;
          deltax:=X-X0Souris;
          If DelTaX<>0 then
            begin
              X0Souris:=X;
              if CurseursDeplaces.CurseurD=0 then
                begin
                  if (LeRectangle.Left+DeltaX)<PosXMaxiAge then
                    DeltaX:=PosXMaxiAge-Round(LeRectangle.Left);
                  LeRectangle.Left:=LeRectangle.Left+DeltaX;
                  LeRectangle.Right:=LeRectangle.Right+DeltaX;
                  CurseursDeplaces.Branche.PosAgeDisp:=PosXToAge(Round(LeRectangle.Left)+CurseursDeplaces.Largeur);
                  CurseursDeplaces.Branche.PosAgeApp:=PosXToAge(Round(LeRectangle.Left));
                end
              else if CurseursDeplaces.CurseurD=1 then
                begin
                  if (LeRectangle.Left+DeltaX)<PosXMaxiAge then
                    DeltaX:=PosXMaxiAge-Round(LeRectangle.Left);
                  LeRectangle.Left:=LeRectangle.Left+DeltaX;
                  CurseursDeplaces.Branche.PosAgeApp:=PosXToAge(Round(LeRectangle.Left));
                  if Round(LeRectangle.Right-LeRectangle.Left-CurseursDeplaces.LargeurTexte)>=0 then
                    CurseursDeplaces.largeur:=Round(LeRectangle.Right-LeRectangle.Left-CurseursDeplaces.LargeurTexte)
                  else
                    begin
                      CurseursDeplaces.Branche.PosAgeApp:=CurseursDeplaces.Branche.PosAgeDisp;
                      LeRectangle.Left:=AgeToPosX(CurseursDeplaces.Branche.PosAgeApp);
                    end;
                end
              else if CurseursDeplaces.CurseurD=2 then
                begin
                  if PosXToAge(Round(LeRectangle.Right)+DeltaX-CurseursDeplaces.LargeurTexte)>CurseursDeplaces.Branche.PosAgeApp then
                    DeltaX:=AgeToPosX(CurseursDeplaces.Branche.PosAgeApp)-Round(LeRectangle.Right)+CurseursDeplaces.LargeurTexte;
                  CurseursDeplaces.Branche.PosAgeDisp:=PosXToAge(Round(LeRectangle.Right+DeltaX-CurseursDeplaces.LargeurTexte));
                  If CurseursDeplaces.Branche.PosAgeDisp>=0 then
                    LeRectangle.Right:=LeRectangle.Right+DeltaX
                  else
                    begin
                      LeRectangle.Right:=AgeToPosX(0)+CurseursDeplaces.LargeurTexte;
                      CurseursDeplaces.Branche.PosAgeDisp:=0;
                    end;
                  CurseursDeplaces.largeur:=Round(LeRectangle.Right-LeRectangle.Left-CurseursDeplaces.LargeurTexte);
                end;

            end;
          ReDessine;
        end;
    end
  else If (Layer is TAncetreLayer) then
    begin
      LAncetre:=(Layer as TAncetreLayer);
      if LAncetre<>Nil then
        begin
          LaBranche:=LAncetre.Branche;
          If LaBranche<>Nil then
            begin
              if SimpleDiagramme then
                TexteInfo:=LaBranche.Nom+' - date estime (sur le diagramme) : '+TranscritAge(LaBranche.PosAgeDisp,True,True,'')
              else
                TexteInfo:=LaBranche.Nom+' - date estime (sur l''arbre) : '+TranscritAge(LaBranche.PosAgeDisp,True,True,'');
              if Assigned(AjusterInfo) then AjusterInfo(Self);
              LRect:=DessinProv.Bitmap.TextWidth(LaBranche.Nom)+4;
              HRect:=DessinProv.Bitmap.TextHeight(LaBranche.Nom)+4;
              RectProv.Left:=Max(0,X-(LRect Div 2));
              RectProv.Right:=RectProv.Left+LRect;
              RectProv.Top:=Y+5;
              RectProv.Bottom:=RectProv.Top+HRect;
              DessinProv.Location:=RectProv;
              DessinProv.Bitmap.Width:=LRect;
              DessinProv.Bitmap.Height:=HRect;
              DessinProv.Bitmap.DrawMode :=dmOpaque;
              DessinProv.Bitmap.Clear($FFFFFFFF);
              DessinProv.Bitmap.FrameRectS(0,0,LRect,HRect,clBlue32);
              DessinProv.Bitmap.Textout(2,2,LaBranche.Nom);
            end;
        end;
    end
  else If (Layer is TCurseursLayer) then
    begin
      LeCurseur:=(Layer as TCurseursLayer);
      if LeCurseur<>Nil then
        begin
          LaBranche:=LeCurseur.Branche;
          If LaBranche<>Nil then
            begin
              if LeCurseur.DeuxCurseurs and(LaBranche.PosAgeApp>0) then
                begin
                  if SimpleDiagramme then
                    TexteInfo:=LaBranche.EtiqTaxon+' - sur le diagramme : de '
                  else
                    TexteInfo:=LaBranche.EtiqTaxon+' - sur l''arbre : de ';
                  TexteInfo:=TexteInfo+TranscritAge(LaBranche.PosAgeApp,True,True,'l''')
                     +'  '+TranscritAge(LaBranche.PosAgeDisp,True,True,'l''')
                     +' - dans le tableau : de '
                     +TranscritAge(LaBranche.AgeApp,True,True,'l''')
                     +'  '+TranscritAge(LaBranche.AgeDisp,True,True,'l''')
                 end
              else
                begin
                  if SimpleDiagramme then
                    TexteInfo:=LaBranche.EtiqTaxon+' - date : - sur le diagramme : '+TranscritAge(LaBranche.PosAgeDisp,True,True,'')
                  else
                    TexteInfo:=LaBranche.EtiqTaxon+' - date : - sur l''arbre : '+TranscritAge(LaBranche.PosAgeDisp,True,True,'');

                  TexteInfo:=TexteInfo+' - dans le tableau : '+TranscritAge(LaBranche.AgeDisp,True,True,'');
                end;
              if Assigned(AjusterInfo) then AjusterInfo(Self);
            end;
        end;
    end
  Else if AfficherStrati and (Y>=YEchelleStrati)and (Y<=YEchelleStrati+HauteurEchelleStrati)and (X>=PosXMaxiAge) and (X<=PosXMiniAge) then
    begin
      if Not TrouveCrise(X,Y,True,LaCrise) then
        TrouveNomStrati(X,Y,True,UnItemStrati);
    end;
  if TexteInfo='' then
    if Assigned(AjusterInfo) then AjusterInfo(Self);
end;
Function TArbreDate.TrouveCrise(X,Y:integer;AfficherInfo:Boolean;Var LaCrise:TItemCrise):Boolean;
Var
  i,XA:integer;
begin
  Result:=False;
  if AfficherCrises and (Y>=YEchelleStrati)and (Y<=YEchelleStrati+HauteurEchelleStrati)and (X>=PosXMaxiAge) and (X<=PosXMiniAge) then
    begin
      For i:=0 to Length(Crises)-1 do
        begin
          XA:=AgeToPosX(Crises[i].Age);
          if (X=XA) or (X=XA+1) then
            begin
              LaCrise:=Crises[i];
              Result:=True;
              if AfficherInfo then
                begin
                  TexteInfo:='Crise '+Crises[i].Nom+' : '+TranscritAge(Crises[i].Age,True,True,'')
                   +' ; '+IntToStr(Crises[i].PCF)+' % de familles, '
                   +IntToStr(Crises[i].PCG)+' % de genres,'
                   +IntToStr(Crises[i].PCE)+' % d''espces ont disparu';
                  if Assigned(AjusterInfo) then AjusterInfo(Self);
                end;
              break;
            end;
        end;
    end;
end;
Function TArbreDate.TrouveNomStrati(X,Y:integer;AfficherInfo:Boolean;Var UnItemStrati:TItemStrati):Boolean;
Var
  i,j,AgeX,AgeMax,AgeMax2:integer;
  TypeItem,TypeItem2:TTypeItemStrati;
  Nom:string;
begin
  Result:=False;
  if AfficherStrati and (Y>=YEchelleStrati)and (Y<=YEchelleStrati+HauteurEchelleStrati)and (X>=PosXMaxiAge) and (X<=PosXMiniAge) then
    begin
      AgeX:=PosXToAge(X);
      for TypeItem:=Epoque downto Ere do
        begin
          if (Y>=YItemsEchelleStrati[TypeItem])and (Y<=YItemsEchelleStrati[TypeItem]+HauteurItemsEchelleStrati)then
            begin
              For i:=0 to Length(EchelleStrati) do
                begin
                  if EchelleStrati[i].TypeItem=TypeItem then
                    begin
                      AgeMax:=EchelleStrati[i].AgeDebut;
                      if AgeMax< EchelleStrati[i].AgeFin then
                        AgeMax:=MaxiAge;
                      if (AgeX>=EchelleStrati[i].AgeFin)and (AgeX<=AgeMax) then
                        begin
                          UnItemStrati:=EchelleStrati[i];
                          Result:=True;
                          if AfficherInfo then
                            begin
                              Nom:=UnItemStrati.Nom;
                              if (Nom='infrieur') or (Nom='moyen') or (Nom='suprieur') then
                                begin
                                  TypeItem2:=Pred(TypeITem);
                                  For j:=0 to Length(EchelleStrati) do
                                    begin
                                      if EchelleStrati[j].TypeItem=TypeItem2 then
                                        begin
                                          AgeMax2:=EchelleStrati[j].AgeDebut;
                                          if AgeMax2< EchelleStrati[j].AgeFin then
                                            AgeMax2:=MaxiAge;
                                          if (AgeX>=EchelleStrati[j].AgeFin)and (AgeX<=AgeMax2) then
                                            begin
                                              Nom:=EchelleStrati[j].Nom+' '+Nom;
                                              break;
                                            end;
                                        end;
                                    end;
                                end;
                              TexteInfo:=Nom+' : de '+TranscritAge(AgeMax,True,True,'')
                                 +'  '+TranscritAge(UnItemStrati.AgeFin,True,True,'l''');
                              if Assigned(AjusterInfo) then AjusterInfo(Self);
                            end;
                          Exit;
                        end;
                    end;
                end;
            end;
        end;
    end;
end;
procedure TArbreDate.ArbreCladeMouseMove (Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
Var
  LaBranche:TBranche;
  SurLeNoeud:Boolean;
  Texte:string;
  RectProv:TFloatRect;
  X1,Y1,X2,Y2:integer;
begin
  if (not (ssLeft in Shift))and DessinerBoites and AfficherNomsGroupes then
    begin
      TexteInfo:='';
      Texte:=NomDeNumeroGroupe(X,Y);
      if Texte<>'' then
        begin
          TexteInfo:=Texte;
          If Assigned(AjusterInfo) then AjusterInfo(Self);
          Cursor:=crDefault;
          exit;
        end;
    end;
  if (ssLeft in Shift) and EstModifiable and (BrancheCliquee<>Nil) then
    begin
      if X>X0Souris then
        begin
          RectProv.Left:=X0Souris;
          RectProv.Right:=X+1;
          X1:=0;
          X2:=(X-X0Souris);
        end
      else
        begin
          RectProv.Left:=X;
          RectProv.Right:=X0Souris+1;
          X1:=(X0Souris-X);
          X2:=0;
        end;
      if Y>Y0Souris then
        begin
          RectProv.Top:=Y0Souris;
          RectProv.Bottom:=Y+1;
          Y1:=0;
          Y2:=(Y-Y0Souris);
        end
      else
        begin
          RectProv.Top:=Y;
          RectProv.Bottom:=Y0Souris+1;
          Y1:=(Y0Souris-Y);
          Y2:=0;
        end;
      DessinProv.Location:=RectProv;
      DessinProv.Bitmap.Width:=Abs(X-X0Souris)+1;
      DessinProv.Bitmap.Height:=Abs(Y-Y0Souris)+1;
      DessinProv.Bitmap.Clear($00FFFFFF);
      DessinProv.Bitmap.LineS(X1,Y1,X2,Y2,$FFC0C0C0);
    end;
  LaBranche:=BrancheAPosition(X,Y,SurLeNoeud);
  If LaBranche<>Nil then
    begin
      if (ssLeft in Shift) and (LaBranche=BrancheCliquee)then
        begin
          Cursor:=crDrag;
          if LaBranche.Curseurs<>Nil then LaBranche.Curseurs.Cursor:=crDrag;
        end
      else if (ssLeft in Shift) and (BrancheCliquee<>Nil)then
        begin
          Cursor:=crCross;
          if LaBranche.Curseurs<>Nil then LaBranche.Curseurs.Cursor:=crCross;
        end
      else
        begin
          if ModeInversion  and SurLeNoeud  then
            begin
              Cursor:=CrSwap;
              if Labranche.Ancetre<>Nil then
                LaBranche.Ancetre.Cursor:=CrSwap;
            end
          else
            begin
              Cursor:=crHandPoint;
              if Labranche.Ancetre<>Nil then
                LaBranche.Ancetre.Cursor:=crHandPoint;
            end;
          if LaBranche.Curseurs<>Nil then
            begin
              LaBranche.Curseurs.Cursor:=crHandPoint;
            end;
        end;
      if SurLeNoeud then
        begin
          if LaBranche.NomGroupe<>'' then
            TexteInfo:='Noeud de l''anctre des '+ LaBranche.NomGroupe
          else
            TexteInfo:='Noeud : '+ LaBranche.Nom;
            //Pour tests
            {if LaBranche.Ancetre<>Nil then
              TexteInfo:=TexteInfo+' - '+intToStr(LaBranche.Ancetre.Couleur);
            if LaBranche.EstUnGroupeMonoPhyl then  TexteInfo:=TexteInfo+ ' : Monophyltique';
            if LaBranche.TracerBoite then  TexteInfo:=TexteInfo+ ' ; TracerBoite'; }
        end
      else
        begin
          if LaBranche.EstUnTaxon then
            TexteInfo:='Branche de '+LaBranche.Nom
          else
            begin
              if LaBranche.NomGroupe<>'' then
                TexteInfo:='Branche de l''anctre des '+ LaBranche.NomGroupe
              else
                TexteInfo:='Branche de '+ LaBranche.Nom;
            end;
        end;
      If Assigned(AjusterInfo) then AjusterInfo(Self);
    end
  else
    begin
      TexteInfo:='';
      If Assigned(AjusterInfo) then AjusterInfo(Self);
      if (ssLeft in Shift)and (BrancheCliquee<>Nil) then
        Cursor:=crDrag
      else
        Cursor:=crDefault;
    end;
end;
procedure TArbreDate.MouseMove(Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
begin
  if TypeDArbre=0 then ArbreDateMouseMove(Shift, X, Y, Layer)
  else ArbreCladeMouseMove(Shift, X, Y, Layer);
  inherited MouseMove(Shift, X, Y, Layer);
end;
procedure TArbreDate.ArbreDateMouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
Var
  DeltaAge,DeltaX:integer;
  Modifie:boolean;
  LeRectangle:TFloatRect;
begin
  Modifie:=False;
  If (Layer is TCurseursLayer) then   //(ssLeft in Shift)and
    begin
      if (CurseursDeplaces<>Nil)and (Layer=CurseursDeplaces) then
        begin
          Modifie:=False;
          DeltaAge:=Round(DeltaPosX/(PosXMiniAge-PosXMaxiAge)*(MaxiAge-MiniAge));
          LeRectangle:=CurseursDeplaces.Location;
          deltax:=X-X0Souris;
          X0Souris:=X;
          if CurseursDeplaces.CurseurD=0 then
            begin
              LeRectangle.Left:=LeRectangle.Left+DeltaX;
              LeRectangle.Right:=LeRectangle.Right+DeltaX;
              CurseursDeplaces.Branche.PosAgeDisp:=PosXToAge(Round(LeRectangle.Left)+CurseursDeplaces.Largeur);
              CurseursDeplaces.Branche.PosAgeApp:=PosXToAge(Round(LeRectangle.Left));
              if CurseursDeplaces.Branche.PosAgeDisp<0 then
                begin
                  CurseursDeplaces.Branche.PosAgeDisp:=0;
                  LeRectangle.Right:=AgeToPosX(0)+CurseursDeplaces.LargeurTexte;
                  LeRectangle.Left:=LeRectangle.Right-CurseursDeplaces.LargeurTexte-CurseursDeplaces.Largeur;
                end;
              if (CurseursDeplaces.Branche.PosAgeDisp<>CurseursDeplaces.Branche.AgeDisp) and
                (Abs(CurseursDeplaces.Branche.PosAgeDisp-CurseursDeplaces.Branche.AgeDisp)<=DeltaAge) then
                begin
                  CurseursDeplaces.Branche.PosAgeDisp:=CurseursDeplaces.Branche.AgeDisp;
                  Modifie:=True;
                end;
              if (CurseursDeplaces.Branche.PosAgeApp<>CurseursDeplaces.Branche.AgeApp) and
                (Abs(CurseursDeplaces.Branche.PosAgeApp-CurseursDeplaces.Branche.AgeApp)<=DeltaAge) then
                begin
                  CurseursDeplaces.Branche.PosAgeApp:=CurseursDeplaces.Branche.AgeApp;
                  Modifie:=True;
                end;
            end
          else if CurseursDeplaces.CurseurD=1 then
            begin
              LeRectangle.Left:=LeRectangle.Left+DeltaX;
              CurseursDeplaces.Branche.PosAgeApp:=PosXToAge(Round(LeRectangle.Left));
              CurseursDeplaces.largeur:=Round(LeRectangle.Right-LeRectangle.Left-CurseursDeplaces.LargeurTexte);
              if (CurseursDeplaces.Branche.PosAgeApp<>CurseursDeplaces.Branche.AgeApp) and
                (Abs(CurseursDeplaces.Branche.PosAgeApp-CurseursDeplaces.Branche.AgeApp)<=DeltaAge) then
                begin
                  CurseursDeplaces.Branche.PosAgeApp:=CurseursDeplaces.Branche.AgeApp;
                  Modifie:=True;
                end;
            end
          else if CurseursDeplaces.CurseurD=2 then
            begin
              LeRectangle.Right:=LeRectangle.Right+DeltaX;
              CurseursDeplaces.Branche.PosAgeDisp:=PosXToAge(Round(LeRectangle.Right-CurseursDeplaces.LargeurTexte));
              CurseursDeplaces.largeur:=Round(LeRectangle.Right-LeRectangle.Left-CurseursDeplaces.LargeurTexte);
              if (CurseursDeplaces.Branche.PosAgeDisp<>CurseursDeplaces.Branche.AgeDisp) and
                (Abs(CurseursDeplaces.Branche.PosAgeDisp-CurseursDeplaces.Branche.AgeDisp)<=DeltaAge) then
                begin
                  CurseursDeplaces.Branche.PosAgeDisp:=CurseursDeplaces.Branche.AgeDisp;
                  Modifie:=True;
                end;
            end;
          if Modifie then
            begin
              CurseursDeplaces.largeur:=AgeToPosX(CurseursDeplaces.Branche.PosAgeDisp)-AgeToPosX(CurseursDeplaces.Branche.PosAgeApp);
              if CurseursDeplaces.largeur<0 then CurseursDeplaces.largeur:=0;
              EffacerCurseursDeplaces:=True;

            end;
          ReDessine;
        end;
    end;
  if Not Modifie then
    CurseursDeplaces:=Nil;
  AncetreDeplace:=Nil;
  X0Souris:=-1;
  Refresh;
end;
procedure TArbreDate.ArbreCladeMouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
Var
  i,numdep,numar,Xdep,plus,nbb:integer;
  LaBranche:TBranche;
  AncetreDirect:TBranche;
  Atrouver:boolean;
  SurLeNoeud,condition:Boolean;
begin
  DessinProv.Bitmap.Clear($00FFFFFF);
  DessinProv.Bitmap.Width:=1;
  DessinProv.Bitmap.Height:=1;
  DessinProv.Location:=FloatRect(0,0,1,1);
  if (not (ssLeft in Shift))and DessinerBoites and AfficherNomsGroupes then
    begin
      LaBranche:=AncetreDuGroupeANommer(X,Y);
      if LaBranche<>Nil then
        begin
          BrancheCliquee:=LaBranche;
          if assigned(UnGroupeEstANommer) then
            UnGroupeEstANommer(self);
          exit;
        end;
    end;
  //EstModifiable:=True;  //Pour tests
  LaBranche:=BrancheAPosition(X,Y,SurLeNoeud);
  if EstModifiable and(BrancheCliquee<>Nil) and (LaBranche<>Nil) then
    begin
      //LaBranche:=BrancheAPosition(X,Y,SurLeNoeud);
      if LaBranche<>Nil then
        begin
          if SurLeNoeud then
            begin
              if NoeudClique then
                FixeNoeudSurLeNoeud(LaBranche,BrancheCliquee)
              else
                FixeBrancheSurLeNoeud(LaBranche,BrancheCliquee);
            end
          else
            begin
              if NoeudClique then
                FixeNoeudSurLaBranche(LaBranche,BrancheCliquee)
              else
                FixeBrancheSurLaBranche(LaBranche,BrancheCliquee);
            end;
        end;
    end
  else
    begin
      If (BrancheCliquee<>Nil)and(BrancheCliquee.AncetreDirect<>Nil)  then
        begin
          AncetreDirect:=BrancheCliquee.AncetreDirect;
          XDep:=BrancheCliquee.XCible;
          if Abs(XDep-X)<8 then
            begin
              BrancheCliquee:=Nil;
              Exit;
            end;
          if XDep<X then plus:=-1 else plus:=0;
          if XDep<>X then
            begin
                 //recherche du numro de la branche clique
              numdep:=-1;
              numar:=-1;
              Atrouver:=True;
              nbb:=Length(AncetreDirect.Descendants);
              for i:=0 to nbb-1 do
                begin
                  LaBranche:=BrancheCliquee.AncetreDirect.Descendants[i];
                  if LaBranche=BrancheCliquee then
                    numdep:=i
                  else if Atrouver  then
                    begin
                      if Y>(BrancheCliquee.AncetreDirect.YCible) then
                        condition:=false
                      else if Y<=LaBranche.YCible then
                        condition:=(LaBranche.XCible>X)
                      else
                        begin
                          condition:=((Y-LaBranche.YCible)*(BrancheCliquee.AncetreDirect.XCible-LaBranche.XCible)>(X-LaBranche.XCible)*(BrancheCliquee.AncetreDirect.YCible-LaBranche.YCible));
                        end;
                      if condition then
                        begin
                          Atrouver:=false;
                          numar:=i+plus;
                        end;
                    end;
                end;
              if Atrouver then numar:=nbb+plus;
              if (numdep>-1)and(numdep<nbb)and(numar>-1)and(numar<nbb)and (numdep<>numar) then
                begin
                  if numdep>numar then
                    begin
                      LaBranche:=BrancheCliquee;
                      For i:=numdep downto numar+1 do
                        AncetreDirect.Descendants[i]:=AncetreDirect.Descendants[i-1];
                      AncetreDirect.Descendants[numar]:=LaBranche;
                      ReclasseBranches;
                      Redessine;
                    end
                  else
                    begin
                      LaBranche:=BrancheCliquee;
                      For i:=numdep to numar-1 do
                        AncetreDirect.Descendants[i]:=AncetreDirect.Descendants[i+1];
                      AncetreDirect.Descendants[numar]:=LaBranche;
                      ReclasseBranches;
                      Redessine;
                    end;
                end;
            end;
        end;
    end;
  BrancheCliquee:=Nil;
  Redessine;
end;
procedure TArbreDate.MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
begin
  if TypeDArbre=0 then ArbreDateMouseUp(Button,Shift, X, Y, Layer)
  else ArbreCladeMouseUp(Button,Shift, X, Y, Layer);
  inherited MouseUp(Button,Shift, X, Y, Layer);
end;
Function TArbreDate.Verifier(Var NbBP:integer):String;
Var
  i,j:integer;
  Divp:integer;
  ListeErreurs:TStringList;
  correct:boolean;
  function different(nb1,nb2:integer):boolean;
  begin
    different:=True;
    if Round(nb1/Divp)=Round(nb2/Divp) then different:=False;
  end;
begin
  Divp:=1000;
  Case PrecisionDate of
    1:Divp:=100;
    2:Divp:=10;
  end;
  //vrification de la position des Taxons
  if SimpleDiagramme then
    Result:='Le diagramme est compatible avec les donnes'
  else
    Result:='L''arbre est compatible avec les donnes';
  NbBP:=0;
  ListeErreurs:=TStringList.Create;

  For i:=0 to Length(Branches)-1 do
    begin
      if Branches[i].Curseurs<>Nil then
        begin
          if Branches[i].Curseurs.DeuxCurseurs then
            begin
              correct:=True;
              if different(Branches[i].PosAgeDisp,Branches[i].AgeDisp) then
                begin
                  if SimpleDiagramme then
                    ListeErreurs.Add('Sur le diagramme, l''ge de disparition de '+Branches[i].EtiqTaxon+' ne correspond pas  celui du tableau')
                  else
                    ListeErreurs.Add('Sur l''arbre, l''ge de disparition de '+Branches[i].EtiqTaxon+' ne correspond pas  celui du tableau');
                  Correct:=False;
                  //Result:='Sur l''arbre, l''ge de disparition de '+Branches[i].EtiqTaxon+' ne correspond pas  celui du tableau'; //(Disp)
                  //exit;
                end;
              if different(Branches[i].PosAgeApp,Branches[i].AgeApp) then
                begin
                  if SimpleDiagramme then
                    ListeErreurs.Add('Sur le Diagramme, l''ge d''apparition de '+Branches[i].EtiqTaxon+' ne correspond pas  celui du tableau') //(App)
                  else
                    ListeErreurs.Add('Sur l''arbre, l''ge d''apparition de '+Branches[i].EtiqTaxon+' ne correspond pas  celui du tableau');
                  Correct:=False;
                  //Result:='Sur l''arbre, l''ge d''apparition de '+Branches[i].EtiqTaxon+' ne correspond pas  celui du tableau'; //(App)
                  //exit;
                end;
              if Correct then inc(NbBP);
            end
          else
            begin
              if different(Branches[i].PosAgeDisp,Branches[i].AgeDisp) then
                begin
                  if SimpleDiagramme then
                    ListeErreurs.Add('Sur le diagramme, l''ge de '+Branches[i].EtiqTaxon+' ne correspond pas  celui du tableau')  //(1 seul curseur )
                  else
                    ListeErreurs.Add('Sur l''arbre, l''ge de '+Branches[i].EtiqTaxon+' ne correspond pas  celui du tableau');  //(1 seul curseur )
                  //Result:='Sur l''arbre, l''ge de '+Branches[i].EtiqTaxon+' ne correspond pas  celui du tableau';  //(1 seul curseur )
                  //exit;
                end
              else
                if Branches[i].AgeDisp<>0 then inc(NbBP);;
            end;
        end;
    end;
  //vrification de la position des Racines
  For i:=0 to Length(Branches)-1 do
    begin
      if Branches[i].Ancetre<>Nil then
        begin
          //vrification par rapport aux descendants
          For j:=0 to Length(Branches[i].Descendants)-1 do
            begin
              if Branches[i].Descendants[j].EstUnTaxon and Branches[i].Descendants[j].Curseurs.DeuxCurseurs then
                begin
                  if Branches[i].PosAgeDisp<=Branches[i].Descendants[j].PosAgeApp then
                    begin
                      if SimpleDiagramme then
                        ListeErreurs.Add('L'''+Branches[i].Nom+' ne peut tre plus jeune que son descendant '
                          +Branches[i].Descendants[j].Nom+#10#13+' contrairement  la position choisie sur le diagramme')
                      else
                        ListeErreurs.Add('L'''+Branches[i].Nom+' ne peut tre plus jeune que son descendant '
                          +Branches[i].Descendants[j].Nom+#10#13+' contrairement  la position choisie sur l''arbre');
                      NbBP:=0;
                      //Result:='L'''+Branches[i].Nom+' ne peut tre plus jeune que son descendant '
                        //+Branches[i].Descendants[j].Nom+#10#13+' contrairement  la position choisie sur l''arbre';
                      //exit;
                    end;
                end
              else
                begin
                  if Branches[i].PosAgeDisp<=Branches[i].Descendants[j].PosAgeDisp then
                    begin
                      ListeErreurs.Add('L'''+Branches[i].Nom+' ne peut tre plus jeune que son descendant '
                        +Branches[i].Descendants[j].Nom);
                        NbBP:=0;
                      //Result:='L'''+Branches[i].Nom+' ne peut tre plus jeune que son descendant '
                        //+Branches[i].Descendants[j].Nom;
                      //exit;
                    end;
                end;
            end;
        end;
    end;
  if ListeErreurs.Count>0 then
    Result:=ListeErreurs.CommaText;
  ListeErreurs.Free;
end;
Function TArbreDate.StructAvecGroupe:String;
Var
  i:integer;
begin
  Result:='';
  For i:=0 to Length(Branches)-1 do
    if Branches[i].AncetreDirect=nil then Result:=Result+Branches[i].StructAvecGroupe;
end;

Function TArbreDate.StructArbre:String;
Var
  i:integer;
begin
  Result:='';
  For i:=0 to Length(Branches)-1 do
    if Branches[i].AncetreDirect=nil then Result:=Result+Branches[i].Structure;
end;
function TArbreDate.TranscritAge(age:integer;moins,AjouterUnite:boolean;le:string):String;
Var
  chaineFormat:string;
  UniteDate:string;
begin
  try
  chaineFormat:='###0';
  UniteDate:='';
  if age<0 then
    begin
      Result:=' ajuster';
      UniteDate:='';
    end
  else if age=0 then
    begin
      Result:=le+'actuel';
      UniteDate:='';
    end
  else if EchelleMa then   // and (age>=1000)
    begin
      case precisionDate of
        0:chaineFormat:='###0';
        1:chaineFormat:='###0.#';
        2:chaineFormat:='###0.##';
      end;
      Result:=FormatFloat(chaineFormat,age/1000);
      if moins then result:='-'+Result;
      UniteDate:=' Ma';
    end
  else
    begin
      Result:=IntToStr(age*1000);
      if moins then result:='-'+Result;
      UniteDate:=' ans';
    end;
  if AjouterUnite then Result:=Result+UniteDate;
  except
    Result:='Erreur 2'
  end;
end;
Procedure TArbreDate.ToutEffacer;
Var
  i:integer;
Begin
  LeNouvCaractere:=Nil;
  For i:=0 to Length(Branches)-1 do
    Branches[i].Free;
  SetLength(Branches,0);
  NumeroAncetre:=0;
  i:=Layers.Count-1;
  While i>=0 do
    begin
      if Layers[i]<>DessinProv then
        begin
          Layers.Delete(i);
        end;
      dec(i);
    end;
end;
Procedure TArbreDate.ToutDisposer;
Var
  i,j:integer;
  LeRectangle:TFloatRect;
begin
  Redessine;
  For i:=0 to Length(Branches)-1 do
    begin
      if Branches[i].EstUnTaxon then
        begin
          Branches[i].PosAgeDisp:=Branches[i].AgeDisp;
          Branches[i].PosAgeApp:=Branches[i].AgeApp;
          if Branches[i].Curseurs<>Nil then
            begin
              Branches[i].Curseurs.Largeur:=AgeToPosX(Branches[i].PosAgeDisp)-AgeToPosX(Branches[i].PosAgeApp);
              LeRectangle:=Branches[i].Curseurs.Location;
              LeRectangle.Left:=AgeToPosX(Branches[i].PosAgeApp);
              LeRectangle.Right:=AgeToPosX(Branches[i].PosAgeDisp)+Branches[i].Curseurs.LargeurTexte;
              Branches[i].Curseurs.Location:=LeRectangle;
            end;
          If Branches[i].AncetreDirect<>Nil then
            begin
              if (Branches[i].AncetreDirect.PosAgeDisp<(Branches[i].AgeApp+EcartAge)) then
                begin
                  Branches[i].AncetreDirect.PosAgeDisp:=Branches[i].AgeApp+EcartAge;
                  if Branches[i].AncetreDirect.Ancetre<>Nil then
                    begin
                      LeRectangle:=Branches[i].AncetreDirect.Ancetre.Location;
                      LeRectangle.Left:=AgeToPosX(Branches[i].AncetreDirect.PosAgeDisp)+Branches[i].AncetreDirect.Ancetre.Rayon;
                      LeRectangle.Right:=LeRectangle.Left+2*Branches[i].AncetreDirect.Ancetre.Rayon;
                    end;
                end;
              Branches[i].AncetreDirect.AgeMin:=Branches[i].AgeApp;
            end;
        end;
    end;
  //Vrifications par niveaux
  For j:=1 to NombreNiveaux-2 do
    For i:=0 to Length(Branches)-1 do
      if Branches[i].niveau=j then
        begin
          If (Branches[i].AncetreDirect<>Nil) and (Branches[i].AncetreDirect.PosAgeDisp<(Branches[i].PosAgeDisp+EcartAge)) then
            begin
              Branches[i].AncetreDirect.PosAgeDisp:=Branches[i].PosAgeDisp+EcartAge;
              if Branches[i].AncetreDirect.Ancetre<>Nil then
                begin
                  LeRectangle:=Branches[i].AncetreDirect.Ancetre.Location;
                  LeRectangle.Left:=AgeToPosX(Branches[i].AncetreDirect.PosAgeDisp)+Branches[i].AncetreDirect.Ancetre.Rayon;
                  LeRectangle.Right:=LeRectangle.Left+2*Branches[i].AncetreDirect.Ancetre.Rayon;
                end;
            end;
        end;
  Redessine;
end;
Procedure TArbreDate.MarqueCommeFossile(Nomtaxon:string);
Var
  LaBranche:TBranche;
begin
  LaBranche:=LabrancheDuTaxon(NomTaxon);
  If (LaBranche<>Nil) and (LaBranche.Curseurs<>Nil) then
    LaBranche.Curseurs.EstFossile:=True;
end;
Procedure TArbreDate.MarqueCommeExterne(Nomtaxon:string);
Var
  LaBranche:TBranche;
begin
  LaBranche:=LabrancheDuTaxon(NomTaxon);
  If (LaBranche<>Nil) and (LaBranche.Curseurs<>Nil) then
    LaBranche.Curseurs.EstExterne:=True;
end;
Procedure TArbreDate.RazFossiles;
Var
  i:integer;
  LaBranche:TBranche;
begin
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche.Curseurs<>Nil then
        LaBranche.Curseurs.EstFossile:=False;
    end;
end;
Procedure TArbreDate.RazExternes;
Var
  i:integer;
  LaBranche:TBranche;
begin
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche.Curseurs<>Nil then
        LaBranche.Curseurs.EstExterne:=False;
    end;
end;
Procedure TArbreDate.RAZCouleurs;
begin
  RazCouleurSurBoites;
  RazCouleurAncetres;
  RazCouleurBranches;
end;
Procedure TArbreDate.RazCouleurSurBoites;
Var
  i:integer;
  LaBranche:TBranche;
begin
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche<>Nil then
        LaBranche.CouleurSurBoite:=0;
    end;
end;
Procedure TArbreDate.RazCouleurBoites;
Var
  i:integer;
  LaBranche:TBranche;
begin
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche<>Nil then
        LaBranche.CouleurBoite:=CouleurBoiteDefaut;
    end;
end;
Procedure TArbreDate.RazCouleurAncetres;
Var
  i:integer;
  LaBranche:TBranche;
begin
  GetRacines;
  For i:=0 to Length(FRacines)-1 do
    begin
      LaBranche:=FRacines[i];
      if LaBranche<>Nil then
        LaBranche.RazCouleurAncetresDescendants;
    end;
end;
Procedure TArbreDate.RazCouleursCurseurs;
Var
  i:integer;
  LaBranche:TBranche;
begin
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche.Curseurs<>Nil then
        LaBranche.Curseurs.Couleur:=ClRed32;
    end;
end;
procedure TArbreDate.RazCouleurBranches;
Var
  i:integer;
  LaBranche:TBranche;
begin
  CouleurTraitRacine:=clBlack32;
  GetRacines;
  For i:=0 to Length(FRacines)-1 do
    begin
      LaBranche:=FRacines[i];
      if LaBranche<>Nil then
        LaBranche.RazCouleurBranchesDescendants;
    end;
end;
procedure TArbreDate.RazNomGroupe;
Var
  i:integer;
  UneBranche:TBranche;
begin
  For i:=0 to Length(Branches)-1 do
    begin
      UneBranche:=Branches[i];
      if UneBranche<>Nil then
        UneBranche.NomGroupe:='';
    end;
end;

procedure TArbreDate.RAZEspB;
Var
  i:integer;
  LaBranche:TBranche;
begin
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche<>Nil then
        begin
          LaBranche.EspBD:=0;
          LaBranche.EspBG:=0;
          LaBranche.EspBGCalcule:=False;
          LaBranche.EspBDCalcule:=False;
        end;
    end;
end;
Function TArbreDate.BrancheAPosition(X,Y:integer;Var SurLeNoeud:Boolean):TBranche;
Var
  i:integer;
  LaBranche:TBranche;
  X0L1,Y0L1,X1L1,Y1L1:integer;
  X0L2,Y0L2,X1L2,Y1L2:integer;
Begin
  SurLeNoeud:=False;
  Result:=Nil;
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche.Ancetre<>Nil then
        begin
          if (X>=LaBranche.Ancetre.Location.Left)and(X<=LaBranche.Ancetre.Location.Right)
             and (Y>=LaBranche.Ancetre.Location.Top)and(Y<=LaBranche.Ancetre.Location.Bottom) then
            begin
              SurLeNoeud:=True;
              Result:=LaBranche;
              Exit;
            end;
        end;
    end;
  For i:=0 to Length(Branches)-1 do
    begin
      LaBranche:=Branches[i];
      if LaBranche.AncetreDirect<>Nil then
        begin
          X0L1:=LaBranche.XCible-EpaisseurBranche;
          X1L1:=LaBranche.AncetreDirect.XCible-EpaisseurBranche;
          Y0L1:=LaBranche.YCible;
          Y1L1:=LaBranche.AncetreDirect.YCible;
          X0L2:=LaBranche.XCible+EpaisseurBranche;
          X1L2:=LaBranche.AncetreDirect.XCible+EpaisseurBranche;
          Y0L2:=LaBranche.YCible;
          Y1L2:=LaBranche.AncetreDirect.YCible;
          if (Y>=Y0L1)and((X-X0L1)*(Y1L1-Y0L1)>=(Y-Y0L1)*(X1L1-X0L1))
              and (Y<=Y1L1)and((X-X0L2)*(Y1L2-Y0L2)<=(Y-Y0L2)*(X1L2-X0L2)) then
            begin
              Result:=LaBranche;
              Exit;
            end;
          if LaBranche.EstUnTaxon then
            begin
              if (Y<=Y0L1)and(X>=LaBranche.XCible-(HauteurTexte div 2))and(X<=LaBranche.XCible+(HauteurTexte div 2))
                  and (Y>MargeV)then
                begin
                  Result:=LaBranche;
                  Exit;
                end;
            end;
        end
      else
        begin
          X0L1:=LaBranche.XCible-EpaisseurBranche;
          X1L1:=X0L1+2*EpaisseurBranche;
          Y0L1:=LaBranche.YCible;
          Y1L1:=LaBranche.YCible+LongueurRacine;
          if (Y>=Y0L1)and (Y<=Y1L1)and (X>=X0L1)and (X<=X1L1) then
            begin
              Result:=LaBranche;
              Exit;
            end;
          if LaBranche.EstUnTaxon then
            begin
              if (Y<=Y0L1)and(X>=LaBranche.XCible-(HauteurTexte div 2))and(X<=LaBranche.XCible+(HauteurTexte div 2))
                  and (Y>MargeV)then
                begin
                  Result:=LaBranche;
                  Exit;
                end;
            end;
        end;
    end;
end;
Function TArbreDate.GetRacines:TGroupeDeBranches;
Var
  i,n:integer;
begin
  SetLength(FRacines,0);
  For i:=0 to Length(Branches)-1 do
    begin
      if Branches[i].AncetreDirect=Nil then
        begin
          n:=Length(FRacines);
          SetLength(FRacines,n+1);
          FRacines[n]:=Branches[i];
        end;
    end;
  Result:=FRacines;
end;
Function TArbreDate.AncPlusVieuxPrem(UneBranche:TBranche):TBranche; //Recherche le plus viel ancetre dont elle est la premire branche descendante
Var
  BrA:TBranche;
begin
  Result:=UneBranche;
  BrA:=UneBranche.AncetreDirect;
  While BrA<>Nil do
    begin
      if BRA.Descendants[0]<>Result then
        begin
          BrA:=Nil;
        end
      else
        begin
          Result:=BRA;
          BRA:=Result.AncetreDirect;
        end;
    end;
end;
Function TArbreDate.AncPlusVieuxDern(UneBranche:TBranche):TBranche; //Recherche le plus viel ancetre dont elle est la dernire branche descendante
Var
  BrA:TBranche;
begin
  Result:=UneBranche;
  BrA:=UneBranche.AncetreDirect;
  While BrA<>Nil do
    begin
      if BRA.Descendants[Length(BRA.Descendants)-1]<>Result then
        begin
          BrA:=Nil;
        end
      else
        begin
          Result:=BRA;
          BRA:=Result.AncetreDirect;
        end;
    end;
end;

Function TArbreDate.ChargeFichierStrati(NomFichier:string):Boolean;
Var
  n,deb,fin,p:integer;
  R,G,B:byte;
  T:TextFile;
  S: string;
  DonneeStrati:TStringList;
  LaDStrati:TItemStrati;
  LeTypeItemStrati:TTypeItemStrati; //=(Eon,Ere,Periode,Epoque,Etage)
  StrTypeStrati:TStringList;
  LectureCrises:Boolean;
  LaCrise:TItemCrise;
begin
  Result:=False;
  LectureCrises:=False;
  if FileExists(NomFichier) then
    begin
      SetLength(EchelleStrati,0);
      Result:=True;
      StrTypeStrati:=TStringList.Create;
      StrTypeStrati.CommaText:='on,re,priode,poque,tage';
      DonneeStrati:=TStringList.Create;
      try
        AssignFile(T,NomFichier);
        Reset(T);
        LeTypeItemStrati:=Periode;
        While Not Eof(T) do
          begin
            Readln(T, S);
            if pos('//',S)=0 then
              begin
                deb:=pos('[',S);
                if deb=0 then
                  begin
                    DonneeStrati.CommaText:=S;
                    if DonneeStrati.Count=5 then
                      begin
                        if LectureCrises then
                          begin
                            LaCrise.Nom:=DonneeStrati[0];
                            try
                              Lacrise.Age:=StrToInt(DonneeStrati[1]);
                              Lacrise.PCF:=StrToInt(DonneeStrati[2]);
                              Lacrise.PCG:=StrToInt(DonneeStrati[3]);
                              Lacrise.PCE:=StrToInt(DonneeStrati[4]);
                              n:=Length(Crises);
                              SetLength(Crises,n+1);
                              Crises[n]:=LaCrise;
                            except
                            end;
                          end
                        else
                          begin
                            LaDStrati.Nom:=DonneeStrati[0];
                            LaDStrati.TypeItem:=LeTypeItemStrati;
                            try
                              LaDStrati.AgeFin:=StrToInt(DonneeStrati[1]);
                              R:=StrToInt(DonneeStrati[2]);
                              G:=StrToInt(DonneeStrati[3]);
                              B:=StrToInt(DonneeStrati[4]);
                              LaDStrati.Couleur:=Color32(R,G,B);
                              n:=Length(EchelleStrati);
                              SetLength(EchelleStrati,n+1);
                              EchelleStrati[n]:=LaDStrati;
                              if (n>0)and(EchelleStrati[n-1].TypeItem=LeTypeItemStrati) then
                                EchelleStrati[n-1].AgeDebut:=LaDStrati.AgeFin;
                            except
                            end;
                          end;
                      end;
                  end
                else
                  begin
                    fin:=pos(']',S);
                    if fin>deb+2 then
                      begin
                        try
                          S:=Copy(S,deb+1,fin-deb-1);
                          p:=StrTypeStrati.IndexOf(S);
                          if (p>-1)then
                            begin
                              LeTypeItemStrati:=TTypeItemStrati(p);
                              LectureCrises:=False;
                            end
                          else if S='crises' then
                            LectureCrises:=True;
                        except
                        end;
                      end;
                  end;
              end;
          end;
        CloseFile(T);
        DonneeStrati.Free;
        StrTypeStrati.Free;
      except
        Result:=False;
        DonneeStrati.Free;
        StrTypeStrati.Free;
      end;
  end;
end;
Function TArbreDate.CalculeLongueurCar(NomCar:string):integer;
Var
  i:integer;
  UneBranche:TBranche;
begin
  Result:=0;
  For i:=0 to Length(Branches)-1 do
    begin
      UneBranche:=Branches[i];
      if (UneBranche<>Nil) and (UneBranche.AncetreDirect=Nil) then
        begin
          Result:=Result+UneBranche.CalculeLongueurCar(NomCar);
        end;
    end;
end;
Function TArbreDate.CalculeLongueurTot(NomCar:string;Var LongCar:integer):integer;  // commencer par tablir la liste des caractres (redoubls s'il y a plusieurs tats)
                                              //avant d'appeler la fonction
Var
  i,n:integer;
  NomCarD:string;
begin
  Result:=0;
  LongCar:=0;
  for i:=0 to ListeCaracteres.Count-1 do
    begin
      NomCarD:=ListeCaracteres[i];
      n:=CalculeLongueurCar(NomCarD);
      Result:=Result+n;
      if NomCarD=NomCar then LongCar:=n;
    end;
end;
Procedure TArbreDate.ConstruitPortraits(Methode:integer);
begin
  MethodeParci:=Methode;
  ConstruitListeTaxons;
  Case methode of
    0:ConstruitPortraitsWagner;   //m. de Wagner (rversions et convergences acceptes)
    1:ConstruitPortraitsCaminSokal; //m. de Camin Sokal (convergences seules acceptes)
                                    //supprimer les rversions
    2:ConstruitPortraitsDollo; //m. de Dollo (rversions seules acceptes)
                                    // supprime les convergences
  end;
end;
Procedure TArbreDate.ConstruitPortraitTaxon(UneBranche:TBranche);
Var
  i,j:integer;
  NomTaxon,NomCar:string;
  Etat,EtatTest:string;
  Numetat,PNumEtat,Statut,NmE:integer;
  UnCarD:TCaractD;
begin
  NomTaxon:=UneBranche.Nom;
  UneBranche.CaracteresDExcl.Clear;
  UneBranche.EtatsDExcl.Clear;

  For i:=0 to ListeCaracteres.Count-1 do
    begin
      NomCar:=ListeCaracteres[i];
      Etat:=LaSousCollection.EtatDe(NomTaxon,NomCar,PNumEtat);
      if (Etat='')or(Etat='?') then
        begin
          Etat:='?';
          Statut:=1;
        end
      else if PNumEtat=0 then Statut:=0
      else
        begin
          Statut:=3;
          //vrifier l'exclusivit sinon redescendre  2
          for j:=0 to ListeCompleteTaxons.Count-1 do
            begin
              if (ListeCompleteTaxons[j]<>NomTaxon) then
                begin
                  EtatTest:=LaSousCollection.EtatDe(ListeCompleteTaxons[j],NomCar,NumEtat);
                  if (EtatTest<>'')and(EtatTest<>'?') then
                    begin
                      UnCarD:=LaSousCollection.LeCarD(NomCar);
                      if UnCarD<>Nil then
                        begin
                          if (EtatTest=Etat)or((Numetat>PNumEtat)and(UnCarD.TypeCarD=1))then
                            begin
                              Statut:=2;
                              break;
                            end;
                        end;
                    end;
                end;
            end;
          if Statut=3 then
            begin
              UneBranche.EstUnGroupeMonoPhyl:=True;
              UneBranche.CaracteresDExcl.Add(NomCar);
              UneBranche.EtatsDExcl.Add(Etat);
            end;
        end;
      UneBranche.Portrait.Ajoute(NomCar,Etat,PNumEtat,Statut);
    end;
  UneBranche.TracerBoite:=UneBranche.EstUnGroupeMonoPhyl;
end;
Procedure TArbreDate.ConstruitPortraitsCaminSokal;
Var                               //m. de Camin Sokal (convergences seules acceptes)
                                  //pas de rversion : tat anctre= tat le moins volu
  i,n:integer;
  UneBranche:TBranche;
begin
  //pas de rversion : tat anctre= tat le moins volu
  ChercheNombreNiveaux;
  for n:=0 to Nombreniveaux-1 do
    begin
      for i:=0 to Length(Branches)-1 do
        begin
          UneBranche:=Branches[i];
          If (UneBranche<>Nil) and (UneBranche.Niveau=n) then
            begin
              UneBranche.Portrait.Clear;
              UneBranche.EstUnGroupeMonoPhyl:=False;
              if UneBranche.EstUnTaxon then
                begin
                  ConstruitPortraitTaxon(UneBranche);
                end
              else
                begin
                  ConstruitPortraitCaminSokal(UneBranche);
                end;
            end;
        end;
    end;
  VerifieMonoPhyletisme(True);
end;
Procedure TArbreDate.ConstruitPortraitCaminSokal(UneBranche:TBranche);
Var                               //m. de CaminSokal (convergences seules acceptes)
  i:integer;
  NomCar:string;
begin
  UneBranche.CaracteresDExcl.Clear;
  UneBranche.EtatsDExcl.Clear;
  For i:=0 to ListeCaracteres.Count-1 do
    begin
      NomCar:=ListeCaracteres[i];
      ConstruitAttributCaminSokal(UneBranche,NomCar);
    end;
end;
Procedure TArbreDate.ConstruitAttributCaminSokal(UneBranche:TBranche;NomCar:string);
Var                               //methode=1 : m. deCaminSokal(convergences seules acceptes)
  j:integer;
  UnAttribut,NvAttribut:TAttribut;
  UnCarD:TCaractD;
begin
  UnAttribut.Caractere:=NomCar;
  UnAttribut.Statut:=1;
  UnCarD:=LaSouscollection.LeCarD(NomCar);
  If UnCarD<>Nil then
    UnAttribut.Etat:=UnCarD.ListeEtats[0]
  else exit;//UnAttribut.Etat:='';
  UnAttribut.Statut:=0;
  if Length(UneBranche.Descendants)>0 then
    begin
      UnAttribut:=UneBranche.Descendants[0].Portrait.AttributDe(NomCar);
      if UnAttribut.NumEtat>0 then
        begin
          For j:=1 to length(UneBranche.Descendants)-1 do
            begin
              NvAttribut:=UneBranche.Descendants[j].Portrait.AttributDe(NomCar);
              if (UnAttribut.Statut=1)or(NvAttribut.NumEtat<UnAttribut.NumEtat) then
                UnAttribut:=NvAttribut;
            end;
          UnAttribut.Statut:=LaSousCollection.VerifStatutDe(NomCar,UnAttribut.NumEtat,UnAttribut.Statut);
        end;
      UneBranche.Portrait.Add(UnAttribut);
    end;
  //Si Statut=2, vrifier si monophyltique ? ou vrification finale

end;

Procedure TArbreDate.ConstruitPortraitsDollo; //pas de convergence : tat ancetre= tat volu si un des descendants possde cet tat de manire non exclusive
begin
  // tat ancetre= tat volu si un des descendants possde cet tat de manire non exclusive
end;
// troisime version qui favorise moins les tats primitifs en utilisant le statut 1 (au lieu du ?) ncessite une relecture finale
Procedure TArbreDate.ConstruitAttributWagner(UneBranche:TBranche;NomCar:string);
Var                               //methode=0 : m. de Wagner (rversions et convergences acceptes)
  i,j,k,ik,max,nbA,n:integer;
  PEtat,Etat,EtatTest:string;
  Numetat,PNumEtat,Statut:integer;
  LesAttributs:Array of TAttribut;
  LesCoeffs:Array of integer;
  UnAttribut,NvAttribut:TAttribut;
  ListeDescendants:TStringList;
  UnCarD:TCaractD;
  Ajouter:Boolean;
  kmini,kmax:integer;
begin
  ListeDescendants:=TStringList.Create;
  ListeDescendants.CommaText:=UneBranche.TaxonsDescendants;
  SetLength(LesAttributs,0);
  SetLength(LesCoeffs,0);
  UnAttribut.Caractere:=NomCar;
  UnAttribut.Statut:=1;
  UnCarD:=LaSouscollection.LeCarD(NomCar);
  kmini:=0;
  If UnCarD<>Nil then
    UnAttribut.Etat:=UnCarD.ListeEtats[0]
  else exit;//UnAttribut.Etat:='';
  UnAttribut.Statut:=0;
  For j:=0 to length(UneBranche.Descendants)-1 do
    begin
      UnAttribut:=UneBranche.Descendants[j].Portrait.AttributDe(NomCar);
      if Length(LesAttributs)=0 then
        begin
          if (UnAttribut.Etat<>'?') and (UnAttribut.Etat<>'') then
            begin
              SetLength(LesAttributs,1);
              LesAttributs[0]:=UnAttribut;
              SetLength(LesCoeffs,1);
              LesCoeffs[0]:=1;
              kmini:=0;
            end;
        end
      else if (UnAttribut.Etat<>'?') and (UnAttribut.Etat<>'') then
        begin
          nbA:=Length(LesAttributs);
          Ajouter:=True;
          for k:=0 to nbA-1 do
            begin
              if UnAttribut.NumEtat=LesAttributs[k].NumEtat then
                begin
                  LesCoeffs[k]:=LesCoeffs[k]+1;//inc(LesCoeffs[k]);
                  Ajouter:=False;
                  break;
                end;
            end;
          if Ajouter then
            begin
              SetLength(LesAttributs,nbA+1);
              LesAttributs[nbA]:=UnAttribut;
              SetLength(LesCoeffs,nbA+1);
              LesCoeffs[nbA]:=1;
              if UnAttribut.Numetat<LesAttributs[kmini].NumEtat then
                kmini:=Length(LesAttributs)-1;
            end;
        end;
    end;
  if Length(LesAttributs)>0 then
    UnAttribut:=LesAttributs[0];

  if Length(LesCoeffs)<2 then
    begin
      If (UnAttribut.NumEtat>0)and(UnAttribut.Etat<>'?') and (UnAttribut.Etat<>'') then
        begin
          UnAttribut.Statut:=3;
           //vrifier l'exclusivit sinon redescendre  2
           //ou fait   la fin
          for k:=0 to ListeCompleteTaxons.Count-1 do
            begin
              if (ListeDescendants.IndexOf(ListeCompleteTaxons[k])=-1) then
                begin
                  EtatTest:=LaSousCollection.EtatDe(ListeCompleteTaxons[k],NomCar,NumEtat);
                  if (EtatTest<>'')and(EtatTest<>'?') then
                     begin
                        UnCarD:=LaSousCollection.LeCarD(NomCar);
                        if UnCarD<>Nil then
                          begin
                            if (EtatTest=UnAttribut.Etat)or((Numetat>UnAttribut.NumEtat)and(UnCarD.TypeCarD=1))then
                              begin
                                UnAttribut.Statut:=2;
                                break;
                              end;
                          end;
                     end;
                end;
            end;
        end
      else if UnAttribut.NumEtat=0 then
        UnAttribut.Statut:=0
      else
        UnAttribut.Statut:=1;
      if UnAttribut.Statut=3 then
        begin
          UneBranche.EstUnGroupeMonoPhyl:=True;
          UneBranche.CaracteresDExcl.Add(UnAttribut.Caractere);
          UneBranche.EtatsDExcl.Add(UnAttribut.Etat);
        end;
    end
  else
    begin
      //Inc(LesCoeffs[kmini]);
      max:=LesCoeffs[0];
      kmax:=0;
      for k:=1 to Length(LesCoeffs)-1 do
        begin
          if LesCoeffs[k]>max then
            begin
              if (UnAttribut.NumEtat<LesAttributs[k].NumEtat) and (LesCoeffs[k]=max+1) then
                LesAttributs[k].Statut:=1;
              UnAttribut:=LesAttributs[k];
              max:=LesCoeffs[k];
              //vrifier si cart=1 et NumCar plus petit dans ce cas passer le statut  1
            end
          else if LesCoeffs[k]=max then
            begin
              UnAttribut.Caractere:=NomCar;
              if UnCarD.TypeCarD=0 then
                UnAttribut.Etat:='?'
              else if LesAttributs[kmax].NumEtat<LesAttributs[k].NumEtat then
                UnAttribut:=LesAttributs[kmax];
              UnAttribut.Statut:=1;//incertain
              if LesAttributs[k].NumEtat<UnAttribut.NumEtat then
                begin
                  UnAttribut.NumEtat:=LesAttributs[k].NumEtat;
                  UnAttribut.Etat:=LesAttributs[k].Etat;
                end;
              //if LesAttributs[k].NumEtat<UnAttribut.NumEtat then
                //UnAttribut:=LesAttributs[k];
            end
          else if (LesCoeffs[k]=max-1)and (LesAttributs[k].NumEtat<UnAttribut.NumEtat) then
            begin
              UnAttribut.Statut:=1;
            end;
        end;
    end;
  if (UnAttribut.Etat='') or (UnAttribut.Etat='?') then
    begin
      UnAttribut.Etat:='?';
      UnAttribut.Statut:=1;
    end
  else if UnAttribut.NumEtat=0 then
    UnAttribut.Statut:=0
  else
    begin
      UnAttribut.Statut:=LaSousCollection.VerifStatutDe(NomCar,UnAttribut.NumEtat,UnAttribut.Statut);
      //UnAttribut.Statut:=2;
    end;
  UneBranche.Portrait.Add(UnAttribut);

  ListeDescendants.Free;
end;

{
// deuxime version qui favorise moins les tats primitifs en utilisant les ? ncessite une relecture finale
Procedure TArbreDate.ConstruitAttributWagner(UneBranche:TBranche;NomCar:string);
Var                               //methode=0 : m. de Wagner (rversions et convergences acceptes)
  i,j,k,ik,max,nbA:integer;
  PEtat,Etat:string;
  Numetat,PNumEtat,Statut:integer;
  LesAttributs:Array of TAttribut;
  LesCoeffs:Array of integer;
  UnAttribut,NvAttribut:TAttribut;
  ListeDescendants:TStringList;
  UnCarD:TCaractD;
  Ajouter:Boolean;
  kmini:integer;
begin
  ListeDescendants:=TStringList.Create;
  ListeDescendants.CommaText:=UneBranche.TaxonsDescendants;
  SetLength(LesAttributs,0);
  SetLength(LesCoeffs,0);
  UnAttribut.Caractere:=NomCar;
  UnAttribut.Statut:=1;
  UnCarD:=LaSouscollection.LeCarD(NomCar);
  kmini:=0;
  If UnCarD<>Nil then
    UnAttribut.Etat:=UnCarD.ListeEtats[0]
  else exit;//UnAttribut.Etat:='';
  UnAttribut.Statut:=0;
  For j:=0 to length(UneBranche.Descendants)-1 do
    begin
      UnAttribut:=UneBranche.Descendants[j].Portrait.AttributDe(NomCar);
      if Length(LesAttributs)=0 then
        begin
          if (UnAttribut.Etat<>'?') and (UnAttribut.Etat<>'') then
            begin
              SetLength(LesAttributs,1);
              LesAttributs[0]:=UnAttribut;
              SetLength(LesCoeffs,1);
              LesCoeffs[0]:=1;
              kmini:=0;
            end;
        end
      else if (UnAttribut.Etat<>'?') and (UnAttribut.Etat<>'') then
        begin
          nbA:=Length(LesAttributs);
          Ajouter:=True;
          for k:=0 to nbA-1 do
            begin
              if UnAttribut.NumEtat=LesAttributs[k].NumEtat then
                begin
                  LesCoeffs[k]:=LesCoeffs[k]+1;//inc(LesCoeffs[k]);
                  Ajouter:=False;
                  break;
                end;
            end;
          if Ajouter then
            begin
              SetLength(LesAttributs,nbA+1);
              LesAttributs[nbA]:=UnAttribut;
              SetLength(LesCoeffs,nbA+1);
              LesCoeffs[nbA]:=1;
              if UnAttribut.Numetat<LesAttributs[kmini].NumEtat then
                kmini:=Length(LesAttributs)-1;
            end;
        end;
    end;
  if Length(LesAttributs)>0 then
    UnAttribut:=LesAttributs[0];

  if Length(LesCoeffs)<2 then
    begin
      If (UnAttribut.NumEtat>0)and(UnAttribut.Etat<>'?') and (UnAttribut.Etat<>'') then
        begin
          UnAttribut.Statut:=3;
           //vrifier l'exclusivit sinon redescendre  2
          for k:=0 to ListeCompleteTaxons.Count-1 do
            begin
              if (ListeDescendants.IndexOf(ListeCompleteTaxons[k])=-1)
                and (LaSousCollection.EtatDe(ListeCompleteTaxons[k],NomCar,NumEtat)=UnAttribut.Etat) then
                begin
                  UnAttribut.Statut:=2;
                  break;
                end;
            end;
        end
      else if UnAttribut.NumEtat=0 then
        UnAttribut.Statut:=0
      else
        UnAttribut.Statut:=1;
      if UnAttribut.Statut=3 then
        begin
          UneBranche.EstUnGroupeMonoPhyl:=True;
          UneBranche.CaracteresDExcl.Add(UnAttribut.Caractere);
          UneBranche.EtatsDExcl.Add(UnAttribut.Etat);
        end;
    end
  else
    begin
      //Inc(LesCoeffs[kmini]);
      max:=LesCoeffs[0];
      for k:=1 to Length(LesCoeffs)-1 do
        begin
          if LesCoeffs[k]>max then
            begin
              UnAttribut:=LesAttributs[k];
              max:=LesCoeffs[k];
            end
          else if LesCoeffs[k]=max then
            begin
              UnAttribut.Caractere:=NomCar;
              UnAttribut.Etat:='?';
              UnAttribut.Statut:=1;//incertain
              if LesAttributs[k].NumEtat<UnAttribut.NumEtat then
                UnAttribut.NumEtat:=LesAttributs[k].NumEtat;
              //if LesAttributs[k].NumEtat<UnAttribut.NumEtat then
                //UnAttribut:=LesAttributs[k];
            end;
        end;
    end;
  if (UnAttribut.Etat='') or (UnAttribut.Etat='?') then
    begin
      UnAttribut.Etat:='?';
      UnAttribut.Statut:=1;
    end
  else if UnAttribut.NumEtat=0 then
    UnAttribut.Statut:=0
  else
    begin
      //UnAttribut.Statut:=2;
    end;
  UneBranche.Portrait.Add(UnAttribut);

  ListeDescendants.Free;
end;
}
// ancienne version qui favorise trop les tats primitifs utiliser plus les ? avant relecture finale
{Procedure TArbreDate.ConstruitAttributWagner(UneBranche:TBranche;NomCar:string);
Var                               //methode=0 : m. de Wagner (rversions et convergences acceptes)
  i,j,k,ik,max,nbA:integer;
  PEtat,Etat:string;
  Numetat,PNumEtat,Statut:integer;
  LesAttributs:Array of TAttribut;
  LesCoeffs:Array of integer;
  UnAttribut,NvAttribut:TAttribut;
  ListeDescendants:TStringList;
  UnCarD:TCaractD;
  Ajouter:Boolean;
  kmini:integer;
begin
  ListeDescendants:=TStringList.Create;
  ListeDescendants.CommaText:=UneBranche.TaxonsDescendants;
  SetLength(LesAttributs,0);
  SetLength(LesCoeffs,0);
  UnAttribut.Caractere:=NomCar;
  UnCarD:=LaSouscollection.LeCarD(NomCar);
  kmini:=0;
  If UnCarD<>Nil then
    UnAttribut.Etat:=UnCarD.ListeEtats[0]
  else exit;//UnAttribut.Etat:='';
  UnAttribut.Statut:=0;
  For j:=0 to length(UneBranche.Descendants)-1 do
    begin
      UnAttribut:=UneBranche.Descendants[j].Portrait.AttributDe(NomCar);
      if Length(LesAttributs)=0 then
        begin
          if (UnAttribut.Etat<>'?') and (UnAttribut.Etat<>'') then
            begin
              SetLength(LesAttributs,1);
              LesAttributs[0]:=UnAttribut;
              SetLength(LesCoeffs,1);
              LesCoeffs[0]:=1;
              kmini:=0;
            end;
        end
      else
        begin
          nbA:=Length(LesAttributs);
          for k:=0 to nbA-1 do
            begin
              if UnAttribut.NumEtat=LesAttributs[k].NumEtat then
                begin
                  LesCoeffs[k]:=LesCoeffs[k]+1;//inc(LesCoeffs[k]);
                end
              else if (UnAttribut.Etat<>'?') and (UnAttribut.Etat<>'') then
                begin
                  SetLength(LesAttributs,nbA+1);
                  LesAttributs[nbA]:=UnAttribut;
                  SetLength(LesCoeffs,nbA+1);
                  LesCoeffs[nbA]:=1;
                  if UnAttribut.Numetat<LesAttributs[kmini].NumEtat then
                    kmini:=Length(LesAttributs)-1;
                end;
            end;
        end;
    end;
  if Length(LesAttributs)>0 then
    UnAttribut:=LesAttributs[0];

  if Length(LesCoeffs)<2 then
    begin
      If (UnAttribut.NumEtat>0)and(UnAttribut.Etat<>'?') and (UnAttribut.Etat<>'') then
        begin
          UnAttribut.Statut:=3;
           //vrifier l'exclusivit sinon redescendre  2
          for k:=0 to ListeCompleteTaxons.Count-1 do
            begin
              if (ListeDescendants.IndexOf(ListeCompleteTaxons[k])=-1)
                and (LaSousCollection.EtatDe(ListeCompleteTaxons[k],NomCar,NumEtat)=UnAttribut.Etat) then
                begin
                  UnAttribut.Statut:=2;
                  break;
                end;
            end;
        end
      else if UnAttribut.NumEtat=0 then
        UnAttribut.Statut:=0
      else
        UnAttribut.Statut:=1;
      if UnAttribut.Statut=3 then
        begin
          UneBranche.EstUnGroupeMonoPhyl:=True;
          UneBranche.CaracteresDExcl.Add(UnAttribut.Caractere);
          UneBranche.EtatsDExcl.Add(UnAttribut.Etat);
        end;
    end
  else
    begin
      Inc(LesCoeffs[kmini]);
      max:=LesCoeffs[0];
      for k:=1 to Length(LesCoeffs)-1 do
        begin
          if LesCoeffs[k]>max then
            begin
              UnAttribut:=LesAttributs[k];
              max:=LesCoeffs[k];
            end
          else if LesCoeffs[k]=max then
            begin
              if LesAttributs[k].NumEtat<UnAttribut.NumEtat then
                UnAttribut:=LesAttributs[k];
            end;
        end;
    end;
  if (UnAttribut.Etat='') or (UnAttribut.Etat='?') then
    begin
      UnAttribut.Etat:='?';
      UnAttribut.Statut:=1;
    end
  else if UnAttribut.NumEtat=0 then
    UnAttribut.Statut:=0
  else
    begin
      //UnAttribut.Statut:=2;
    end;
  UneBranche.Portrait.Add(UnAttribut);

  ListeDescendants.Free;
end;
}
Procedure TArbreDate.ConstruitPortraitWagner(UneBranche:TBranche);
Var                               //m. de Wagner (rversions et convergences acceptes)
  i:integer;  //,j,k,max
  NomCar:string;
  //PEtat,Etat:string;
  //Numetat,PNumEtat,Statut:integer;
  //ListeDescendants:TStringList;
begin
//  ListeDescendants:=TStringList.Create;
//  ListeDescendants.CommaText:=UneBranche.TaxonsDescendants;
  UneBranche.CaracteresDExcl.Clear;
  UneBranche.EtatsDExcl.Clear;

  For i:=0 to ListeCaracteres.Count-1 do
    begin
      NomCar:=ListeCaracteres[i];
      ConstruitAttributWagner(UneBranche,NomCar);
    end;

{  UneBranche.TracerBoite:=UneBranche.EstUnGroupeMonoPhyl;
  if UneBranche.Ancetre<>Nil then
    begin
      if UneBranche.EstUnGroupeMonoPhyl then
        UneBranche.Ancetre.Couleur:=CouleurAncetre
      else
        UneBranche.Ancetre.Couleur:=CouleurErreur;
    end;
  }
 // ListeDescendants.Free;
end;

procedure TArbreDate.ConstruitPortraitsWagner; //dtermination des listes de caractres et d'tats
Var                               //m. de Wagner (rversions et convergences acceptes)
  i,n,j,k,nbd,mini,ki,kj:integer;
  UneBranche:TBranche;
  NomCar:string; //NomTaxon,
  //PEtat,Etat:string;
  //Numetat,PNumEtat,Statut:integer;
  //LesAttributs:Array of TAttribut;
  //LesCoeffs:Array of integer;
  UnAttribut,AttributDesc,AttributAncetre:TAttribut;
 // ListeDescendants:TStringList;
  //Statut:= 0:primitif, 1:indtermin, 2:driv non exclusif,  3:driv exclusif
begin
  ChercheNombreNiveaux;
  for n:=0 to Nombreniveaux-1 do
    begin
      for i:=0 to Length(Branches)-1 do
        begin
          UneBranche:=Branches[i];
          If (UneBranche<>Nil) and (UneBranche.Niveau=n) then
            begin
              UneBranche.Portrait.Clear;
              UneBranche.EstUnGroupeMonoPhyl:=False;
              if UneBranche.EstUnTaxon then
                begin
                  ConstruitPortraitTaxon(UneBranche);
                end
              else
                begin
                  ConstruitPortraitWagner(UneBranche);
                end;
            end;
        end;
    end;
    //Faire une vrification qui remplace statuts de type 1 (incertain) sauf si tous les descendants sont ?
  for n:=Nombreniveaux-1 downto 1 do
    begin
      for i:=0 to Length(Branches)-1 do
        begin
          UneBranche:=Branches[i];
          If (UneBranche<>Nil) and (UneBranche.Niveau=n) then
            begin
              For j:=0 to ListeCaracteres.Count-1 do
                begin
                  NomCar:=ListeCaracteres[j];
                  UnAttribut:=UneBranche.Portrait.AttributDe(NomCar);
                  if UnAttribut.Statut=1 then
                    begin
                      nbd:=Length(UneBranche.Descendants);
                      if (nbd>0) then
                        begin
                          AttributDesc.NumEtat:=50000;
                          for k:=0 to nbd-1 do
                            if (UneBranche.Descendants[k].Portrait.AttributDe(Nomcar).Statut<>1) and
                              (UneBranche.Descendants[k].Portrait.AttributDe(Nomcar).NumEtat<AttributDesc.NumEtat) then
                              begin
                                AttributDesc:=UneBranche.Descendants[k].Portrait.AttributDe(Nomcar);
                              end;
                          if AttributDesc.NumEtat<50000 then
                            begin
                              UneBranche.Portrait.Retire(NomCar);
                              if (UneBranche.AncetreDirect=Nil)  then
                                begin
                                  UneBranche.Portrait.Add(AttributDesc);
                                 { //vrifier aussi le monophyltisme
                                  AttributDesc.Statut:=3;
                                  UneBranche.EstUnGroupeMonoPhyl:=True;
                                  For ki:=0 to Length(Branches)-1 do
                                    begin
                                      if (Branches[i]<>Nil) and (Branches[i].EstUnTaxon)and (Not Branches[i].EstDescendantDe(UneBranche)) then
                                        begin
                                          if Branches[i].Portrait.NumeroEtat(NomCar)>=AttributDesc.NumEtat then
                                            begin
                                              AttributDesc.Statut:=2;
                                              UneBranche.EstUnGroupeMonoPhyl:=False;
                                              break;
                                            end;
                                        end;
                                    end;
                                  }
                                end
                              else if (UneBranche.AncetreDirect.Portrait.AttributDe(NomCar).NumEtat<AttributDesc.NumEtat) then
                                begin
                                  UneBranche.Portrait.Add(AttributDesc);
                                end
                              else
                                begin
                                  UnAttribut:=UneBranche.AncetreDirect.Portrait.AttributDe(NomCar);
                                  if UnAttribut.Statut=3 then
                                    UnAttribut.Statut:=2;
                                  UneBranche.Portrait.Add(UnAttribut);
                                end;
                            end;

                        end;
                    end;
                end;
            end;
        end;
    end;
  VerifieMonoPhyletisme(False);
end;
procedure TArbreDate.ColoreSuivantEtats(Nomcar:string;ListeCouleurs: Array of TColor);
Var
  i,n,p:integer;
  UneBranche:TBranche;
  UnAttribut:TAttribut;
begin
  CouleurTraitRacine:=Color32(ListeCouleurs[1]);
  For i:=0 to Length(Branches)-1 do
    begin
      UneBranche:=Branches[i];
      If UneBranche<>Nil then
        begin
          UnAttribut:=UneBranche.Portrait.AttributDe(NomCar);
          p:=UnAttribut.Statut;
          if p<2 then
            UneBranche.CouleurTrait:=Color32(ListeCouleurs[1-p])
          else
            begin
              UneBranche.CouleurTrait:=Color32(ListeCouleurs[UnAttribut.NumEtat+1]);
            end;
          if UneBranche.EstUnGroupeMonoPhyl and (UneBranche.Ancetre<>Nil) then
            begin
              UneBranche.Ancetre.Couleur:=UneBranche.CouleurTrait;
            end;
        end;
    end;
end;
procedure TraceCercleSur(Bitmap:TBitMap32;Xcentre,YCentre,rayon:integer;Couleur,CouleurContour:TColor32);
Var
  i,j,X,Y:integer;
  nombre:integer;
  angle:single;
  Coul:TColor32;
begin
  Coul:=Couleur;
  for i:=0 to rayon do
    begin
      nombre:=(1+2*i)*(1+2*i);
      for j:=0 to nombre-1 do
        begin
          angle:=2*pi/nombre*j;
          X:=XCentre+round(rayon*cos(angle));
          Y:=YCentre+round(rayon*sin(angle));
          if i=rayon then Coul:=CouleurContour;
          Bitmap.PixelS[X,Y]:=Coul;
        end;
    end;
end;
procedure TArbreDate.ColoreBoitesParDefaut;
Var
  i,n,nbc:integer;
  UneBranche:TBranche;
begin
  InitCouleursCaractDBoites;
  nbc:=Length(CouleursCaractDBoites);
  n:=0;
  For i:=0 to Length(Branches)-1 do
    begin
      UneBranche:=Branches[i];
      if (UneBranche<>Nil) and UneBranche.TracerBoite then
        begin
          UneBranche.CouleurBoite:=Color32(CouleursCaractDBoites[n mod nbc]);
          inc(n);
        end;
    end;
end;
Function TArbreDate.NomDeNumeroGroupe(X,Y:integer):String;
Var
  i:integer;
  UneBranche:TBranche;
begin
  Result:='';
  if DessinerBoites and AfficherNomsGroupes then
    begin
      For i:=0 to Length(Branches)-1 do
        begin
          UneBranche:=Branches[i];
          if (UneBranche<>Nil)and(UneBranche.NumeroGroupe>-1) then
            begin
              if (X>=UneBranche.PositionNumero.Left)and(X<=UneBranche.PositionNumero.Right) and
                 (Y>=UneBranche.PositionNumero.Top)and(Y<=UneBranche.PositionNumero.Bottom) then
                begin
                  Result:=IntToStr(UneBranche.NumeroGroupe)+' : ';
                  if (UneBranche.NomGroupe<>'') then
                    Result:=Result+UneBranche.NomGroupe
                  else
                    Result:=Result+StrGroupeNonNomme;
                end;
            end;
        end;
    end;
end;
Function TArbreDate.AncetreDuGroupeANommer(X,Y:integer):TBranche;
Var
  i:integer;
  UneBranche:TBranche;
begin
  Result:=Nil;
  if DessinerBoites and AfficherNomsGroupes then
    begin
      For i:=0 to Length(Branches)-1 do
        begin
          UneBranche:=Branches[i];
          if (UneBranche.EstUnGroupeMonoPhyl or UneBranche.TracerBoite)and (UneBranche.NomGroupe='') then
            begin
              if (X>=UneBranche.PositionEtiqGroupe.Left)and(X<=UneBranche.PositionEtiqGroupe.Right) and
                 (Y>=UneBranche.PositionEtiqGroupe.Top)and(Y<=UneBranche.PositionEtiqGroupe.Bottom) then
                begin
                  Result:=UneBranche;
                  Exit;
                end;
            end;
        end;
    end;
end;

Function TArbreDate.RegroupeTout:TBranche;
Var
  i,j,k,p,n:integer;
  UneBranche,LaBrancheS:TBranche;
  UneRacine:TBranche;
begin
  Result:=Nil;
  UneRacine:=Nil;
  ConstruitListeTaxons;
  if ListeCompleteTaxons.Count<2 then
    exit;
  i:=0;
  While i<Length(Branches) do
    begin
      LaBrancheS:=Branches[i];
      if (LaBrancheS<>Nil) and (Not LaBrancheS.EstUnTaxon) then
        begin
          if (UneRacine=Nil) and (LaBrancheS.AncetreDirect=Nil) then
            begin
              UneRacine:=LaBrancheS;
              inc(i);
            end
          else
            begin
              SetLength(LaBrancheS.Descendants,0);
              p:=Length(Branches)-1;
              For j:=i to p-1 do
                Branches[j]:=Branches[j+1];
              SetLength(Branches,p);
              if LaBrancheS<>Nil then LaBrancheS.Free;
            end;
        end
      else
        inc(i);
    end;
  If UneRacine = Nil then
    begin
      UneRacine:=TBranche.CreateBranche(Self);
      UneRacine.AncetreDirect:=Nil;
      p:=Length(Branches);
      SetLength(Branches,p+1);
      Branches[p]:=UneRacine;
    end;
  UneRacine.Nom:='Anctre racine';
  UneRacine.NomGroupe:='';
  SetLength(UneRacine.Descendants,0);
  For i:=0 to Length(Branches)-1 do
    if Branches[i]<>UneRacine then
      begin
        Branches[i].AncetreDirect:=UneRacine;
        n:=Length(UneRacine.Descendants);
        SetLength(UneRacine.Descendants,n+1);
        UneRacine.Descendants[n]:=Branches[i];
      end;
  //RazCouleurs;
  ReclasseBranches;
  ConstruitPortraits(MethodeParci);
  Redessine;
  Result:=UneRacine;
end;
Procedure TArbreDate.AjouteAncetreArbreDateBrancheTermGroupe;
Var
  i,j,p:integer;
  BrAncetre,UneBranche,NvAncetre:TBranche;
begin
  for i:=0 to Length(Branches)-1 do
    begin
      if Branches[i]<>Nil then
        begin
          UneBranche:=Branches[i];
          if UneBranche.EstUnTaxon and UneBranche.TracerBoite then
            begin
              NvAncetre:=TBranche.CreateBranche(Self);
              NvAncetre.AncetreDirect:=UneBranche.AncetreDirect;
              NvAncetre.NomGroupe:=UneBranche.NomGroupe;
              if NvAncetre.NomGroupe='' then
                NvAncetre.Nom:='Anctre du groupe de '+UneBranche.Nom
              else
                NvAncetre.Nom:='Anctre des '+NvAncetre.NomGroupe;
              SetLength(NvAncetre.Descendants,1);
              NvAncetre.Descendants[0]:=UneBranche;
              UneBranche.TracerBoite:=False;
              UneBranche.EstUnGroupeMonoPhyl:=False;
              UneBranche.AncetreDirect:=NvAncetre;
              if NvAncetre.AncetreDirect<>Nil then
                begin
                  for j:=0 to Length(NvAncetre.AncetreDirect.Descendants)-1 do
                    if NvAncetre.AncetreDirect.Descendants[j]=UneBranche then
                      begin
                        NvAncetre.AncetreDirect.Descendants[j]:=NvAncetre;
                        Break;
                      end;
                end;
              p:=Length(Branches);
              SetLength(Branches,p+1);
              Branches[p]:=NvAncetre;
            end;
        end;
    end;
end;
procedure TArbreDate.VerifieMonoPhyletisme(Tout:Boolean); //si tout= false ne pas vrifier les taxons
Var
  i,j,k:integer;
  UneBranche:TBranche;
  NomCar,EtatRef,NomTaxon,EtatRefNorm,Etat:string;
  UnAttribut:TAttribut;
  NumEtatRef,NumEtat,Statut:integer;
  Monophyl:Boolean;
  ListeTaxonsDescendants:TStringList;
  TypeCard:integer;
  
begin
  // les Portraits ont t calculs avant
  ListeTaxonsDescendants:=TStringList.Create;
  for i:=0 to Length(Branches)-1 do
    begin
      UneBranche:=Branches[i];
      if (UneBranche<>Nil) and (Tout or (Not UneBranche.EstUnTaxon)) then
        begin
          UneBranche.EstUnGroupeMonoPhyl:=False;
          ListeTaxonsDescendants.CommaText:=UneBranche.TaxonsDescendants;
          UneBranche.CaracteresDExcl.Clear;
          UneBranche.EtatsDExcl.Clear;
          For j:=0 to ListeCaracteres.Count-1 do
            begin
              NomCar:=ListeCaracteres[j];
              TypeCarD:=LaSousCollection.LeTypeCarD(NomCar);
              if TypeCarD>=0 then
                begin
                  EtatRef:=UneBranche.Portrait.Etat(NomCar);
                  NumEtatRef:=UneBranche.Portrait.NumeroEtat(NomCar);
                  EtatRefNorm:=LaSousCollection.NomEtat(NomCar,NumEtatRef);
                  Statut:=UneBranche.Portrait.Statut(NomCar);
                  if EtatRef<>EtatRefNorm then
                    begin
                      {MessageDlg('Erreur de numrotation d''tat chez '+UneBranche.Nom+' Caractre '+NomCar+' Etat '+EtatRef+ 'numro '+IntToStr(NumEtatRef),
                          mtError,[mbOK],0);}
                      //Statut:=UneBranche.Portrait.Statut(NomCar);
                      UneBranche.ChangePortrait(NomCar,EtatRefNorm,NumEtatRef,3);
                    end;
                  if (NumEtatRef>0)and(EtatRef<>'')and(EtatRef<>'?')and(Statut<>0) then
                    begin

                      Monophyl:=True;
                      //vrifier que tous les taxons descendants portent le mme tat driv du Caractre
                      // ou un tat driv de rang sup (et type 1) ou ? ou ''
                      for k:=0 to ListeTaxonsDescendants.Count-1 do
                        begin
                          NomTaxon:=ListeTaxonsDescendants[k];
                          Etat:=LaSousCollection.EtatDe(NomTaxon,NomCar,NumEtat);
                          if ((TypeCarD=0)and(Numetat<>NumEtatRef)and(Etat<>'')and(Etat<>'?'))or((TypeCarD=1)and(Numetat<NumEtatRef)and(Etat<>'')) then
                            begin
                              //pas monophyl pour ce caractre
                              Monophyl:=False;
                              Break;
                            end;
                        end;

                      //Vrifier qu'aucun autre taxon ne porte cet tat driv du caractre ni un tat qui en drive
                      if Monophyl then
                        begin
                          for k:=0 to ListeCompleteTaxons.Count-1 do
                            begin
                              NomTaxon:=ListeCompleteTaxons[k];
                              if (NomTaxon <>UneBranche.Nom) and (ListeTaxonsDescendants.IndexOf(NomTaxon)=-1) then
                                begin
                                  Etat:=LaSousCollection.EtatDe(NomTaxon,NomCar,NumEtat);
                                  if (NumEtat>0)and(Etat<>'')and(Etat<>'?')and (((TypeCarD=0)and(Numetat=NumEtatRef))or((TypeCarD=1)and(Numetat>=NumEtatRef))) then
                                    begin
                                      //pas monophyl pour ce caractre
                                      Monophyl:=False;
                                      Break;
                                    end;
                                end;
                            end;
                          if Monophyl then
                            begin
                              UneBranche.EstUnGroupeMonoPhyl:=True;
                              //Mettre  jour le statut de l'attribut pour le caractre
                              UneBranche.ChangePortrait(NomCar,EtatRef,NumEtatRef,3);
                              //Ajouter  la liste des caractresD Monophyltiques
                              UneBranche.CaracteresDExcl.Add(NomCar);
                              UneBranche.EtatsDExcl.Add(EtatRef);
                            end;
                        end;
                    end;
                end;
            end;
          UneBranche.TracerBoite:=UneBranche.EstUnGroupeMonoPhyl;
          if UneBranche.Ancetre<>Nil then
            begin
              if UneBranche.EstUnGroupeMonoPhyl then
                UneBranche.Ancetre.Couleur:=CouleurAncetre
              else
                UneBranche.Ancetre.Couleur:=CouleurErreur;
            end;
        end;
    end;
  ListeTaxonsDescendants.Free;
end;
procedure TArbreDate.VerifieAncetreRacine;
Var
  i:integer;
  UneBranche:TBranche;
Begin
  For i:=Length(Branches)-1 downto 0 do
    begin
    UneBranche:=Branches[i];
      if (UneBranche<>Nil) then
        if (pos('Anctre',UneBranche.Nom)>0)and (Length(UneBranche.Descendants)=0) then
          begin
            SupprimeBranche(UneBranche);
          end;
    end;
end;
function TArbreDate.RazParentes(ListeTax:TStringList):Boolean;
Var
  i,j:integer;
  UneBranche:TBranche;
Begin
  Result:=False;
  For i:=Length(Branches)-1 downto 0 do
    begin
      UneBranche:=Branches[i];
      if (UneBranche<>Nil) and (Length(UneBranche.Descendants)=0)
         and (ListeTax.IndexOf(UneBranche.Nom)>-1) then
        begin
          UneBranche.AncetreDirect:=Nil;
          Result:=True;
        end
      else 
        begin
          For j:=i+1 to Length(Branches)-1 do
            Branches[j-1]:=Branches[j];
          SetLength(Branches,Length(Branches)-1);
          if UneBranche.Ancetre<>Nil then
            SupprimeLayer(UneBranche.Ancetre);
          if UneBranche.Curseurs<>Nil then
            SupprimeLayer(UneBranche.Curseurs);
          if (UneBranche<>Nil) then
            UneBranche.Free;
        end;
    end;
  NumeroAncetre:=0;
end;
procedure Register;
begin
  RegisterComponents('JFM', [TArbreDate]);
end;

end.
